//=============================================================================
//=============================================================================
// To execute: make demo-run
//
//=============================================================================
#include <stdlib.h>
#include <iostream.h>

//---------------------------------//
//    External fortran programs    //
//---------------------------------//
extern "C" void glib_init_();
extern "C" void glib_fini_();
//
#define KoralW koralw_
//>>> extern "C" void koralw_(const long&,const double*,const long*);
//
extern "C" void koralw_(const long&, double x[], long n[]);
//
extern "C" void korwan_(
  const double&, const double&, const double&,
  const    int&, const    int&, const double&, const double&);
//
extern "C" void lulist_(const long&);
//

//---------------------------------//
//    Common block from fortran    //
//---------------------------------//
struct {
  int   mstu[200];
  float paru[200];
  int   mstj[200];
  float parj[200];  } ludat1_ ;
//  

//-----------------------------------------------------------------------------
main()
{
   cout << "   |-------------------| \n" ;
   cout << "   |  Demo.C  Entering | \n" ;
   cout << "   |-------------------| \n" ;

   // Initialization of LUND //
   ludat1_.mstu[ 10 ] = 16;

   // Initialization of Glibk internal fortran library //
   glib_init_();

   // Initialisation input data
   // lenght 100+1 of xpar npar is not accident! see actual koralw calls
   long   mode;
   double xpar[101];
   long   npar[101];

   // =============================================================
   // Prepare the input parameters for KORALW
   // Note that indices in the matrices are shifted by one

   npar[1]=1;    // KeyRad = 1000*KeyCul +100*KeyNLL +10*KeyFSR +KeyISR  
   npar[2]=1011; // KeyPhy = 100000*KeyWu +10000*KeyRed +1000*KeySpn 
                 //                       +100*KeyZet +10*KeyMas +KeyBra  
   npar[3]=10;   // KeyTek = 10*KeyRnd +KeyWgt
   npar[4]=0;    // KeyMis = 100*KeyAcc +10*Key4f +KeyMix
   npar[5]=0;    // KEYDWM    W- decay: 7=[ev], 0=all ch.   
   npar[6]=0;    // KEYDWP    W+ decay: 7=[ev], 0=all ch.  
   npar[7]=16;   // NOUT      Output unit number, for Nout.LE.0, Nout=16
   npar[21]=0;   // JAK1      Decay mode tau+
   npar[22]=0;   // JAK2      Decay mode tau-
   npar[23]=1;   // ITDKRC    Bremsstrahlung switch in Tauola 
   npar[24]=1;   // IFPHOT    PHOTOS switch
   npar[25]=1;   // IFHADM    Hadronisation W-
   npar[26]=1;   // IFHADP    Hadronisation W+IFHADP

   xpar[1]=180e0;      // CMSENE CMS total energy  
   xpar[2]=1.16639e-5; // GFERMI Fermi Constant  
   xpar[3]=128.07e0;   // ALFWIN alpha QED at WW tresh. scale [inverse] 
   xpar[4]=91.1888e0;  // AMAZ   Z mass   
   xpar[5]=2.4974e0;   // GAMMZ  Z width      
   xpar[6]=80.230e0;   // AMAW   W mass 
   xpar[7]=-2.03e0;    // GAMMW  W with, For GAMMW<0 RECALCULATED inside progr.
   xpar[8]=1e-6;       // VVMIN  Photon spectrum parameter
   xpar[9]=0.99e0;     // VVMAX  Photon spectrum parameter
   xpar[10]=-1e0;      // WTMAX  max weight for reject. 
                       //        WTMAX<0 = default setting
   // ============== End of setting parameters ==============

/**************  KORALW initialisation   **************/
   // small trick on shift +1 of index in npar and xpar
   KoralW(-1,&xpar[1],&npar[1]);

/**************  KORALW event generation **************/
   for ( long i=0; i<1000; i++) {
     KoralW(0,&xpar[1],&npar[1]);
     int l =2;
     if(i < 10 ) lulist_(2);
       }
/**************  KORALW final printouts  **************/ 
   KoralW(1,&xpar[1],&npar[1]);

   double xsect = xpar[20];
   double ersect= xpar[21];
   cout << " KORALW: xsect  ="<<  xsect << "    ersect ="<< ersect << "\n" ;

/**************  KORWAN  **************/ 
   double svar = xpar[1]*xpar[1];
   int  keypho=302; 
   int  keyacc=1;
   double Xtot2e,errabs;
   korwan_(svar,0e0,1e0,keypho,keyacc,Xtot2e,errabs);
   cout << " KORWAN: xsect  ="<< Xtot2e << "    ersect ="<< errabs << "\n" ;


   // check on length of various types
   cout << " ==================test================" << endl ;
   cout << " type   int : \t  " << sizeof(  int) << endl ;
   cout << " type short : \t  " << sizeof(short) << endl ;
   cout << " type  long : \t  " << sizeof( long) << endl ;
   cout << " type       float : \t  " << sizeof(      float) << endl ;
   cout << " type      double : \t  " << sizeof(     double) << endl ;
   cout << " type long double : \t  " << sizeof(long double) << endl ;
   cout << " ======================================" << endl ;

   cout << "   |-------------------| \n" ;
   cout << "   |  Demo.C  Exiting  | \n" ;
   cout << "   |-------------------| \n" ;

   // Closing output
   glib_fini_();

}
//-----------------------------------------------------------------------------
