//=============================================================================
//=============================================================================
// To execute: make demo2-run
//
//=============================================================================
#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>
#include "koralw.h"
#include "event_lu.h"


void fill_param( double xpar[], long npar[] );

/*****************************************************************************/
main()
{
   cout << "   |--------------------| \n" ;
   cout << "   |  Demo2.C  Entering | \n" ;
   cout << "   |--------------------| \n" ;

/**************  Lund parameters  **************/
   event_lu::initialization();

/**************  KORALW initialisation   **************/
   double xpar[101];
   long   npar[101];
   fill_param( xpar, npar );
   koralw::initialize( xpar, npar );

/**************  KORALW event generation **************/
   for ( long i=0; i<2; i++) {
     koralw kw_event;
     event_lu current_event;
     if(i < 10 ) 
       {
	 kw_event.print();
	 if(i < 10 ) lulist_(2);
	 if(i < 10 ) current_event.print();
       }
   }
/**************  KORALW final printouts  **************/ 
   koralw::finalize( xpar, npar );

   double xsect = xpar[20];
   double ersect= xpar[21];
   cout << " KORALW: xsect  ="<<  xsect << "    ersect ="<< ersect << "\n" ;

   cout << "   |--------------------| \n" ;
   cout << "   |  Demo2.C  Exiting  | \n" ;
   cout << "   |--------------------| \n" ;

}
/*****************************************************************************/
void fill_param( double xpar[], long npar[] )
{
   npar[1]=1;    // KeyRad = 1000*KeyCul +100*KeyNLL +10*KeyFSR +KeyISR  
   npar[2]=1011; // KeyPhy = 100000*KeyWu +10000*KeyRed +1000*KeySpn 
                 //                       +100*KeyZet +10*KeyMas +KeyBra  
   npar[3]=10;   // KeyTek = 10*KeyRnd +KeyWgt
   npar[4]=0;    // KeyMis = 100*KeyAcc +10*Key4f +KeyMix
   npar[5]=0;    // KEYDWM    W- decay: 7=[ev], 0=all ch.   
   npar[6]=0;    // KEYDWP    W+ decay: 7=[ev], 0=all ch.  
   npar[7]=16;   // NOUT      Output unit number, for Nout.LE.0, Nout=16
   npar[21]=0;   // JAK1      Decay mode tau+
   npar[22]=0;   // JAK2      Decay mode tau-
   npar[23]=1;   // ITDKRC    Bremsstrahlung switch in Tauola 
   npar[24]=1;   // IFPHOT    PHOTOS switch
   npar[25]=1;   // IFHADM    Hadronisation W-
   npar[26]=1;   // IFHADP    Hadronisation W+IFHADP

   xpar[1]=180e0;      // CMSENE CMS total energy  
   xpar[2]=1.16639e-5; // GFERMI Fermi Constant  
   xpar[3]=128.07e0;   // ALFWIN alpha QED at WW tresh. scale [inverse] 
   xpar[4]=91.1888e0;  // AMAZ   Z mass   
   xpar[5]=2.4974e0;   // GAMMZ  Z width      
   xpar[6]=80.230e0;   // AMAW   W mass 
   xpar[7]=-2.03e0;    // GAMMW  W with, For GAMMW<0 RECALCULATED inside progr.
   xpar[8]=1e-6;       // VVMIN  Photon spectrum parameter
   xpar[9]=0.99e0;     // VVMAX  Photon spectrum parameter
   xpar[10]=-1e0;      // WTMAX  max weight for reject. 
}
/*****************************************************************************/

