//=============================================================================
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>
#include <math.h>
#include <iomanip.h>
//***************************************************************************//
void make_link(int mult, float x, float A[100][100],
	       int link[100][100], int noli[100], float suli[100])
     // integer matrix link which is 0,1 indicating existence of link 
     // integer matrix noli counts number of off-diagonal links in the column
     // A is cut to zero below treshold x
{
  int i,j,k;
  for(j=0; j<mult;j++) 
    {
      noli[j]=0;
      suli[j]=0;
      for(k=0; k<mult;k++)
	{
	  if(A[k][j] > x) 
	    { link[k][j]=1; noli[j]++; suli[j]=suli[j]+A[k][j]; }
	  else
	    { link[k][j]=0; A[k][j]=.0; }
	};
    };
};
//***************************************************************************//
void order_right(int mult, int noli[100], float suli[100],
		           int link[100][100], float A[100][100])
{
  int i,j,k,l,m,n;
  float x;
  // this orders link matrix such that links
  // are in the right lower corner
  for(j=mult-1; j>0;j--)
    {
      for(k=0; k<j; k++)
	{
	  //cout << k << " ";
	  //if( noli[k+1] < noli[k])
	  if( suli[k+1] < suli[k])
	    {
	      n=noli[k+1]; noli[k+1]=noli[k]; noli[k]=n;
	      x=suli[k+1]; suli[k+1]=suli[k]; suli[k]=x;
	      for (m=0; m<mult ; m++) // interchange raws
		{
		  n=link[k+1][m]; link[k+1][m]=link[k][m]; link[k][m]=n; 
		  x=A[k+1][m];       A[k+1][m]=   A[k][m];    A[k][m]=x; 
		}
	      for (m=0; m<mult ; m++) // interchange collumns
		{
		  n=link[m][k+1]; link[m][k+1]=link[m][k]; link[m][k]=n;
		  x=   A[m][k+1];    A[m][k+1]=   A[m][k];    A[m][k]=x;
		}
	    }
	}
      //cout << endl;
    }
};
//***************************************************************************//
void order_left(int mult, int noli[100],  float suli[100],
		int link[100][100], float A[100][100])
{
  int i,j,k,l,m,n;
  float x;
  // this orders link matrix such that links
  // are in the left upper corner
  for(j=mult-1; j>0;j--)
    {
      for(k=0; k<j; k++)
	{
	  //cout << k << " ";
	  //if( noli[k+1] > noli[k])
	  if( suli[k+1] > suli[k])
	    {
	      n=noli[k+1]; noli[k+1]=noli[k]; noli[k]=n;
	      x=suli[k+1]; suli[k+1]=suli[k]; suli[k]=x;
	      for (m=0; m<mult ; m++) // interchange raws
		{
		  n=link[k+1][m]; link[k+1][m]=link[k][m]; link[k][m]=n; 
		  x=A[k+1][m];       A[k+1][m]=   A[k][m];    A[k][m]=x; 
		}
	      for (m=0; m<mult ; m++) // interchange columns
		{
		  n=link[m][k+1]; link[m][k+1]=link[m][k]; link[m][k]=n;
		  x=   A[m][k+1];    A[m][k+1]=   A[m][k];    A[m][k]=x;
		}
	    }
	}
      //cout << endl;
    }
};
//***************************************************************************//
void print_link(int mult, int noli[100], float suli[100], int link[100][100])
{
  int i,j,k;
  cout << endl;
  for(j=0; j<mult;j++) cout << "  " << noli[j];
  int ntot=0; for(j=0; j<mult;j++) ntot=ntot+noli[j];
  cout <<"   " <<ntot<<"/"<< mult*mult;
  cout << endl;
  for(j=0; j<mult;j++)
    {
      for(k=0; k<mult;k++) cout << link[j][k] << " ";
      cout << endl;
    };
  for(j=0; j<mult;j++) cout << "  " << setprecision(2) << setw(5)<< suli[j];
  cout << endl;
};
//***************************************************************************//
void print_mat100(int mult, float A[100][100])
{
  int i,j,k;
# define sw2 setprecision(2) << setw(5)
  cout << endl;
  cout << mult << endl;
  for(j=0; j<mult;j++)
    {
      for(k=0; k<mult;k++) cout << sw2 << A[j][k] << " ";
      cout << endl;
    };
};
//**************************************************************************//
//==========================================================================//
//--------------------------------------------------------------------------//
//**************************************************************************//
void permanent(int n, int link[100][100], float A[100][100], 
	       int &ntot, double &result)
{
int i,j,k,l,m;
int anti_ord;
int ind[100];
int free[100][100];
double fact, Prec;

Prec = 0;
if(n > 9) Prec = 0.01;
if(n > 14)Prec = 0.1;

///////////////////////////
/// Loop initialization ///
///////////////////////////
// set first permutation and occupancy matrix
for(i=0; i<n; i++)
  {
    if(i==0)
      for(k=0; k<n; k++) free[k][0]=1;              // all free for first digit
    else
      for(k=0; k<n; k++) free[k][i]=free[k][i-1];   // copy previous column
    for(k=0; k<n; k++)                              // set digit, occupy
      if( free[k][i] == 1 && link[k][i] == 1 )
      //if( free[k][i] == 1 )      
	{ ind[i]=k; free[k][i]=0; break;}
  }

//for(k=0; k<n; k++) cout << ind[k];  cout << endl;
//for(k=0; k<n; k++)
//  { for(i=0; i<n; i++) cout<<free[k][i]<<" "; cout<<endl; }
//cout<<endl;

ntot=0;
result=0;
double factt=1;
double resultt=0;
////////////////////////
/// Loop starts here ///
////////////////////////
ACCEPT:

//cout << endl;
ntot++;

//if(ntot==  1000) Prec=0.001; // this ansatz gives about 10%
//if(ntot== 10000) Prec=0.01;  //
//if(ntot==100000) Prec=0.1;   //

//cout<<"  factt="<<setprecision(6)<<factt<<endl;
resultt=resultt+factt;

fact=1; for(k=0; k<n; k++) fact=fact*A[k][ind[k]];
result=result+fact;

double average = result/ntot;

if(ntot%100000 == 0)
  {
    for(k=0; k<n; k++) cout << ind[k] << " ";
//    cout << endl;
//    cout << endl;
//    for(k=0; k<n; k++)
//      { for(i=0; i<n; i++) cout<<free[k][i]<<" "; cout<<endl; }
//    cout<<endl;
    cout<<"  "<<ntot<<"  ";
    cout<<"  "<<setprecision(6)<<result<<" "<<result/ntot<<" "<<fact;
    cout<<endl;
  }

//cin >> l;


for(i=n-1; i>=0; i--)  // LOOP starting from the last digit downward
  {
    //cout<<"i->"<<i<<endl;

    // Check WHETHER trailer is ANTI-ORDERED
    anti_ord=1;                       // assume anti-ordering
    for(k=i+1;k<n;k++) 
      if(ind[k]>ind[k-1]) anti_ord=0; // check for anti-ordering one by one

    //cout << "anti_ord=" << anti_ord << endl; 

    factt=factt/A[i][ind[i]];
    //cout<< "   DIVIDE "<<i<<" "<<ind[i]<<" "<<factt<<endl;

  SAME_DIGIT:
    if(anti_ord == 0)                 // if trailer is NOT ANTI-ORDERED
      {                               // then update current digit
	//cout << " update digit reset (order) the trailer "<< endl;

	for(k=ind[i]+1; k<n; k++)             // find next possible entry
	  {
	    //cout<<"$"<<" k="<<k<<" free="<<free[k][i];
	    //cout<<" link="<<link[k][i]<<endl;
	    if( free[k][i]==1 && link[k][i]==1 ) 
	    //if( free[k][i]==1 ) 
	      {
		if( factt*A[i][k]<Prec*average) goto Next_k; // accelerator
		free[ind[i]][i]=1;              // free actual entry
		ind[i]=k; free[k][i]=0;         // SET NEW DIGIT
		factt=factt*A[i][ind[i]];
		//cout<< " MULTIPLY "<<i<<" "<<ind[i]<<" "<<factt<<endl;
		//cout << "!!!! new digit is set "<<k<< endl; 
		goto RESET_TRAILER;             // reset trailer
	      }
	  Next_k:;
	  }
	//cout << "no space left to update current digit"<< endl; 
	goto NEXT_DIGIT;           // no space left to update current digit
      RESET_TRAILER:
	// reset trailer digits taking into account occupied/free
	j=i+1;
      UP_j:;
	if(j == n) goto ACCEPT;
	for(k=0; k<n; k++) free[k][j]=free[k][j-1];
	int kmin=0;
      DOWN_j:;
	//cout << "RESET start digit j="<<j<<endl;
	//[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
	//for(k=0; k<n; k++)
	//  { for(l=0; l<n; l++) cout<<free[k][l]<<" "; cout<<endl; }
	//cout<<"[[[*]]]"<<endl;
	//]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]
	for(k=kmin; k<n; k++)
	  {
            //cout<<"$"<<" k="<<k<<" free="<<free[k][j];
	    //               cout<<" link="<<link[k][j]<<endl;
	    if( free[k][j]==1 && link[k][j]==1 ) 
	    //if( free[k][j]==1 ) 
	      {
		if( factt*A[j][k]<Prec*average) goto next_k; // accelerator
		ind[j]=k; free[k][j]=0;         // SET NEW ENTRY
		factt=factt*A[j][ind[j]];
		//cout<< " Multiply "<<j<<" "<<ind[j]<<" "<<factt<<endl;
		//cout<<"            digit j="<<j<< " IS RESET to "<<k<<endl;
		j++; goto UP_j;
	      }
	  next_k:;
	  }
	//cout << "          reset digit j="<<j<< " failed, j--"<<endl;
	j--;
	kmin=ind[j]+1;     // set kmin for avoiding repetition
	free[ind[j]][j]=1; // UNSET previous entry in matrix free
	factt=factt/A[j][ind[j]];
	//cout<< "   Divide "<<j<<" "<<ind[j]<<" "<<factt<<endl;
	//if(j==i) cout << "    total FAILURE, wrong j=" <<j<<endl;
	if(j==i) goto SAME_DIGIT; // j-th reset failed, total failure
	//cout << "                                    DOWN_j"<<endl;
	goto DOWN_j;              // j-th reset failed, try rescue
      } // end if anti_ord == 0
  NEXT_DIGIT:;                // take next lower (older) digit
  } // end for i
////////////////////////
/// Loop  ends  here ///
////////////////////////

//cout<<"    Prec ="<<setprecision(6)<<Prec<<endl;
//cout<<"  result ="<<setprecision(6)<<result <<endl;
//cout<<"  resultt="<<setprecision(6)<<resultt<<endl;


//for(k=0; k<n; k++) cout << ind[k];  cout << endl;
//for(k=0; k<n; k++)
//  { for(i=0; i<n; i++) cout<<free[k][i]<<" "; cout<<endl; }

//cout << "ntot= "<< ntot<< "\n" ;
};
//**************************************************************************//
//--------------------------------------------------------------------------//
//==========================================================================//
//**************************************************************************//
