//*****************************************************************************
// Routine ReadSema helps to manage main production loop
// It check semaphore file and reads seed numbers for ranmar
//*****************************************************************************
TString ReadSema(TString Mode)
{
  char txtdum [200];
// Skip everything to the end of line in file F
#define SKIPLINE(F) F.getline(txtdum,200,'\n')
  //char Semaph[5];  
  TString  Semaph;  
  ifstream InfileSema;
  ifstream InfileSeed;
  ofstream OufileSema;
  //long ijklin = 54217137; // default random number seed
  long ijklin = 46785717; // test
  long ntotin =        0; // default
  long ntot2n =        0; // default

  InfileSema.open("./semaphore");  //read directive from semaphore file
  InfileSema>>setw(4)>>Semaph;
  //SKIPLINE(InfileSeed); unnecessary, for CONT it is OK.
  if(Mode == "Init")
    {
      //////////////////////////////////////////////////////////////
      //   Initialization before generation of the first event    //
      //////////////////////////////////////////////////////////////
      if( Semaph == "STAR" )
	{
	  ////////////////////////////////////////////////
	  //   start from scratch, read seed from disk  //
	  ////////////////////////////////////////////////
	  InfileSema.close();
	  //
	  InfileSeed.open("./iniseed");
	  InfileSeed >> ijklin; SKIPLINE(InfileSeed);
	  InfileSeed >> ntotin; SKIPLINE(InfileSeed);
	  InfileSeed >> ntot2n; SKIPLINE(InfileSeed);
	  InfileSeed.close();
	  //initialization of the random number generator
	  marini_(ijklin,ntotin,ntot2n);
	  return Semaph;
	}
      if( Semaph == "CONT" )
	{
	  ////////////////////////////////////////////////
	  // read seed from semaphore file and continue //
	  ////////////////////////////////////////////////
	  InfileSema >> ijklin; SKIPLINE(InfileSema);
	  InfileSema >> ntotin; SKIPLINE(InfileSema);
	  InfileSema >> ntot2n; SKIPLINE(InfileSema);
	  InfileSema.close();
	  //initialization of the random number generator
	  marini_(ijklin,ntotin,ntot2n);
	  return Semaph;
	}
      if( Semaph == "STOP" )
	{
	  InfileSema.close();
	  ////////////////////////////////////////////////
	  // Stop flag encountered for initialization   //
	  ////////////////////////////////////////////////
	  cout<< " ++++++++++++++++++++++++++++++++++++++ \nl";
	  cout<< "        WRONG SEMAPHORE                 \nl";
	  cout<< " ++++++++++++++++++++++++++++++++++++++ \nl";
	  return Semaph;
	}
    }
  else
    {
      //////////////////////////////////////////////////////////////
      //     during the event generation main loop                //
      //     close and overwrite semaphore file                   //
      //////////////////////////////////////////////////////////////
      InfileSema.close();
      marout_(ijklin,ntotin,ntot2n);
      OufileSema.open("./semaphore");
      OufileSema<<"CONT"<<"\n";
      OufileSema<<ijklin<<"\n";
      OufileSema<<ntotin<<"\n";
      OufileSema<<ntot2n<<"\n";
      OufileSema.close();
      return Semaph;
    } // if(Mode)
};
