//=============================================================================
//=============================================================================
// To initiate enviroment for ROOT  source ~/bin/rootlogin
// To compile&link:                 make rmain.exe
// To execute:                      make rmain.root
// To debug:                        xldb rmain.exe
//  set -g option in compilation everywhere!!!
//  xldb -I "../korww ../interfaces ../ampli4f ../kwlund ../model" rmain.exe 
//=============================================================================
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>
#include <math.h>
#include <iomanip.h>
#include "Lorenz.h"
#include "koralw.h"
#include "Koralw.h"
#include "partit1.h"

// headers from ROOT
#include "TROOT.h"
#include "TFile.h"
#include "TH1.h"
#include "TH2.h"
#include "TProfile.h"
#include "TNtuple.h"
#include "TRandom.h"
//=============================================================================
//  ROOT  ROOT ROOT   ROOT  ROOT  ROOT  ROOT  ROOT  ROOT  ROOT   ROOT   ROOT 
//=============================================================================
TROOT tuples("rmain","Test of histogramming and I/O");
//=============================================================================
//  Important GLOBAL variables
//
// lambda is fit to get average multiplicity
// and the average weight is divided out as an overall normalization

TFile hfile("rmain.root","NEW","histograms");
long NevTot = 300;    // 1h

double lambda  = 1.0;
double avewt   = 1.0;
double lambda2 = 1.0;
double avewt2  = 1.0;
//TFile hfile("rmain.root.172GeV.2J.5k","NEW","histograms");
//TFile hfile("rmain.root.200GeV.4J.5k","NEW","histograms");
//TFile hfile("rmain.root.172GeV.4J.5k","NEW","histograms");
//long NevTot = 5000;    // 1h

//  172GeV
//TFile hfile("rmain.root.172GeV.4J.40k","NEW","histograms");
//long NevTot =40000;  // 7.5h
//TFile hfile("rmain.root.172GeV.4J.40k.isr","NEW","histograms");
//long NevTot =40000;    // 7.5h (B.E. ntuple shortened)
//double lambda = 1.0675;   // 172GeV  2W Range=0.20,ifun=2
//double avewt  = 0.1751;   // 172GeV  2W Range=0.20,ifun=2
//double lambda2= 1.0510;   // 172GeV  1W Range=0.20,ifun=2
//double avewt2 = 0.4387;   // 172GeV  1W Range=0.20,ifun=2
//
//  200GeV
//TFile hfile("rmain.root.200GeV.4J.40k","NEW","histograms");
//long NevTot =40000;    // 7.5h
//double lambda = 1.0617;   // 200GeV  2W
//double avewt  = 0.2095;   // 200GeV  2W
//double lambda2= 1.0495;   // 200GeV  1W
//double avewt2 = 0.3986;   // 200GeV  1W
//
//  Other
//double lambda = 1.025;    // 172GeV  1W Range=0.10,ifun=1
//double avewt  = 0.64;     // 172GeV  1W Range=0.10,ifun=1
//=============================================================================
//  histos  histos  histos  histos  histos  histos  histos  histos  histos
TH1F *hst_unQ2  = new TH1F("hst_unQ2" ,"Q2 2-pi"     ,100,0,1);
TH1F *hst_wtQ2  = new TH1F("hst_wtQ2" ,"Q2 2-pi wted",100,0,1);
TH1F *hst_wt2Q2 = new TH1F("hst_wt2Q2","Q2 2-pi wted",100,0,1);
TH1F *hst_unQ3  = new TH1F("hst_unQ3" ,"Q2 3-pi"     ,100,0,1);
TH1F *hst_wtQ3  = new TH1F("hst_wtQ3" ,"Q2 3-pi wted",100,0,1);
TH1F *hst_wt2Q3 = new TH1F("hst_wt2Q3","Q2 3-pi wted",100,0,1);
TH1F *hst_nclu  = new TH1F("hst_nclu","cluster dist",20,0,20);
//
TH1F *hst_pene = new TH1F("hst_pene" ,"energy parton",100,0,100);
TH1F *hst_jene = new TH1F("hst_jene" ,"energy jet   ",100,0,100);
TH1F *MasW_avg = new TH1F("MasW_avg" ,"avg mass no BE",40,78.0,82.0);
TH1F *MasW_avg2= new TH1F("MasW_avg2","avg mass BE on",40,78.0,82.0);
//=============================================================================
// ntuples ntuples ntuples ntuples ntuples ntuples ntuples ntuples
TNtuple *ntuple8 =
        new TNtuple("ntuple8","mWW ntuple","m0:m1:m2:m3:m4:m5:np:wt");
TNtuple *jtuple6 = new TNtuple("jtuple6","mWW ntuple","M0:M1:nj:np:wt:wt2");
TNtuple *ctuple2 = new TNtuple("ctuple2","mWW ntuple","Q:np:wt");
TNtuple *ctuple3 = new TNtuple("ctuple3","mWW ntuple","Q:np:wt");
int      ctuple2_counter=0;
int      ctuple2_max=10000;  // maximum entries in ntuple
int      ctuple3_counter=0;
int      ctuple3_max=10000;  // maximum entries in ntuple
//=============================================================================
//TNtuple *ntBE2   = new TNtuple("ntBE2"  ,"BE ntuple","np:wt:wt2");
//TNtuple *ntBE6   = new TNtuple("ntBE6"  ,"BE ntuple","np:nm:n0:wp:wm:w0");
//=============================================================================
//=============================================================================
//  Headers from this source file
//=============================================================================

void fill_param( double xpar[], long npar[] );

void   parton_mass(Koralw event, double m[6] );
void   jet_mass(Koralw event, double m[6] );

double pair_Q2(double p1[4], double p2[4]);
void   BoseEinstein(Koralw event, 
		    int &nPiPlus, int &nPiMinus, int &nPiZero,
		    double &wtPlus, double &wtMinus, double &wtZero,
		    double &wtot,  double &wtot2);
void   BEbook(Koralw event, int kfP, int ntot, double wt, double wt2);
double Q2pair(PartLund first, PartLund second);

/*****************************************************************************/
/*****************************************************************************/
/*****************************************************************************/
main()
{
  long iEvent =0;       // event number for generation
  //long NevTot =300;   // total number of events
  int kf;

  //long NevTot =  300;    // 3min
  //long NevTot =  600;    // 6min
  //long NevTot = 1200;    // 15min
  //long NevTot = 2500;    // 30min, 144kB
  //long NevTot = 5000;    // 1h, 0.3mb
  //long NevTot =10000;    // 2h, 0.6mb
  //long NevTot =20000;    // 4h
  //long NevTot =30000;    // 5.5h, 1.8MB

  cout << "   |--------------------| \n" ;
  cout << "   |  Rmain.C  Entering | \n" ;
  cout << "   |--------------------| \n" ;

/**************  KORALW initialisation   **************/
   double xpar[101];
   long   npar[101];
   fill_param( xpar, npar );
   Koralw::initialize(xpar, npar);

/**************  KORALW event generation **************/
   
   for ( iEvent = 0; iEvent< NevTot; iEvent++) {
     Koralw current_event;
     current_event.User();
     if(iEvent < 3 ) 
       {
	 current_event.print(); // print from class koralw
	 current_event.Print(); // big Print from class Koralw
	 cout << "njet = " << current_event.njet << endl;
       }
     if( (iEvent%100)  == 0 ) cout <<"iEvent = "<<iEvent<<endl<<flush;
     if( (iEvent%1000) == 1 ) hfile.Write();
// %%%%%%%%%%%%%%%%%%%%%%%%%
// BoseEinstein
     int nPiPlus; int nPiMinus; int nPiZero;
     double wtPlus; double wtMinus; double wtZero, wtBE, wtBE2;
     BoseEinstein(current_event, nPiPlus, nPiMinus, nPiZero,
		  wtPlus,  wtMinus,  wtZero,
		  wtBE, wtBE2);
     int ntot = nPiPlus+ nPiMinus+ nPiZero;
     kf= 211; BEbook(current_event,kf,ntot,wtBE,wtBE2);
     kf=-211; BEbook(current_event,kf,ntot,wtBE,wtBE2);
     //kf= 111; BEbook(current_event,kf,ntot,wtBE,wtBE2);

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Partons Partons Partons Partons Partons
     int i,j;
     hst_pene->Fill(current_event.ferm1[0]);
     hst_pene->Fill(current_event.ferm2[0]);
     double mWW[6];
     parton_mass(current_event,mWW);
     ntuple8->Fill(mWW[0],mWW[1],mWW[2],mWW[3],mWW[4],mWW[5],ntot,wtBE);
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Jets Jets Jets Jets Jets Jets Jets Jets Jets
     int nj = current_event.njet;
     for (j=0; j<nj ;j++) 
       hst_jene->Fill(current_event.jet[j].pmom[0]);

     jet_mass(current_event,mWW);
     jtuple6->Fill(mWW[0],mWW[1],nj,ntot,wtBE,wtBE2);
     jtuple6->Fill(mWW[2],mWW[3],nj,ntot,wtBE,wtBE2);
     jtuple6->Fill(mWW[4],mWW[5],nj,ntot,wtBE,wtBE2);

     if( nj == 4 ){
       // chlopologicznie bez wagi
       if(abs(mWW[0]-mWW[1])<10.00) MasW_avg->Fill(0.5*(mWW[0]+mWW[1]));
       if(abs(mWW[2]-mWW[3])<10.00) MasW_avg->Fill(0.5*(mWW[2]+mWW[3]));
       if(abs(mWW[4]-mWW[5])<10.00) MasW_avg->Fill(0.5*(mWW[4]+mWW[5]));
       // chlopologicznie z waga
       if(abs(mWW[0]-mWW[1])<10.00) MasW_avg2->Fill(0.5*(mWW[0]+mWW[1]),wtBE);
       if(abs(mWW[2]-mWW[3])<10.00) MasW_avg2->Fill(0.5*(mWW[2]+mWW[3]),wtBE);
       if(abs(mWW[4]-mWW[5])<10.00) MasW_avg2->Fill(0.5*(mWW[4]+mWW[5]),wtBE);
     };
   }

// %%%%%%%%%%%%%%%%%%%%%%%%%
   hfile.Write();
   hfile.Close();

/**************  KORALW final printouts  **************/ 
   Koralw::finalize( xpar, npar );

   double xsect = xpar[20];
   double ersect= xpar[21];
   cout << " KORALW: xsect  ="<<  xsect << "    ersect ="<< ersect << "\n" ;

   cout << "   |--------------------| \n" ;
   cout << "   |  Rmain.C  Exiting  | \n" ;
   cout << "   |--------------------| \n" ;
}

/*****************************************************************************/
/*****************************************************************************/
/*****************************************************************************/
void parton_mass(Koralw event, double m[6] )
{
  VLorenz psum;
  psum = event.ferm1 + event.ferm2; m[0] = sqrt(psum*psum);
  psum = event.ferm3 + event.ferm4; m[1] = sqrt(psum*psum);
  psum = event.ferm1 + event.ferm3; m[2] = sqrt(psum*psum);
  psum = event.ferm2 + event.ferm4; m[3] = sqrt(psum*psum);
  psum = event.ferm1 + event.ferm4; m[4] = sqrt(psum*psum);
  psum = event.ferm2 + event.ferm3; m[5] = sqrt(psum*psum);
  //for(int i=0;i<6;i++) cout << m[i] << " "; cout << endl;
};
//------------------------
void jet_mass(Koralw event, double m[6] )
{
  VLorenz psum;
  int nj = event.njet;
  for(int i=0; i<6; i++) m[i]=0;
  //[[[[[[[[[[[[[
  //cout << "==>" << event.jet[0].pmom[0] << " "; cout << endl;
  //cout << "..."; (*event.jet[0]).print();
  //cout << "..."; (*event.jet[1]).print();
  //cout << "..."; (*event.jet[2]).print();
  //cout << "..."; (*event.jet[3]).print();
  //]]]]]]]]]]]]]
  if(nj==4)
    {
      psum= event.jet[0].pmom +event.jet[1].pmom; m[0] =  sqrt(psum*psum);
      psum= event.jet[2].pmom +event.jet[3].pmom; m[1] =  sqrt(psum*psum);
      psum= event.jet[0].pmom +event.jet[2].pmom; m[2] =  sqrt(psum*psum);
      psum= event.jet[1].pmom +event.jet[3].pmom; m[3] =  sqrt(psum*psum);
      psum= event.jet[0].pmom +event.jet[3].pmom; m[4] =  sqrt(psum*psum);
      psum= event.jet[1].pmom +event.jet[2].pmom; m[5] =  sqrt(psum*psum);
    }
  //for(int i=0;i<6;i++) cout << m[i] << " "; cout << endl;
};

/*****************************************************************************/
//===========================================================================//
//                          Bose Einstein                                    //
//===========================================================================//
//***************************************************************************//
void BEbook(Koralw event, int kfP, int ntot, double wt, double wt2)
{
  int j,k,l;
  PartLund *pion[500];

  //cout<<"***********************************************"<<endl; 
  int nP=0;
  for (j=0; j< event.npart ;j++)
    if( event.part[j].kflavor ==  kfP ) 
      {
	pion[nP] = &event.part[j];
	nP++;
      };

  //cout<<"----------------------------------------------"<<endl; 
  //cout<<" nP= "<<nP<<endl;
  //cout<<" wt= "<<wt<<endl;

  //pairs (off-diagonal elements)
  for(j=0; j<nP;j++)
      for(k=0; k<j;k++)
	{
	  double Q2jk= Q2pair(*pion[j],*pion[k]);
	  hst_unQ2->Fill(Q2jk);
	  hst_wtQ2->Fill(Q2jk,wt);
	  hst_wt2Q2->Fill(Q2jk,wt2);
	  if(ctuple2_counter < ctuple2_max)
	    if(Q2jk<1.0) {ctuple2->Fill(Q2jk,ntot,wt); ctuple2_counter++;}
	  for(l=0; l<k;l++)
	    {
	      double Q2jl= Q2pair(*pion[j],*pion[l]);
	      double Q2kl= Q2pair(*pion[k],*pion[l]);
	      double Q3jkl = Q2jk+Q2jl+Q2kl;
	      hst_unQ3->Fill(Q3jkl);
	      hst_wtQ3->Fill(Q3jkl,wt);
	      hst_wt2Q3->Fill(Q3jkl,wt2);
	      if(ctuple3_counter < ctuple3_max)
		if(Q3jkl<1.0){ctuple3->Fill(Q3jkl,ntot,wt); ctuple3_counter++;}
	    }
	}

}
//==========================================================================//
//==========================================================================//
double Q2pair(PartLund first, PartLund second)
// calculates positive Q2 = -(q1-q2)^2 for a pair of particles
{
  VLorenz  Q;
  double   Q2;

  Q = first.pmom - second.pmom;
  Q2 = -(Q*Q);
  return Q2;
};
//==========================================================================//
//                    Correlation functions
//==========================================================================//
double CorFun1(double Q2, int mult, double Rf, double pp)
  // EXPONENTIAL UA1 fit
  {
      double R = Rf/0.2;                   // conversion to GeV^-1
      R = R*sqrt((mult*(mult-1))/2.0);     // UA1 fit, R increasing with n
      double Q2p = Q2*2/(mult*(mult-1));
      double Qp  = sqrt(Q2p);
      double x = Qp*R;
      double zexp= 0; 
      if( x < 100.0 ) zexp = exp(-x);
      return zexp;
  }
//=======================================================================
double CorFun2(double Q2, int mult, double Rf, double pp)
  // GAUSSIAN UA1 fit
  {
      double R = Rf/0.2;                   // conversion to GeV^-1
      double Q2p = Q2*2/(mult*(mult-1));
      double x = Q2p*(R*R);
      double zexp= 0; 
      if( x < 100.0 ) zexp = exp(-x);
      return zexp;
  }
//=======================================================================
void WTcluster(int mult, PartLund *first, double &wt)
//*************************************************************************//
// Operates on a SINGLE cluster *first which is still in form of a 
// LIST starting at the element *first,
// Calculates weight wt.
//*************************************************************************//
{ 
  int i,j,k,l,m,n;
  int ntot;
  float x;
  PartLund *clmat   = new PartLund[mult];
  float A[100][100];
  int link[100][100];
  int noli[100];
  float suli[100];

  // Copy etire cluster into matrix clmat
  PartLund *actual; j=0;
  for (actual = first; actual != NULL; actual = actual->previous)
    {
      clmat[j] = *actual;
      j++;
    };


  // real    matrix A containing the value of relative Q2
  for(j=0; j<mult;j++) A[j][j]=0.0;  // diagonal elements
  double Q2jk;
  double Q2 = 0;
  for(j=0; j<mult;j++)               // off-diagonal elements
      for(k=0; k<j;k++)
	{
	  double Q2jk= Q2pair( clmat[j],clmat[k]);
	  A[j][k]=Q2jk; A[k][j]=Q2jk;
	  Q2=Q2 + Q2jk;
	}

  wt=1;
  if(mult>1)
    {
      double pp;   // coherence parameter pp=p=lambda
      double R ;   // radius in fermi <===== !!!!!
      double zexp;
      int ifun=1;
      if( ifun == 2 )
	{
	  // exponential UA1 fit
	  pp=0.40; R=1.3; zexp =CorFun1(Q2, mult, R, pp);
	}
      else
	{
	  // gaussian    UA1 fit
	  pp=0.20; R=1.0; zexp =CorFun2(Q2, mult, R, pp);
	}
      // parameters of Kacper
      double pz=pp*zexp;
      double uz=1-pp;
      double wwjap;
    //**********************
      japww(mult,pz,uz,wwjap);
    //**********************
      wt=wwjap;
      if(wt>100.0)
	{
	  double Qp = sqrt(Q2*2/(mult*(mult-1)));
	  cout<<"mult= "<<mult<<" wt= "<<wt;
	  cout<<" pz="<<pz<<" pp="<<pp<<" Qp= "<<Qp ;
	  cout<<" zexp= "<<zexp<<endl;
	}
    }

  // IMPORTANT!!! detach dynamical storage!!!
  // IMPORTANT!!! detach dynamical storage!!!
  delete [] clmat;
};
//*********************************************************//
void BEchain2(Koralw event, int kfP, int &nP, double &wt)
//==========================================================//
// Forms chain of MANY CLUSTERS of particles type kfP
//==========================================================//
{
  int iPrint =0;  // Printing flag for debugs
  int j,k;
  double Qp,QpMin;
  PartLund *head, *actual;
  PartLund *first, *second;
  PartLund *clhead, *cltail, *next;
  PartLund *clust[500];
  int      nclust[500];
  int mulclus,np;
  int nptot=0;
  double Range=0.20; // maximum sqrt(Q2) range for a single pair to qualify

  nP=0; // default value 
  wt=1; // default value
  
  if(iPrint) cout << "||||||||||||||| BEchain2 Begin ||||||||||||||||" << endl;
  head=NULL;  
  for (j=0; j< event.npart ;j++)
    if( event.part[j].kflavor ==  kfP ) 
      {
	event.part[j].previous = head;
	head   = &event.part[j];
	if(iPrint) {(*head).pmom.print(); cout<<endl;}
	nP++;
      };

  if(iPrint) event.Print();
  if(iPrint) {cout << "ALL: "; (*head).ListPrint(); cout<<endl;}
  if(iPrint) cout << "==============================================" << endl;

  if(head == NULL) goto End;

  // I this part we form clusters of particles as LISTS which
  // begin at pointer *clust[i], i< mulclus
  // multiplicity of i-th cluster is stored in nclust[i]

  for(mulclus = 0; mulclus< 500; mulclus++)
    {
      np=1;
      cltail = head;          // last element in cluster segment
      for (actual = head; actual->previous != NULL; )
	{
	  if(iPrint) {(*actual).print(0); cout << " <-actual " << endl;}
	  next = actual->previous;
	  QpMin = 1e20;
	  for(first =head; ; first = first->previous)
	    {
	      Qp= sqrt(Q2pair(*first, *next));
	      if(Qp < QpMin) QpMin=Qp;
    if(iPrint){(*first).print(0);cout<<" <-first,QpMin="<<QpMin<<endl;}
	      if( first == cltail ) goto EE;
	    };
	EE:
	  if(QpMin < Range)
	    {
	      if(iPrint) {(*next).print(0);cout<<" <-detach "<< endl;}
	      actual->previous = actual->previous->previous; // detach
	      next->previous   = head;                       // attach
	      head= next;                                    // attach
	      np++;
	    }
	  else
	    {
	      actual= actual->previous;  // move further on
	    };
	};
      clhead = head;              // head of cluster
      head   = cltail->previous;  // new head of the remainder
      cltail->previous = NULL;    // grounding end of cluster
      clust[mulclus] = clhead;
      nclust[mulclus] = np;
      //
      int mlt2=np*(np-1)/2;
      hst_nclu->Fill(np+0.001,mlt2);     // cluster multiplicity
      //
      nptot = nptot+np;
     
      if(iPrint)
	{
	  cout<<"-----------> " << mulclus <<endl;
	  cout<<"np= "<<np << ": "; (*clhead).ListPrint(); cout<<endl;
	  (*head).ListPrint(); cout << endl;
	}

      if(head == NULL ) goto EEX;
    };
EEX:

  if(iPrint)
    {
      if( kfP ==  211) cout << "+++ "; 
      if( kfP == -211) cout << "--- "; 
      if( kfP ==  111) cout << "000 "; 
      cout << "|| nptot= "<<nptot << ":  ";
      cout << "mulclus= "<< mulclus << ":  ";
      for (j=0; j<mulclus; j++) cout << nclust[j] << " ";
      cout << endl;
    }

  double wtclu;
  for (j=0; j<mulclus; j++)
    if( nclust[j] > 1)
      {
	WTcluster(nclust[j], clust[j], wtclu);
	wt=wt*wtclu;
      }

End:
  if(iPrint) cout << "||||||||||||||| BEchain2 End ||||||||||||||||" << endl;
};  // END of BEchain2

//==========================================================================//
//==========================================================================//
void BoseEinstein(Koralw event, 
		  int &nPiPlus, int &nPiMinus, int &nPiZero,
		  double &wtPlus, double &wtMinus, double &wtZero, 
		  double &wtot, double &wtot2)
{
  int kf_PiPlus  =  211;
  int kf_PiMinus = -211;
  int kf_PiZero  =  111;

  BEchain2(event, kf_PiPlus,  nPiPlus,  wtPlus);
  BEchain2(event, kf_PiMinus, nPiMinus, wtMinus);
  BEchain2(event, kf_PiZero,  nPiZero,  wtZero);


  int ntot= nPiPlus+nPiMinus+nPiZero;
  wtot2  = wtPlus*wtMinus*wtZero*exp(-ntot *log(lambda2))/avewt2;

  double Avewt  = exp(log(avewt)/3); // qubic root
  wtPlus  = wtPlus *exp(-nPiPlus *log(lambda))/Avewt;
  wtMinus = wtMinus*exp(-nPiMinus*log(lambda))/Avewt;
  wtZero  = wtZero *exp(-nPiZero *log(lambda))/Avewt;
  
  wtot = wtPlus*wtMinus*wtZero;

  if(wtot>1000.0)
    {
      cout << " n = " <<" "<< event.npart  << ",  ";
      cout << nPiPlus <<" "<< nPiMinus <<" "<< nPiZero  << "  ";
      cout << " wtPlus  = " << wtPlus  << "   ";
      cout << " wtMinus = " << wtMinus << "   ";
      cout << " wtZero  = " << wtZero  << "   ";
      cout << " wtot = "    << wtot << endl;
    }
};




/*****************************************************************************/
void fill_param( double xpar[], long npar[] )
{
   npar[1]=1;    // KeyRad = 1000*KeyCul +100*KeyNLL +10*KeyFSR +KeyISR  
   npar[2]=1011; // KeyPhy = 100000*KeyWu +10000*KeyRed +1000*KeySpn 
                 //                       +100*KeyZet +10*KeyMas +KeyBra  
   npar[3]=10;   // KeyTek = 10*KeyRnd +KeyWgt
   npar[4]=0;    // KeyMis = 100*KeyAcc +10*Key4f +KeyMix
   npar[5]=1;    // KEYDWM    W- decay: 7=[ev], 0=all ch.   
   npar[6]=1;    // KEYDWP    W+ decay: 7=[ev], 0=all ch.  
   npar[7]=16;   // NOUT      Output unit number, for Nout.LE.0, Nout=16
   npar[21]=0;   // JAK1      Decay mode tau+
   npar[22]=0;   // JAK2      Decay mode tau-
   npar[23]=1;   // ITDKRC    Bremsstrahlung switch in Tauola 
   npar[24]=1;   // IFPHOT    PHOTOS switch
   npar[25]=1;   // IFHADM    Hadronisation W-
   npar[26]=1;   // IFHADP    Hadronisation W+IFHADP

   xpar[1]=172e0;      // CMSENE CMS total energy  172e0
   xpar[2]=1.16639e-5; // GFERMI Fermi Constant  
   xpar[3]=128.07e0;   // ALFWIN alpha QED at WW tresh. scale [inverse] 
   xpar[4]=91.1888e0;  // AMAZ   Z mass   
   xpar[5]=2.4974e0;   // GAMMZ  Z width      
   xpar[6]=80.230e0;   // AMAW   W mass 
   xpar[7]=-2.03e0;    // GAMMW  W with, For GAMMW<0 RECALCULATED inside progr.
   xpar[8]=1e-6;       // VVMIN  Photon spectrum parameter
   xpar[9]=0.99e0;     // VVMAX  Photon spectrum parameter
   xpar[10]=-1e0;      // WTMAX  max weight for reject. 
}
/*****************************************************************************/


