//=================================================================
// .x view-FitJet.C
// TWO CHOICES OF MW, (wt=1 case)
// I fit W mass using either m0 or (m0+m1)/2 with cut on abs(m0-m1)
// Ntuple jtuple with parton-parton masses produced using KORALW Monte Carlo
// Problems are marked with ???
//=================================================================
{
//
gROOT->Reset();
cFitJet = new TCanvas("cFitJet","The W mass fit",1000,800);
//----------------------------------------------------------------------------
// Connect ROOT histogram/ntuple demonstration file
//
//TFile f1("../172GeV.4J.mini/rmain.root");
TFile f1("../172GeV.4J/rmain.root.60k");
//TFile f1("../172GeV.4J/rmain.root");
//TFile f1("rmain.root.172GeV.4J.40k.isr");
//TFile f1("rmain.root.172GeV.4J.40k.isr1");
//TFile f1("rmain.root.172GeV.4J.40k.reco");
//----------------------------------------------------------------------------
cFitJet.cd();
cFitJet.SetFillColor(0);
cFitJet.SetBorderSize(0);
//============================================================================
//          Fit with average mass
//============================================================================
float Mmin = 78.0;
float Mmax = 82.2;
int   Nbin = 40;
TPad pad1("pad1","This is pad1", .00,.00, .50,1.00);
pad1.SetFillColor(10);
pad1.Draw();
pad1.cd();
// 
jtuple.SetFillColor(5);
jtuple.SetMarkerColor(2);
jtuple.SetLineColor(1);
jtuple.SetFillStyle(1001);
jtuple.SetFillColor(24);
//-------------------------------------------------
// define fitting BW function with 3 parameters
TF1 brwig1("brwig1",
   "[2]*sq(x)*sq([0])/(sq(sq(x)-sq([0])) +sq([0]*[1]))",Mmin,Mmax);
brwig1.SetParameters(80.0, 2.0, 1.0);
brwig1.SetLineWidth(4);
brwig1.SetLineColor(2);
//   Why this does not work?????
//TFormula FitJet("FitJet","[0]+ sq(x)*sq([1])/(sq(sq(x)-sq([1]))+sq([1]*[2]))");
//TF1 bwig1("bwig1","FitJet",Mmin,Mmax);
//----------------------------------------------------------------------
//----------------------------------------------------------------------
// get histo from ntuple
MasW_avg_cut = new TH1F("MasW_avg_cut","Case: Average Mass", Nbin,Mmin,Mmax);
MasW_avg_cut->SetLabelSize(0.035);
jtuple.Draw("0.5*(x0+x1)>>MasW_avg_cut","(abs(x0-x1)<10.0)*(nj==4)","goff");
jtuple.Draw("0.5*(x2+x3)>>+MasW_avg_cut","(abs(x2-x3)<10.0)*(nj==4)","goff");
jtuple.Draw("0.5*(x4+x5)>>+MasW_avg_cut","(abs(x4-x5)<10.0)*(nj==4)","goff");
//----------------------------------------------------------------------
//----------------------------------------------------------------------
// fit histogram and write fitted parameters
//-------------------------
MasW_avg_cut.Fit("brwig1");
//------------------
// plot results
MasW_avg_cut.Draw();
//-------------------------
float  MassW1 = brwig1.GetParameter(0);
float dMassW1 = brwig1.GetParError(0);
float  GammW1 = brwig1.GetParameter(1);
float dGammW1 = brwig1.GetParError(1);
TPaveText fitlabel( .25,.15 , (.25+.70),(.15+.12) ,"NDC");
fitlabel.SetTextAlign(12);
fitlabel.SetFillColor(42);
char mytext[200];
sprintf(mytext,"   Results of the fit: ");
fitlabel.AddText(mytext);
sprintf(mytext,"MassW = %7.3f +-%7.3f " ,MassW1,dMassW1);
fitlabel.AddText(mytext);
sprintf(mytext,"GammW = %7.3f +-%7.3f " ,GammW1,dGammW1);
fitlabel.AddText(mytext);
fitlabel.Draw();
//
TPaveText label1( .35,.00, .65,.05, "NDC");
label1.AddText("Average Mass");
label1.SetFillColor(10);
label1.SetBorderSize(0);
label1.Draw();
//     Why this not work ????
//TPaveLabel label7(0.4,0.8,0.9,0.95,"Average Mass");
//label7.Draw();
//
cFitJet.Update();
//============================================================================
//============================================================================
//  Fit with single mass
//============================================================================
//
Mmin = 76.0;
Mmax = 85.0;
Nbin = 40;
//
cFitJet.cd();
TPad pad2("pad2","This is pad2", .50,.00, 1.00,1.00);
pad2.SetFillColor(10);
pad2.Draw();
pad2.cd();
//
jtuple.SetFillColor(5);
jtuple.SetMarkerColor(2);
jtuple.SetLineColor(1);
jtuple.SetFillStyle(1001);
jtuple.SetFillColor(24);
//------------------------------------------------
// define fitting BW function with 3 parameters
TF1 brwig2("brwig2","[2]*sq(x)*sq([0])/(sq(sq(x)-sq([0])) +sq([0]*[1]))"
           ,Mmin,Mmax);
brwig2.SetParameters(80.0, 2.0, 1.0);
brwig2.SetLineWidth(4);
brwig2.SetLineColor(2);
//----------------------------------------------------------------------
//----------------------------------------------------------------------
// get histo from ntuple
MasW_sng_cut = new TH1F("MasW_sng_cut","Case: Single Mass", Nbin,Mmin,Mmax);
MasW_sng_cut->SetLabelSize(0.035);
jtuple.Draw("x0 >>MasW_sng_cut","(abs(x0-x1)<10.0)*(nj==4)","goff");
jtuple.Draw("x1>>+MasW_sng_cut","(abs(x0-x1)<10.0)*(nj==4)","goff");
jtuple.Draw("x2>>+MasW_sng_cut","(abs(x2-x3)<10.0)*(nj==4)","goff");
jtuple.Draw("x3>>+MasW_sng_cut","(abs(x2-x3)<10.0)*(nj==4)","goff");
jtuple.Draw("x4>>+MasW_sng_cut","(abs(x4-x5)<10.0)*(nj==4)","goff");
jtuple.Draw("x5>>+MasW_sng_cut","(abs(x4-x5)<10.0)*(nj==4)","goff");
//----------------------------------------------------------------------
//----------------------------------------------------------------------
// fit histogram and write fitted parameters
MasW_sng_cut.Fit("brwig2");
//---------------------
// plot results
MasW_sng_cut.Draw();
//------------------------------------------
float  MassW2 = brwig2.GetParameter(0);
float dMassW2 = brwig2.GetParError(0);
float  GammW2 = brwig2.GetParameter(1);
float dGammW2 = brwig2.GetParError(1);
TPaveText fitlabel2( .25,.15 , (.25+.70),(.15+.12) ,"NDC");
fitlabel2.SetTextAlign(12);
fitlabel2.SetFillColor(42);
char mytext[200];
sprintf(mytext,"   Results of the fit: ");
fitlabel2.AddText(mytext);
sprintf(mytext,"MassW = %7.3f +-%7.3f " ,MassW2,dMassW2);
fitlabel2.AddText(mytext);
sprintf(mytext,"GammW = %7.3f +-%7.3f " ,GammW2,dGammW2);
fitlabel2.AddText(mytext);
fitlabel2.Draw();
//
TPaveText label2( .35,.00, .65,.05, "NDC");
label2.AddText("Single Mass");
label2.SetFillColor(10);
label2.SetBorderSize(0);
label2.Draw();
//
cFitJet.Update();
cFitJet.cd();
}
