//=================================================================
// .x view-FitJetBE.C
// B.E. EFFECT IN FITTED MW
// I fit W mass using either m0 with cut on abs(m0-m1)
// Ntuple jtuple2 with parton-parton masses produced using KORALW Monte Carlo
// Problems are marked with ???
//=================================================================
{
//
gROOT->Reset();
//----------------------------------------------------------------------------
//
gROOT->Reset();
gStyle->SetStatY(-5.0);  // the trick to get rid of statistics!!!
gStyle->SetTitleX(-5.0); // the trick to get rid of title!!
//
TPaveText label2( .20,.00, .80,.05, "NDC");
label2.AddText("Average Mass [GeV]");
label2.SetFillColor(0);
label2.SetBorderSize(0);
//
TPaveLabel  labelA(.00,.92,1.0,1.0,"(a) B.E. off: |M?i!-M?j!|<10GeV","NDC");
labelA.SetBorderSize(0);
labelA.SetFillColor(0);
TPaveLabel  labelB(.00,.92,1.0,1.0,"(b) B.E. on: |M?i!-M?j!|<10GeV","NDC");
labelB.SetBorderSize(0);
labelB.SetFillColor(0);
//
//----------------------------------------------------------------------------
cFitJetBE = new TCanvas("cFitJetBE","The W mass fit",1000,800);
//----------------------------------------------------------------------------
// Connect ROOT histogram/ntuple demonstration file
// 172 GeV Production
TFile f1("../run/172GeV.4J/rmain.root");
//TFile f1("../run/172GeV.4J/rmain.root.160k");
//TFile f1("../run/200GeV.4J/rmain.root.160k");
//TFile f1("../run/172GeV.4J.isr/rmain.root.40k");
//TFile f1("../run/172GeV.4J.isr1/rmain.root.40k");
//TFile f1("../run/172GeV.4J.reco/rmain.root.40k");
//------------------------------------------------------------------------
// 200GeV Production
//TFile f1("../run/200GeV.4J/rmain.root.40k");
//============================================================================
cFitJetBE.cd();
cFitJetBE.SetFillColor(1);
cFitJetBE.SetBorderSize(0);
jtuple.SetMarkerColor(2);
jtuple.SetLineColor(1);
jtuple.SetFillStyle(1001);
jtuple.SetFillColor(24);
//============================================================================
//          Fit with average mass
//============================================================================
//float Mmin = 78.0;
//float Mmax = 82.2;
//int   Nbin = 40;
float Mmin = 74.0;
float Mmax = 84.0;
int   Nbin = 60;
//
TPad pad1("pad1","This is pad1", .00,.00, .50, 1.00, 5, 0, 0);
pad1.SetFillColor(0);
pad1.Draw();
pad1.cd();
// 
//-------------------------------------------------
// define fitting BW function with 3 parameters
TF1 brwig1("brwig1",
   "[2]*sq(x)*sq([0])/(sq(sq(x)-sq([0])) +sq([0]*[1])) +[3]+x*[4]+x*x*[5]"
   ,Mmin,Mmax);
brwig1.SetParameters(80.0, 2.0, 1.0, 0.0, 0.0, 0.0);
brwig1.SetLineColor(2);
brwig1.SetLineWidth(4);
//-------------------------------[[[[[[[
//   Why this does not work?????
//TFormula FitJet("FitJet","[0]+ sq(x)*sq([1])/(sq(sq(x)-sq([1]))+sq([1]*[2]))");
//TF1 bwig1("bwig1","FitJet",Mmin,Mmax);
//-------------------------------]]]]]]]
//----------------------------------------------------------------------
//----------------------------------------------------------------------
// get histo from ntuple
MasW_avg_cut = new TH1F("MasW_avg_cut"," B.E. OFF ", Nbin,Mmin,Mmax);
MasW_avg_cut.SetLabelSize(0.035);
jtuple.Draw("0.5*(x0+x1) >>MasW_avg_cut","(abs(x0-x1)<10.0)*(nj==4)","goff");
jtuple.Draw("0.5*(x2+x3)>>+MasW_avg_cut","(abs(x2-x3)<10.0)*(nj==4)","goff");
jtuple.Draw("0.5*(x4+x5)>>+MasW_avg_cut","(abs(x4-x5)<10.0)*(nj==4)","goff");
//----------------------------------------------------------------------
//----------------------------------------------------------------------
// fit histogram and plot results
MasW_avg_cut.Fit("brwig1");
MasW_avg_cut->SetLabelSize(0.035,"X");
MasW_avg_cut->SetLabelSize(0.030,"Y");
MasW_avg_cut.Draw();
//----------------------------------------------------------------------
float  MassW1 = brwig1.GetParameter(0);
float dMassW1 = brwig1.GetParError(0);
float  GammW1 = brwig1.GetParameter(1);
float dGammW1 = brwig1.GetParError(1);
TPaveText fitlabel( .20,.30 , (.20+.70),(.30+.12) ,"NDC");
fitlabel.SetTextAlign(12);
fitlabel.SetFillColor(42);
char mytext[200];
sprintf(mytext,"   Results of the fit: ");
fitlabel.AddText(mytext);
sprintf(mytext,"MassW = %7.3f +-%7.3f " ,MassW1,dMassW1);
fitlabel.AddText(mytext);
sprintf(mytext,"GammW = %7.3f +-%7.3f " ,GammW1,dGammW1);
fitlabel.AddText(mytext);
fitlabel.SetBorderSize(1);
fitlabel.SetFillColor(0);
fitlabel.Draw();
//
labelA.Draw();
label2.Draw();
//     Why this not work ????
//TPaveLabel label7(0.4,0.8,0.9,0.95,"Average Mass");
//label7.SetFillColor(42);
//label7.Draw();
//
cFitJetBE.Update();
//============================================================================
//============================================================================
//  Fit with avg  mass WEIGHTED
//============================================================================
//
cFitJetBE.cd();
TPad pad2("pad2","This is pad2", .50,.00,  1.0, 1.0, 5, 0, 0);
pad2.SetFillColor(0);
pad2.Draw();
pad2.cd();
//
//------------------------------------------------
// define fitting BW function with 3 parameters
TF1 brwig2("brwig2",
  "[2]*sq(x)*sq([0])/(sq(sq(x)-sq([0])) +sq([0]*[1])) +[3]+x*[4]+x*x*[5]"
  ,Mmin,Mmax);
brwig2.SetParameters(80.0, 2.0, 1.0, 0.0, 0.0, 0.0);
brwig2.SetLineWidth(4);
brwig2.SetLineColor(3);
//----------------------------------------------------------------------
//----------------------------------------------------------------------
// get WEIGHTED histo from ntuple
MasW_avg_wt = new TH1F("MasW_avg_wt"," B.E. ON ", Nbin,Mmin,Mmax);
MasW_avg_wt->SetLabelSize(0.035);
jtuple.Draw("0.5*(x0+x1) >>MasW_avg_wt",
	    "(abs(x0-x1)<10.0)*(nj==4)*wt2*exp(-np*log(1.0))","goff");
jtuple.Draw("0.5*(x2+x3)>>+MasW_avg_wt",
	    "(abs(x2-x3)<10.0)*(nj==4)*wt2*exp(-np*log(1.0))","goff");
jtuple.Draw("0.5*(x4+x5)>>+MasW_avg_wt",
	    "(abs(x4-x5)<10.0)*(nj==4)*wt2*exp(-np*log(1.0))","goff");
//----------------------------------------------------------------------
//----------------------------------------------------------------------
// fit histogram and plot results
MasW_avg_wt.Fit("brwig2");
MasW_avg_wt->SetLabelSize(0.035,"X");
MasW_avg_wt->SetLabelSize(0.030,"Y");
MasW_avg_wt.Draw();
//---------------------
float  MassW2 = brwig2.GetParameter(0);
float dMassW2 = brwig2.GetParError(0);
float  GammW2 = brwig2.GetParameter(1);
float dGammW2 = brwig2.GetParError(1);
TPaveText fitlabel2( .20,.30 , (.20+.70),(.30+.12) ,"NDC");
fitlabel2.SetTextAlign(12);
fitlabel2.SetFillColor(42);
char mytext[200];
sprintf(mytext,"   Results of the fit: ");
fitlabel2.AddText(mytext);
sprintf(mytext,"MassW = %7.3f +-%7.3f " ,MassW2,dMassW2);
fitlabel2.AddText(mytext);
sprintf(mytext,"GammW = %7.3f +-%7.3f " ,GammW2,dGammW2);
fitlabel2.AddText(mytext);
fitlabel2.SetBorderSize(1);
fitlabel2.SetFillColor(0);
fitlabel2.Draw();
//
labelB.Draw();
label2.Draw();
//
cFitJetBE.Update();
cFitJetBE.cd();
}
