//=================================================================
// .x  view-FitPJa.C
//
// Ntuple jtuple with parton-parton masses produced using KORALW Monte Carlo
//=================================================================
{
//
gROOT->Reset();
gStyle->SetOptStat(0);   // to get rid of statistics!!!
gStyle->SetOptTitle(0);  // to get rid of title!!!
//
TPaveText label2( .20,.00, .80,.05, "NDC");
label2.AddText("Average Mass [GeV]");
label2.SetFillColor(0);
label2.SetBorderSize(0);
//
TPaveLabel  labelA(.00,.92,1.0,1.0,"(a) QUARKS: |M?i!-M?j!|<5GeV","NDC");
labelA.SetBorderSize(0);
labelA.SetFillColor(0);
TPaveLabel  labelB(.00,.92,1.0,1.0,"(b) JETS: |M?i!-M?j!|<10GeV","NDC");
labelB.SetBorderSize(0);
labelB.SetFillColor(0);
//------------------------------------------------------------------------
//------------------------------------------------------------------------
cFitPJa = new TCanvas("cFitPJa","The W mass fit",1000,800);
//
//------------------------------------------------------------------------
// Connect ROOT histogram/ntuple demonstration file
TFile f1("../run/172GeV.4J/rmain.root");
//TFile f1("../run/172GeV.4J/rmain.root.160k");
//------------------------------------------------------------------------
//
//float Mmin = 78.0;
//float Mmax = 82.0;
//int   Nbin = 40;
float Mmin = 74.0;
float Mmax = 84.0;
int   Nbin = 60;
//------------------------------------------------------------------------
jtuple.SetFillColor(5);
jtuple.SetMarkerColor(2);
jtuple.SetLineColor(1);
jtuple.SetFillStyle(1001);
jtuple.SetFillColor(24);
//************************************************************************
//************************************************************************
cFitPJa.cd();
cFitPJa.SetFillColor(5);
TPad pad1("pad1","This is pad1", .00,.00, .50, 1.00, 5, 0, 0);
pad1.SetFillColor(0);
pad1.Draw();
pad1.cd();
//-------
// define BW function with 3 parameters
TF1 brwig1("brwig1",
     "[2]*sq(x)*sq([0])/(sq(sq(x)-sq([0])) +sq([0]*[1])) +[3]+x*[4]+x*x*[5]",
     Mmin,Mmax);
brwig1.SetParameters(80.0, 2.0, 1.0, 0.0, 0.0, 0.0);
brwig1.SetLineWidth(4);
brwig1.SetLineColor(2);
//   Why this does not work?????
//TFormula FitPJa("FitPJa","[0]+ sq(x)*sq([1])/(sq(sq(x)-sq([1])) +sq([1]*[2]))");
//TF1 bwig1("bwig1","FitPJa",Mmin,Mmax);
//-------
// get histogram from ntuple
mass_all_cut = new TH1F("mass_all_cut","QUARKS: |Mi-Mj|<5GeV", Nbin,Mmin,Mmax);
//
jtuple.Draw("0.5*(m0+m1)>>mass_all_cut", "(abs(m0-m1)<5.0)","");
jtuple.Draw("0.5*(m2+m3)>>+mass_all_cut","(abs(m2-m3)<5.0)","goff");
jtuple.Draw("0.5*(m4+m5)>>+mass_all_cut","(abs(m4-m5)<5.0)","goff");
//
mass_all_cut->SetLabelSize(0.04,"X");
mass_all_cut->SetLabelSize(0.022,"Y");
//-------
// fit histogram and write fitted parameters
mass_all_cut.Fit("brwig1");
// plot results
mass_all_cut.Draw();
//
//-------------------------
float  MassW1 = brwig1.GetParameter(0);
float dMassW1 = brwig1.GetParError(0);
float  GammW1 = brwig1.GetParameter(1);
float dGammW1 = brwig1.GetParError(1);
TPaveText fitlabel( .20,.30 , (.20+.70),(.30+.12) ,"NDC");
fitlabel.SetTextAlign(12);
fitlabel.SetFillColor(42);
char mytext[200];
sprintf(mytext,"   Results of the fit: ");
fitlabel.AddText(mytext);
sprintf(mytext,"MassW = %7.3f +-%7.3f " ,MassW1,dMassW1);
fitlabel.AddText(mytext);
sprintf(mytext,"GammW = %7.3f +-%7.3f " ,GammW1,dGammW1);
fitlabel.AddText(mytext);
fitlabel.SetBorderSize(1);
fitlabel.SetFillColor(0);
fitlabel.Draw();
label2.Draw();
labelA.Draw();
//
cFitPJa.Update();
//************************************************************************
cFitPJa.cd();
//************************************************************************
TPad pad2("pad2","This is pad2", .50,.00, 1.00,1.00, 5, 0, 0);
pad2.SetFillColor(0);
pad2.Draw();
pad2.cd();
// 
//-------------------------------------------------
// define fitting BW function with 3 parameters
TF1 brwig1("brwig1",
   "[2]*sq(x)*sq([0])/(sq(sq(x)-sq([0])) +sq([0]*[1])) +[3]+x*[4]+x*x*[5]"
   ,Mmin,Mmax);
brwig1.SetParameters(80.0, 2.0, 1.0, 0.0, 0.0, 0.0);
brwig1.SetLineWidth(4);
brwig1.SetLineColor(3);
//   Why this does not work?????
//TFormula FitJet("FitJet","[0]+ sq(x)*sq([1])/(sq(sq(x)-sq([1]))+sq([1]*[2]))");
//TF1 bwig1("bwig1","FitJet",Mmin,Mmax);
//----------------------------------------------------------------------
//----------------------------------------------------------------------
// get histo from ntuple
MasW_avg_cut = new TH1F("MasW_avg_cut","JETS: |Mi-Mj|<10GeV", Nbin,Mmin,Mmax);
MasW_avg_cut->SetLabelSize(0.035);
jtuple.Draw("0.5*(x0+x1)>>MasW_avg_cut","(abs(x0-x1)<10.0)*(nj==4)","goff");
jtuple.Draw("0.5*(x2+x3)>>+MasW_avg_cut","(abs(x2-x3)<10.0)*(nj==4)","goff");
jtuple.Draw("0.5*(x4+x5)>>+MasW_avg_cut","(abs(x4-x5)<10.0)*(nj==4)","goff");
//----------------------------------------------------------------------
//----------------------------------------------------------------------
// fit histogram and write fitted parameters
//-------------------------
MasW_avg_cut.Fit("brwig1");
//------------------
// plot results
MasW_avg_cut->SetLabelSize(0.04,"X");
MasW_avg_cut->SetLabelSize(0.025,"Y");
MasW_avg_cut.Draw();
//-------------------------
float  MassW1 = brwig1.GetParameter(0);
float dMassW1 = brwig1.GetParError(0);
float  GammW1 = brwig1.GetParameter(1);
float dGammW1 = brwig1.GetParError(1);
TPaveText fitlabel2( .20,.30 , (.20+.70),(.30+.12) ,"NDC");
fitlabel2.SetTextAlign(12);
fitlabel2.SetFillColor(42);
char mytext[200];
sprintf(mytext,"   Results of the fit: ");
fitlabel2.AddText(mytext);
sprintf(mytext,"MassW = %7.3f +-%7.3f " ,MassW1,dMassW1);
fitlabel2.AddText(mytext);
sprintf(mytext,"GammW = %7.3f +-%7.3f " ,GammW1,dGammW1);
fitlabel2.AddText(mytext);
fitlabel2.SetBorderSize(1);
fitlabel2.SetFillColor(0);
fitlabel2.Draw();
//
label2.Draw();
labelB.Draw();
//
cFitPJa.Update();
cFitPJa.cd();
}
