//=================================================================
// .x view-FitPJb.C
// TWO CHOICES OF MW, (wt=1 case)
// I fit W mass using either m0 or (m0+m1)/2 with cut on abs(m0-m1)
// Ntuple jtuple with parton-parton masses produced using KORALW Monte Carlo
// Problems are marked with ???
//=================================================================
{
//
gROOT->Reset();
cFitPJb = new TCanvas("cFitPJb","The W mass fit",1000,800);
//----------------------------------------------------------------------------
// Connect ROOT histogram/ntuple demonstration file
//
//TFile f1("../172GeV.4J.mini/rmain.root");
TFile f1("../172GeV.4J/rmain.root.40k");
//TFile f1("../172GeV.4J/rmain.root");
//TFile f1("rmain.root.172GeV.4J.40k.isr");
//TFile f1("rmain.root.172GeV.4J.40k.isr1");
//TFile f1("rmain.root.172GeV.4J.40k.reco");
//----------------------------------------------------------------------------
cFitPJb.cd();
cFitPJb.SetFillColor(0);
cFitPJb.SetBorderSize(0);
jtuple.SetFillColor(5);
jtuple.SetMarkerColor(2);
jtuple.SetLineColor(1);
jtuple.SetFillStyle(1001);
jtuple.SetFillColor(24);
//
float Mmin = 76.0;
float Mmax = 85.0;
int Nbin = 40;
//============================================================================
//============================================================================
//          QUARKS
//============================================================================
TPad pad1("pad1","This is pad1", .00,.00, .50,1.00);
pad1.SetFillColor(10);
pad1.Draw();
pad1.cd();
//
//-------
// define BW function with 3 parameters
TF1 brwig2("brwig2","[2]*sq(x)*sq([0])/(sq(sq(x)-sq([0])) +sq([0]*[1]))"
           ,Mmin,Mmax);
brwig2.SetParameters(80.0, 2.0, 1.0);
brwig2.SetLineWidth(2);
brwig2.SetLineColor(2);
//
//-------
// get histogram from ntuple
jtuple.SetFillColor(5);
jtuple.SetMarkerColor(2);
jtuple.SetLineColor(1);
jtuple.SetFillStyle(1001);
jtuple.SetFillColor(24);
mass_all_cut2=new TH1F("mass_all_cut2","QUARKS: |Mi-Mj|<5GeV", Nbin,Mmin,Mmax);
#if ( swiWT == 0 )
jtuple.Draw("m0>>mass_all_cut2", "(abs(m0-m1)<5.0)","goff");
jtuple.Draw("m2>>+mass_all_cut2","(abs(m2-m3)<5.0)","goff");
jtuple.Draw("m2>>+mass_all_cut2","(abs(m4-m5)<5.0)","goff");
mass_all_cut2.Draw("");
#else
jtuple.Draw("m0>>mass_all_cut2", "wt*(abs(m0-m1)<5.0)","goff");
jtuple.Draw("m2>>+mass_all_cut2","wt*(abs(m2-m3)<5.0)","goff");
jtuple.Draw("m2>>+mass_all_cut2","wt*(abs(m4-m5)<5.0)","goff");
mass_all_cut2.Draw("");
#endif
//-------
// fit histogram and write fitted parameters
mass_all_cut2.Fit("brwig2");
// plot results
mass_all_cut2.Draw();
//
//---------------------
float  MassW2 = brwig2.GetParameter(0);
float dMassW2 = brwig2.GetParError(0);
float  GammW2 = brwig2.GetParameter(1);
float dGammW2 = brwig2.GetParError(1);
TPaveText fitlabel1( .32,.17 , (.30+.70),(.17+.12) ,"NDC");
fitlabel1.SetTextAlign(12);
fitlabel1.SetFillColor(42);
char mytext[200];
sprintf(mytext,"   Results of the fit: ");
fitlabel1.AddText(mytext);
sprintf(mytext,"MassW = %7.3f +-%7.3f " ,MassW2,dMassW2);
fitlabel1.AddText(mytext);
sprintf(mytext,"GammW = %7.3f +-%7.3f " ,GammW2,dGammW2);
fitlabel1.AddText(mytext);
fitlabel1.SetBorderSize(1);
fitlabel1.Draw();
//
TPaveText label1( .35,.00, .65,.05, "NDC");
label1.AddText("Single Mass");
label1.SetFillColor(10);
label1.SetBorderSize(0);
label1.Draw();
//
//
cFitPJb.Update();
//============================================================================
//============================================================================
//  Fit with single mass
//============================================================================
//
cFitPJb.cd();
TPad pad2("pad2","This is pad2", .50,.00, 1.00,1.00);
pad2.SetFillColor(10);
pad2.Draw();
pad2.cd();
//------------------------------------------------
// define fitting BW function with 3 parameters
TF1 brwig2("brwig2","[2]*sq(x)*sq([0])/(sq(sq(x)-sq([0])) +sq([0]*[1]))"
           ,Mmin,Mmax);
brwig2.SetParameters(80.0, 2.0, 1.0);
brwig2.SetLineWidth(4);
brwig2.SetLineColor(2);
//----------------------------------------------------------------------
//----------------------------------------------------------------------
// get histo from ntuple
MasW_sng_cut = new TH1F("MasW_sng_cut","JETS: |Mi-Mj|<10GeV", Nbin,Mmin,Mmax);
MasW_sng_cut->SetLabelSize(0.035);
jtuple.Draw("x0 >>MasW_sng_cut","(abs(x0-x1)<10.0)*(nj==4)","goff");
jtuple.Draw("x1>>+MasW_sng_cut","(abs(x0-x1)<10.0)*(nj==4)","goff");
jtuple.Draw("x2>>+MasW_sng_cut","(abs(x2-x3)<10.0)*(nj==4)","goff");
jtuple.Draw("x3>>+MasW_sng_cut","(abs(x2-x3)<10.0)*(nj==4)","goff");
jtuple.Draw("x4>>+MasW_sng_cut","(abs(x4-x5)<10.0)*(nj==4)","goff");
jtuple.Draw("x5>>+MasW_sng_cut","(abs(x4-x5)<10.0)*(nj==4)","goff");
//----------------------------------------------------------------------
//----------------------------------------------------------------------
// fit histogram and write fitted parameters
MasW_sng_cut.Fit("brwig2");
//---------------------
// plot results
MasW_sng_cut.Draw();
//------------------------------------------
float  MassW2 = brwig2.GetParameter(0);
float dMassW2 = brwig2.GetParError(0);
float  GammW2 = brwig2.GetParameter(1);
float dGammW2 = brwig2.GetParError(1);
TPaveText fitlabel2( .32,.17 , (.30+.70),(.17+.12) ,"NDC");
fitlabel2.SetTextAlign(12);
fitlabel2.SetFillColor(42);
char mytext[200];
sprintf(mytext,"   Results of the fit: ");
fitlabel2.AddText(mytext);
sprintf(mytext,"MassW = %7.3f +-%7.3f " ,MassW2,dMassW2);
fitlabel2.AddText(mytext);
sprintf(mytext,"GammW = %7.3f +-%7.3f " ,GammW2,dGammW2);
fitlabel2.AddText(mytext);
fitlabel2.SetBorderSize(1);
fitlabel2.Draw();
//
TPaveText label2( .35,.00, .65,.05, "NDC");
label2.AddText("Single Mass");
label2.SetFillColor(10);
label2.SetBorderSize(0);
label2.Draw();
//
cFitPJb.Update();
cFitPJb.cd();
}
