//=================================================================
// .x  view-FitPar.C
// PARTON LEVEL fit to W mass using either m0 or (m0+m1)/2; cut abs(m0-m1)
// Weghting or not: swiWT=0 is for wt=1, swiWT=0 for wt=wtBE
//
// Ntuple jtuple with parton-parton masses produced using KORALW Monte Carlo
//=================================================================
{
//
gROOT->Reset();
//
//----------------------------------------------------------------------------
cFitPar = new TCanvas("cFitPar","The W mass fit",1000,800);
//
//------------------------------------------------------------------------
// Connect ROOT histogram/ntuple demonstration file
TFile f1("../run/172GeV.4J/rmain.root.160k");
//
// Weghting or not: 
// swiWT=0    for  wt=1, 
// swiWT=1    for  wt=wtBE
#define swiWT 0
//#define swiWT 1
//------------------------------------------------------------------------
//
//float Mmin = 78.0;
//float Mmax = 82.0;
//int   Nbin = 40;
float Mmin = 74.0;
float Mmax = 84.0;
int   Nbin = 60;
//------------------------------------------------------------------------
jtuple.SetFillColor(5);
jtuple.SetMarkerColor(2);
jtuple.SetLineColor(1);
jtuple.SetFillStyle(1001);
jtuple.SetFillColor(24);
//------------------------------------------------------------------------
//------------------------------------------------------------------------
cFitPar.cd();
cFitPar.SetFillColor(5);
TPad pad1("pad1","This is pad1", .00,.00, .50, 1.00);
pad1.SetFillColor(10);
pad1.Draw();
pad1.cd();
//-------
// define BW function with 3 parameters
TF1 brwig1("brwig1",
   "[2]*sq(x)*sq([0])/(sq(sq(x)-sq([0])) +sq([0]*[1])) +[3]+x*[4]+x*x*[5]"
   ,Mmin,Mmax);
brwig1.SetParameters(80.0, 2.0, 1.0, 0.0, 0.0, 0.0);
brwig1.SetLineWidth(2);
brwig1.SetLineColor(2);
//   Why this does not work?????
//TFormula FitPar("FitPar","[0]+ sq(x)*sq([1])/(sq(sq(x)-sq([1])) +sq([1]*[2]))");
//TF1 bwig1("bwig1","FitPar",Mmin,Mmax);
//-------
// get histogram from ntuple
mass_all_cut = new TH1F("mass_all_cut","Case: Average Mass", Nbin,Mmin,Mmax);
#if ( swiWT == 0 )
//
jtuple.Draw("0.5*(m0+m1)>>mass_all_cut", "(abs(m0-m1)<5.0)","");
jtuple.Draw("0.5*(m2+m3)>>+mass_all_cut","(abs(m2-m3)<5.0)","goff");
jtuple.Draw("0.5*(m4+m5)>>+mass_all_cut","(abs(m4-m5)<5.0)","goff");
//
#else
jtuple.Draw("0.5*(m0+m1)>>mass_all_cut",
	    "(abs(m0-m1)<5.0)*wt2*exp(-np*log(0.999))","");
jtuple.Draw("0.5*(m2+m3)>>+mass_all_cut",
	    "(abs(m2-m3)<5.0)*wt2*exp(-np*log(0.999))","goff");
jtuple.Draw("0.5*(m4+m5)>>+mass_all_cut",
	    "(abs(m4-m5)<5.0)*wt2*exp(-np*log(0.999))","goff");
#endif
mass_all_cut.Draw("");
//-------
// fit histogram and write fitted parameters
mass_all_cut.Fit("brwig1");
// plot results
mass_all_cut.Draw();
//
//-------------------------
float  MassW1 = brwig1.GetParameter(0);
float dMassW1 = brwig1.GetParError(0);
float  GammW1 = brwig1.GetParameter(1);
float dGammW1 = brwig1.GetParError(1);
TPaveText fitlabel( .20,.30 , (.20+.70),(.30+.12) ,"NDC");
fitlabel.SetTextAlign(12);
fitlabel.SetFillColor(42);
char mytext[200];
sprintf(mytext,"   Results of the fit: ");
fitlabel.AddText(mytext);
sprintf(mytext,"MassW = %7.3f +-%7.3f " ,MassW1,dMassW1);
fitlabel.AddText(mytext);
sprintf(mytext,"GammW = %7.3f +-%7.3f " ,GammW1,dGammW1);
fitlabel.AddText(mytext);
fitlabel.SetBorderSize(1);
fitlabel.Draw();
//
TPaveText label1( .35,.00, .65,.05, "NDC");
label1.AddText("Average Mass");
label1.SetFillColor(10);
label1.SetBorderSize(0);
label1.Draw();
//
//TPaveLabel label2(0.4,0.8,0.9,0.95,"Average Mass");
//label2.SetFillColor(42);
//label2.Draw();
//
cFitPar.Update();
//************************************************************************
//************************************************************************
cFitPar.cd();
TPad pad2("pad2","This is pad2", .50,.00, 1.00,1.00);
pad2.SetFillColor(10);
pad2.Draw();
pad2.cd();
//-------
// define BW function with 3 parameters
TF1 brwig2("brwig2",
   "[2]*sq(x)*sq([0])/(sq(sq(x)-sq([0])) +sq([0]*[1])) +[3]+x*[4]+x*x*[5]",
   Mmin,Mmax);
brwig2.SetParameters(80.0, 2.0, 1.0, 0.0, 0.0, 0.0);
brwig2.SetLineWidth(2);
brwig2.SetLineColor(2);
//
//-------
// get histogram from ntuple
mass_all_cut2 = new TH1F("mass_all_cut2","Case: Single Mass", Nbin,Mmin,Mmax);
#if ( swiWT == 0 )
jtuple.Draw("m0>>mass_all_cut2", "(abs(m0-m1)<5.0)","goff");
jtuple.Draw("m2>>+mass_all_cut2","(abs(m2-m3)<5.0)","goff");
jtuple.Draw("m4>>+mass_all_cut2","(abs(m4-m5)<5.0)","goff");
mass_all_cut2.Draw("");
#else
jtuple.Draw("m0>>mass_all_cut2", 
	    "(abs(m0-m1)<5.0)*wt2*exp(-np*log(1.0))","goff");
jtuple.Draw("m2>>+mass_all_cut2",
	    "(abs(m2-m3)<5.0)*wt2*exp(-np*log(1.0))","goff");
jtuple.Draw("m4>>+mass_all_cut2",
	    "(abs(m4-m5)<5.0)*wt2*exp(-np*log(1.0))","goff");
mass_all_cut2.Draw("");
#endif
//-------
// fit histogram and write fitted parameters
mass_all_cut2.Fit("brwig2");
// plot results
mass_all_cut2.Draw();
//
//---------------------
float  MassW2 = brwig2.GetParameter(0);
float dMassW2 = brwig2.GetParError(0);
float  GammW2 = brwig2.GetParameter(1);
float dGammW2 = brwig2.GetParError(1);
TPaveText fitlabel2( .20,.30 , (.20+.70),(.30+.12) ,"NDC");
fitlabel2.SetTextAlign(12);
fitlabel2.SetFillColor(42);
char mytext[200];
sprintf(mytext,"   Results of the fit: ");
fitlabel2.AddText(mytext);
sprintf(mytext,"MassW = %7.3f +-%7.3f " ,MassW2,dMassW2);
fitlabel2.AddText(mytext);
sprintf(mytext,"GammW = %7.3f +-%7.3f " ,GammW2,dGammW2);
fitlabel2.AddText(mytext);
fitlabel2.SetBorderSize(1);
fitlabel2.Draw();
//
TPaveText label2( .35,.00, .65,.05, "NDC");
label2.AddText("Single Mass");
label2.SetFillColor(10);
label2.SetBorderSize(0);
label2.Draw();
//
cFitPar.Update();
cFitPar.cd();
}
