#ifndef JetAnalyzer_H
#define JetAnalyzer_H
///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                CLASS JetAnalyzer                                          //
//                                                                           //
//    Constructs 4 Jets in double W decay final state                        //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

#include "TROOT.h"
#include "TFile.h"
#include "TProfile.h"
#include "TNtuple.h"
#include "TProfile.h"

#include <iostream.h>
#include <fstream.h>

#include "KorEvent.h"
#include "JetAnalyzer.h"

class JetAnalyzer : public TNamed {
public:
//
   TH1F      *hst_pene;     // histo:  parton minimum energy
   TH1F      *hst_jene;     // histo:  jet minimum energy
   TNtuple   *jtuple;       // ntuple: big ntuple with jet masses etc
//
public:
  JetAnalyzer();
  ~JetAnalyzer() {;}
public:
//////////////////////////////////////////////////////////////////////////////
void JetAnalyzer::Book(KorEvent &event,
			long ntot, double wt, double wt2);
////////////////////////////////////////////////////////////////////////////
   ClassDef(JetAnalyzer,1)    // Construction of 4 Jets in double W decay final state

};
////////////////////////////////////////////////////////////////////////////
#endif
