      PROGRAM  main
*/////////////////////////////////////////////////////////////////////
*//   To execute:  make KWdemo2HADR                                 //
*//                make KWdemo2SEMI                                 //
*//                                                                 //
*//   Generally user is supposed to provide his/her own main        //
*//   program. Neverthels we provide simple 2 examples of the       //
*//   main program This is SECOND of them.                          //
*//   Its role is: (1) useful template                              //
*//                (2) 1-st time check that program runs correctly. //
*//                                                                 //
*//   The essential part of this program is loop in which series    //
*//   of KORALW events is produced. The example of HISTOGRAMING     //
*//   with proper normalization is also shown!!!                    //
*//                                                                 //
*//   Two data sets are provided for separate 2 runs:               //
*//   KWdemo2.input.HADR                                            //
*//      CC03 "signal" process is simulated, (internal matrix       //
*//      element), ISR is on, four-quark chanel only - selected     //
*//      with Umask matrix. WtMain = 1 events.                      //
*//                                                                 //
*//   KWdemo2.input.SEMI                                            //
*//      CC03 "signal" process is simulated, (internal matrix       //
*//      element), ISR is on,                                       //
*//      Anomalous triple gauge boson coupling constants!           //
*//      see data file, semi-leptonic chanel only - selected        //
*//      with Umask matrix. WtMain is varying.                      //
*//                                                                 //
*/////////////////////////////////////////////////////////////////////
      IMPLICIT NONE
      SAVE
*
* Common block for Robol
      COMMON / inout  / ninp,nout
      INTEGER           ninp,nout
*
      INTEGER      iMax
      PARAMETER    (iMax=10000)
      REAL*8       xpar(iMax)
*
      CHARACTER*80 DiskFile
      INTEGER      iReset,iTalk
      INTEGER      NevTot
*
      INTEGER  loop, loop2, Iev, i
*///////////////////////////////////////////////////////////////
*//        Define output/input files                          //
*///////////////////////////////////////////////////////////////
      ninp= 5
      nout=16                      ! Default in KoralW is nout=16
      OPEN(nout,file='KWdemo2.output')
      CALL LuGive("MSTU(11)=16;")  ! Output unit for Jetset
*///////////////////////////////////////////////////////////////
      WRITE(NOUT,*) '   '
      WRITE(NOUT,*) '=============================================='
      WRITE(NOUT,*) '==========/////////////////////==============='
      WRITE(NOUT,*) '==========///     KWdemo2   ///==============='
      WRITE(NOUT,*) '==========/////////////////////==============='
      WRITE(NOUT,*) '=============================================='
      WRITE(NOUT,*) '   '
*///////////////////////////////////////////////////////////////
*//        Read header of input data file                     //
*///////////////////////////////////////////////////////////////
      DiskFile = './KWdemo2.input'
      OPEN( ninp,file=DiskFile)
      READ( ninp,'(I10)')  NevTot
      CLOSE(ninp)
* some printouts
      WRITE( 6,*)     NevTot,' REQUESTED EVENTS '
      WRITE(NOUT,*)   NevTot,' REQUESTED EVENTS '
*---------------------------------------------------------------
*///////////////////////////////////////////////////////////////
*//        Read DEFAULT input data file                       //
*///////////////////////////////////////////////////////////////
      DiskFile = './data_DEFAULTS'
      iReset   = 1              ! <-- xpar is defined/reset
      CALL KW_ReaDataX( DiskFile,    iReset, iMax, xpar)
*///////////////////////////////////////////////////////////////
*//        Read input data file for THIS test                 //
*///////////////////////////////////////////////////////////////
      DiskFile = './KWdemo2.input'
      iReset   = 0              ! <-- xpar modified selectively
      CALL KW_ReaDataX(  DiskFile,   iReset, iMax, xpar)
*///////////////////////////////////////////////////////////////
*//       Optional reading of mask matrix                     //
*// It is not necessary, default value in xpar is provided    //
*// Here Umask is in the same input file                      //
*///////////////////////////////////////////////////////////////
      DiskFile = './KWdemo2.input'
      iTalk    = 1
      CALL KW_ReadMask( DiskFile, iTalk, xpar)
*==============================================================
      CALL KW_Initialize(xpar)
*     ************************
      CALL Robol (-1,xpar)
      Iev=0
      DO loop=1,1000
         DO loop2=1,1000000
            Iev=Iev+1
            IF(MOD(Iev,2000) .EQ. 1) WRITE(6,*) '  Iev= ',Iev
            CALL KW_Make
*           ************
            CALL Robol ( 0,xpar)
            IF(Iev .LE. 2) CALL lulist(2)
            IF(Iev .GE. NevTot) GOTO 103
         ENDDO
      ENDDO
 103  CONTINUE
*==============================================================
      WRITE(6,*) 'Generation finished '
      CALL KW_Finalize
*     ****************
      CALL Robol( 1,xpar)
      END


      SUBROUTINE Robol(imod,xpar)
*///////////////////////////////////////////////////////////////////
*//                                                               //
*//   User subprogram with histogramming                          //
*//                                                               //
*///////////////////////////////////////////////////////////////////
      IMPLICIT NONE
*
      SAVE
      REAL*8  xpar(*)
      INTEGER imod
*////////////////////////////////////////////////////////////////////
*     I/O units
      COMMON / inout / ninp,nout
      INTEGER          ninp,nout
*////////////////////////////////////////////////////////////////////
*//               HEPDATA  REAL*4  2k entries                      //  
*////////////////////////////////////////////////////////////////////
      INTEGER nmxhep         ! maximum number of particles
      PARAMETER (nmxhep=2000)
      REAL*4  phep, vhep
      INTEGER nevhep, nhep, isthep, idhep, jmohep, jdahep
      COMMON /hepevt/
     $     nevhep,           ! serial number
     $     nhep,             ! number of particles
     $     isthep(nmxhep),   ! status code
     $     idhep(nmxhep),    ! particle ident KF
     $     jmohep(2,nmxhep), ! parent particles
     $     jdahep(2,nmxhep), ! childreen particles
     $     phep(5,nmxhep),   ! four-momentum, mass [GeV]
     $     vhep(4,nmxhep)    ! vertex [mm]
      SAVE /hepevt/
*////////////////////////////////////////////////////////////////////
      REAL*8   WtCrud,WtMain,WtSet(100)
*////////////////////////////////////////////////////////////////////
      CHARACTER*80     bxope,bxl1f,bxl2f,bxclo,bxtxt,bxl1i
      PARAMETER(
     $bxope =  '(//1X,15(5H#####)    )',
     $bxclo =  '(1X,15(5H#####)/   )',
     $bxtxt =  '(1X,1H*,                  A48,25X,    1H*)',
     $bxl1f =  '(1X,1H#,F17.8,               16X, A20,A12,A7, 1X,1H#)',
     $bxl2f =  '(1X,1H#,F17.8, 4H  +-, F11.8, 1X, A20,A12,A7, 1X,1H#)',
     $bxl1i =  '(1X,1H*,I17,                 16X, A20,A12,A7, 1X,1H*)'
     $         )
*---------------------------------------------------------------------
      REAL*8   p1(4),p2(4),p3(4),p4(4)
      REAL*8   pout(4),wp(4)
      REAL*8   MassW,GammW,svar,cthe1,cthe3,vv,s1
      REAL*8   CMSene,vvmax,sprim
      REAL*8   XSecNR,XErrNR,XsecMC,XErrMC,XsBre,ErBre
      REAL*8   averwt,errela,dumm3
      REAL*8   Xborn,ErBorn,Xtot3e,Erro3e
      INTEGER  nb,IdKar,IdBre,NevMC,KeyPho,KeyAcc
      INTEGER  i,j,k,id1,id2
      INTEGER  KeyWgt,KeyIsr,Key4f
      INTEGER  Icont
      DATA     Icont /0/
*---------------------------------------------------------------------
*  ############################
      IF (IMOD .EQ. -1) THEN
*  ############################
      CMSene = xpar(1)
      GammW  = ABS(xpar(7))
      MassW  = xpar(6)
      vvmax  = xpar(9)
      KeyISR =NINT(xpar(1011))
      KeyWgt =NINT(xpar(1031))
      Key4f  =NINT(xpar(1042))

      nb=40
      svar = CMSene**2
* histo id-s
      IdKar = 0
      IdBre = 1000
      IF(KeyISR .NE. 0) THEN
*   initialize average energy loss
         CALL gmonit(-1,IdBre+82,0d0,1d0,1d0) ! photon energy best ord exp
         CALL gmonit(-1,IdBre+86,0d0,1d0,1d0) ! principal weight
*   initialize energy loss histo
         CALL gbook1(IdBre+30,'dsig/dv best, exp $',nb,  0d0,vvmax)
      ENDIF
* initialize weight histo
      CALL gbook1(IdKar+12,'WtMain - best wt     $',nb,  0d0,10d0)
*   angular distribs, LAB
      CALL gbook1(IdKar+41,'dsig/dcth1 (p1) in LAB $',nb, -1d0,1d0)
      CALL gbook1(IdKar+43,'dsig/dcth2 (p3) in LAB $',nb, -1d0,1d0)
*   inv mass distr
      CALL gbook1(IdKar+35,'dsigma/dsqrt(s1) $', 50, -3*GammW,3*GammW)

*   ############################
      ELSEIF (imod .EQ. 0) THEN
*   ############################
*
* Get main MC weight and auxiliary weights from generator
      CALL KW_GetWtAll(WtMain,WtCrud,WtSet)
* Alternatively CALL KW_GetWtMain(WtMain) would do it also...
*
      IF(WtMain .NE. 0d0) THEN
*((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((
* dig out momenta p1,p2,p3,p4 of partons out of PDG common block
         DO k=1,4
            wp(k)=phep(k,3)
         ENDDO
         DO id1=5,nhep
            IF (idhep(id1) .NE. 22) THEN
               GOTO 8
            ENDIF
         ENDDO
 8       CONTINUE
         DO  k=1,4
            p1(k)=phep(k,id1)
            p2(k)=phep(k,id1+1)
         ENDDO
         DO id2=id1+2,nhep
            IF (idhep(id2) .NE. 22 ) THEN
               GOTO 18
            ENDIF
         ENDDO
 18      CONTINUE
         DO  K=1,4
            p3(k)=phep(k,id2)
            p4(k)=phep(k,id2+1)
         ENDDO
c))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
* Alternatively we may get p1,...,p4 directly using getter:
* Even better because REAL*8 !!!!
*             CALL KW_GetMomDec(p1,p2,p3,p4)
*----------------------------------------------------------
         DO I=1,4
            pout(i)=p1(i)+p2(i)+p3(i)+p4(i)
         ENDDO
         sprim = pout(4)**2 -pout(3)**2 -pout(2)**2 -pout(1)**2
         vv    = 1d0-sprim/svar
         s1    = ABS(wp(4)**2 -wp(3)**2 -wp(2)**2 -wp(1)**2)
         cthe1 = p1(3)/sqrt(p1(3)**2+p1(2)**2+p1(1)**2)
         cthe3 = p3(3)/sqrt(p3(3)**2+p3(2)**2+p3(1)**2)
      ELSE
         cthe1=0d0
         cthe3=0d0
         vv=0d0
         s1=0d0
      ENDIF
      IF(KeyISR .NE. 0) then
* phot. energy loss
         CALL gmonit(0,IdBre+82, WtMain*vv,  1d0,1d0)
         CALL gf1(IdBre+30,vv   ,WtMain*vv)
      ENDIF
* best weight
      CALL gmonit(0,IdBre+86,WtMain,  1d0,1d0)
      CALL gf1(IdKar+12,WtMain,1d0)
* angles
      CALL gf1(IdKar+41,cthe1,WtMain)
      CALL gf1(IdKar+43,cthe3,WtMain)
* inv mass
      CALL gf1(IdKar+35, SQRT(s1)-MassW, WtMain)
*  ############################
      ELSE
*  ############################
*///////////////////////////////////////////////////////////////////////
*// Normalization Xsection for histos and Number of events
*// XSecNR is good both for constant and variable weight run!
      CALL KW_GetNevMC(NevMC)
      CALL KW_GetXSecNR(XSecNR,XErrNR)
*///////////////////////////////////////////////////////////////////////
*// Main best Xsection form KoralW
      CALL KW_GetXSecMC(XSecMC,XErrMC)
      WRITE(nout,bxope)
      WRITE(nout,bxl1i) NevMC,         'No of events ','KORALW','<<'
      WRITE(nout,bxl2f) XsecMC,XErrMC, 'MC Best, xpar','KORALW','<<'
      WRITE(nout,bxl1f) XSecNR,        'XSecNR,  xpar','KORALW','<<'
      WRITE(nout,bxclo)
      WRITE(   6,bxope)
      WRITE(   6,bxl1i) NevMC,         'No of events ','KORALW','<<'
      WRITE(   6,bxl2f) XsecMC,XErrMC, 'MC Best, xpar','KORALW','<<'
      WRITE(   6,bxl1f) XSecNR,        'XSecNR,  xpar','KORALW','<<'
      WRITE(   6,bxclo)
*///////////////////////////////////////////////////////////////////////
*// Korwan: SemiAnalytical Born
      KeyPho=0
      KeyAcc=3
      CALL korwan(svar,0d0,vvmax,KeyPho,KeyAcc,Xborn,ErBorn)
      WRITE(nout,bxope)
      WRITE(   6,bxope)
      WRITE(nout,bxtxt) 'SEMIANALYTICAL calculations'
      WRITE(   6,bxtxt) 'SEMIANALYTICAL calculations'
      WRITE(   6,bxl2f) Xborn,ErBorn, 'Semianalyt.  Born ','KORWAN','<<'
      WRITE(nout,bxl2f) Xborn,ErBorn, 'Semianalyt.  Born ','KORWAN','<<'
*///////////////////////////////////////////////////////////////////////
*// Korwan: SemiAnalytical O(alf3)exp.
      IF(KeyISR .NE. 0) THEN
        KeyPho=303
        KeyAcc=1
        CALL korwan(svar,0d0,vvmax,KeyPho,KeyAcc,Xtot3e,Erro3e)
        WRITE(   6,bxl2f) 
     $       Xtot3e,Erro3e, 'SAN O(alf3)exp.LL','KORWAN','<<'
        WRITE(nout,bxl2f)
     $       Xtot3e,Erro3e, 'SAN O(alf3)exp.LL','KORWAN','<<'
      ENDIF
      WRITE(nout,bxclo)
      WRITE(   6,bxclo)
*///////////////////////////////////////////////////////////////////////
*//                Histograms from MC run                             // 
*///////////////////////////////////////////////////////////////////////
*  principal weight distribution
      CALL gprint(IdKar+12)
*  two angular distributions
      CALL HisNormalize(IdKar+41,NevMC,XSecNR,IdKar+41)
      CALL HisNormalize(IdKar+43,NevMC,XSecNR,IdKar+43)
      CALL gidopt(IdKar+41,'ERRO')
      CALL gidopt(IdKar+43,'ERRO')
      CALL gprint(IdKar+41)
      CALL gprint(IdKar+43)
*  W-mass distribution
      CALL HisNormalize(IdKar+35,NevMC,XSecNR,IdKar+35)
      CALL gidopt(IdKar+35,'ERRO')
      CALL gprint(IdKar+35)
*///////////////////////////////////////////////////////////////////////
      IF( KeyISR .NE. 0) THEN
* photon v-distribution
         CALL HisNormalize(IdBre+30,NevMC,XSecNR,IdBre+30)
         CALL gidopt(IdBre+30,'ERRO')
         CALL gprint(IdBre+30)
* average photon energy
         CALL gmonit(1,IdBre+82,averwt,errela,dumm3)
         XsBre  = averwt *sqrt(svar)/2d0
         ErBre  = XsBre* errela
         CALL gmonit(1,IdBre+86,averwt,errela,dumm3)
         WRITE(nout,bxope)
         WRITE(nout,bxl2f)
     $        XsBre/averwt,ErBre/averwt, '<E_gamma, exp>','KORALW','<<'
         WRITE(nout,bxclo)
      ENDIF
*  ############################
      ENDIF
*  ############################
      END

      SUBROUTINE HisNormalize(id1,NevMC,XSecNR,id2)
*//////////////////////////////////////////////////////////
*//   This routine re-normalizes histogram to XSecNR    //
*//////////////////////////////////////////////////////////
      IMPLICIT NONE
      SAVE
      CHARACTER*80 title
      REAL*8  XSecNR,tmin,tmax,fact
      INTEGER  NevMC,id1,id2,nbt
*----------
      CALL ginbo1(id1,title,nbt,tmin,tmax)
      fact = nbt*XSecNR/(NevMC*(tmax-tmin))
* Multiply content
      CALL gopera(id1,'+',id1,id2, fact, 0d0)
      END

