      PROGRAM Main
*     ************
* Main program for MC production
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
!
!     ***********
      CALL ProRun
!     ***********
      END


      SUBROUTINE ProRun
*     *****************
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
* input/output units
      COMMON / inout  / ninp,nout
      CHARACTER*4 semaph
      SAVE
!
*///////////////////////////////////////////////////////////////
*//        Define output file                                 //
*///////////////////////////////////////////////////////////////
      nout = 16                    ! Default in YFSWW is nout=16
c      OPEN(nout,FILE='./pro.output')
c      REWIND(nout)
      CALL goutpu(nout)
c      CALL LuGive("MSTU(11)=16;")  ! Output unit for Jetset
!
c      WRITE(nout,*) '   '
c      WRITE(nout,*) '=============================================='
c      WRITE(nout,*) '==========*********************==============='
c      WRITE(nout,*) '==========***    ProRun     ***==============='
c      WRITE(nout,*) '==========*********************==============='
c      WRITE(nout,*) '=============================================='
c      WRITE(nout,*) '   '
!---------------
! READ semaphore flag
      CALL givsem(semaph)
!---------------
      IF(semaph  .EQ.  'STAR') THEN
         WRITE(6,*) ' ------- starting from the scratch ----------'
! READ initial (root) random number seed
         ninp3=3
         OPEN(ninp3,FILE='./iniseed')
         READ(ninp3,'(i10)') ijklin
         READ(ninp3,'(i10)') ntotin
         READ(ninp3,'(i10)') ntot2n
         CALL MARINI(ijklin,ntotin,ntot2n)
      ELSEIF(semaph  .EQ.  'CONT') THEN
         WRITE(6,*) ' ------- restoring from the disk   ----------'
! restore histograms from the disk
         ninph=10
         OPEN(ninph,FILE='./'//'korw.hst')
         CALL glimit(50000)
         CALL goutpu(nout)
         CALL grFILE(ninph,' ',' ')      !transfer FILE number
         CALL grin(   0,9999,0)          !READ from the disk
         CALL grend(' ')                 !CLOSE FILE
! READ random number seed stored in semaphore FILE
         ninp2=2
         OPEN(ninp2,FILE='./semaphore')
         READ(ninp2,'(a4)') semaph
         READ(ninp2,'(i10)') ijklin
         READ(ninp2,'(i10)') ntotin
         READ(ninp2,'(i10)') ntot2n
         CALL MARINI(ijklin,ntotin,ntot2n)
         CLOSE(ninp2)
      ELSEIF(semaph  .EQ.  'STOP') THEN
         WRITE(6,*) '++++++++++++++++++++++++++++++++++++++++++++++++++'
         WRITE(6,*) '++++ STOP: please change semaph to cont or start !'
         WRITE(6,*) '++++++++++++++++++++++++++++++++++++++++++++++++++'
         STOP
      ELSE
         WRITE(6,*) '++++++++++++++++++++++++++++++++++++++++++++++++++'
         WRITE(6,*) '++++ STOP: wrong key semaph = ', semaph
         WRITE(6,*) '++++++++++++++++++++++++++++++++++++++++++++++++++'
         STOP
      ENDIF
! *******************************************
      CALL ProHis
! ********************************************
      END

       SUBROUTINE ProHis
!      PROGRAM  main
*/////////////////////////////////////////////////////////////////////
*/////////////////////////////////////////////////////////////////////
      IMPLICIT NONE
      SAVE
*
* Common block for Robol
      COMMON / inout  / ninp,nout
      INTEGER           ninp,nout
*
      INTEGER      iMax
      PARAMETER    (iMax=10000)
      REAL*8       xpar(iMax)
*
      CHARACTER*80 DiskFile
      INTEGER      iReset,iTalk
      INTEGER      NevTot, kat1,kat2,kat3,kat4,kat5,kat6,kat7,kat8
*
      INTEGER  loop, loop2, Iev, i

      INTEGER KeyZon,Key4f,KeyPho,KeyAcc,mout,ii, ieor
      DOUBLE PRECISION CMSene,XsBorn,ErBorn,Xtot3e,XErr3e
*///////////////////////////////////////////////////////////////
*//        Define output/input files                          //
*///////////////////////////////////////////////////////////////
      ninp= 5
      nout=16                      ! Default in KoralW is nout=16
      OPEN(nout,file='korw.output')
      CALL LuGive("MSTU(11)=16;")  ! Output unit for Jetset
*///////////////////////////////////////////////////////////////
      WRITE(NOUT,*) '   '
      WRITE(NOUT,*) '=============================================='
      WRITE(NOUT,*) '==========/////////////////////==============='
      WRITE(NOUT,*) '==========///     KWdemo2   ///==============='
      WRITE(NOUT,*) '==========/////////////////////==============='
      WRITE(NOUT,*) '=============================================='
      WRITE(NOUT,*) '   '
*///////////////////////////////////////////////////////////////
*//        Read header of input data file                     //
*///////////////////////////////////////////////////////////////
      DiskFile = './prod-132.data'
      OPEN( ninp,file=DiskFile)

      READ( ninp,*) kat1,kat2,kat3,kat4,kat5,kat6,kat7,kat8
      READ( ninp,'(I10)')  NevTot

      CLOSE(ninp)
* some printouts
      WRITE( 6,*)     NevTot,' REQUESTED EVENTS '
      WRITE(NOUT,*)   NevTot,' REQUESTED EVENTS '
*---------------------------------------------------------------
*///////////////////////////////////////////////////////////////
*//        Read DEFAULT input data file                       //
*///////////////////////////////////////////////////////////////
      DiskFile = './data_DEFAULTS'
      iReset   = 1              ! <-- xpar is defined/reset
      CALL KW_ReaDataX( DiskFile,    iReset, iMax, xpar)
*///////////////////////////////////////////////////////////////
*//        Read input data file for THIS test                 //
*///////////////////////////////////////////////////////////////
      DiskFile = './prod-132.data'
      iReset   = 0              ! <-- xpar modified selectively
      CALL KW_ReaDataX(  DiskFile,   iReset, iMax, xpar)
*///////////////////////////////////////////////////////////////
*//       Optional reading of mask matrix                     //
*// It is not necessary, default value in xpar is provided    //
*// Here Umask is in the same input file                      //
*///////////////////////////////////////////////////////////////
      DiskFile = './prod-132.data'
      iTalk    = 1
      CALL KW_ReadMask( DiskFile, iTalk, xpar)
*==============================================================
      CALL KW_Initialize(xpar)
*     ************************
      IF(kat1.EQ.1) CALL Prod1 (-1)
      IF(kat3.EQ.1) CALL Prod3 (-1)
      Iev=0
      DO loop=1,10000
         DO loop2=1,100000
            Iev=Iev+1
            IF(MOD(Iev,2000) .EQ. 1) WRITE(6,*) '  Iev= ',Iev
            CALL check_EndOfRun(ieor)
            IF(ieor.EQ.1) THEN
               WRITE(6,*)'KWyfsww: end of run requested'
               GOTO 103
            ENDIF
            CALL KW_Make
*           ************
            IF(kat1.EQ.1) CALL Prod1 ( 0)
            IF(kat3.EQ.1) CALL Prod3 ( 0)
            IF(Iev .LE. 2) CALL lulist(2)
            IF(Iev .GE. NevTot) GOTO 103
         ENDDO
*! Dump partial results on the disk after every Ngroup
         CALL  DUMPEH(Iev)
      ENDDO
 103  CONTINUE
*==============================================================
      WRITE(6,*) 'Generation finished '
*! Dump finalresults on the disk
      CALL  DUMPEH(Iev)
      CALL KW_Finalize
*     ****************
      IF(kat1.EQ.1) CALL Prod1 ( 1)
      IF(kat3.EQ.1) CALL Prod3 ( 1)

c*//////////////////////////////////////////////////////////////////
c*//         SemiAnalytical O(alf3)exp. form Korwan               //
c*//  To compare SemiAnal results with MC make physics sense      //
c*//  for KeyZon = 0 and  key4f = 0,                              //
c*//  otherwise: Korwan provides useful info on crude x-section   //
c*//////////////////////////////////////////////////////////////////
c      KeyZon =xpar(1044)
c      Key4f  =xpar(1042)
c      CMSene=xpar(1)            ! input for Korwan 
c      KeyPho=0
c      KeyAcc=1
c      CALL Korwan(CMSene**2,0d0,1d0,KeyPho,KeyAcc,XsBorn,ErBorn)
c      KeyPho=303 
c      KeyAcc=1
c      CALL Korwan(CMSene**2,0d0,1d0,KeyPho,KeyAcc,Xtot3e,XErr3e)
c*     Final printouts of demo
c      DO ii=1,2
c         mout = 6
c         IF( ii.EQ.2 ) mout = nout
c         WRITE(mout,'(A60)') '============ demo ============'
c         IF( (KeyZon .EQ. 0) .AND. (Key4f .EQ. 0) ) THEN
c            WRITE(mout,'(1X,F17.8, 4H  +-, F11.8, 1X, A30)') 
c     $           XsBorn,ErBorn,'SemiAnal Born, Korwan'
c            WRITE(mout,'(1X,F17.8, 4H  +-, F11.8, 1X, A30)') 
c     $           Xtot3e,XErr3e,'SemiAnal O(alf3)exp.LL, Korwan'
c         ENDIF
c         WRITE(mout,'(A60)') '========== End demo =========='
c      ENDDO
      END



      SUBROUTINE HisNormalize(id1,NevMC,XSecNR,id2)
*//////////////////////////////////////////////////////////
*//   This routine re-normalizes histogram to XSecNR    //
*//////////////////////////////////////////////////////////
      IMPLICIT NONE
      SAVE
      CHARACTER*80 title
      REAL*8  XSecNR,tmin,tmax,fact
      INTEGER  NevMC,id1,id2,nbt
*----------
      CALL ginbo1(id1,title,nbt,tmin,tmax)
      fact = nbt*XSecNR/(NevMC*(tmax-tmin))
* Multiply content
      CALL gopera(id1,'+',id1,id2, fact, 0d0)
      END


      SUBROUTINE Prod1(mode)
*     ***************************
!---------------------------------------------------------------!
! This is for the Born level ...                                !
!---------------------------------------------------------------!
      IMPLICIT REAL*8 (A-H,O-Z) 
      PARAMETER( pi = 3.1415926535897932d0 )
! Input/output files
      COMMON / INOUT  / NINP,NOUT
      DOUBLE PRECISION qwm(4),qwp(4)
      DIMENSION IFLAV(4),AMDEC(4)
      DIMENSION IfChar(4),PfeAll(4,4)
      DIMENSION wtset(100)
      DIMENSION pf1(4),pf2(4),pf3(4),pf4(4)
      SAVE 
!
      IF (mode.EQ.-1) THEN
!----------------------------------------------------------------------
        WRITE(nout,*) '   '
        WRITE(nout,*) '=============================================='
        WRITE(nout,*) '============= Prod1: Born level =============='
        WRITE(nout,*) '=============================================='
        WRITE(nout,*) '   '
        Nbin = 50
        idbo = 110000
! Deg --> rad    
        degrad = pi/180
! Minimum angle of final state fermion to beams
        thfmin = 10d0
        ctfmin = COS(thfmin*degrad)
! Initialize total cross section monitoring
! ccall
        CALL GMONIT(-1,idbo+1,0D0,1D0,1D0) ! no cuts
        CALL GMONIT(-1,idbo+2,0D0,1D0,1D0) ! with cuts
! ccall-cc03
        CALL GMONIT(-1,idbo+3,0D0,1D0,1D0) ! no cuts
        CALL GMONIT(-1,idbo+4,0D0,1D0,1D0) ! with cuts
! Book histograms
        ct1 =-1d0
        ct2 = 1d0
! ccall
        CALL GBOOK1(idbo+11,'costh(W+): Born ccall$',Nbin,ct1,ct2)
        CALL GBOOK1(idbo+12,'costh(W-): Born ccall$',Nbin,ct1,ct2)
! ccall-cc03
        CALL GBOOK1(idbo+111,'costh(W+): Born all-03$',Nbin,ct1,ct2)
        CALL GBOOK1(idbo+112,'costh(W-): Born all-03$',Nbin,ct1,ct2)
        xm1 = 75d0
        xm2 = 85d0
! ccall
        CALL GBOOK1(idbo+13,'Inv mass W+: Born ccall$',Nbin,xm1,xm2)
        CALL GBOOK1(idbo+14,'Inv mass W-: Born ccall$',Nbin,xm1,xm2)
! ccall-cc03
        CALL GBOOK1(idbo+113,'Inv mass W+: Born all-03$',Nbin,xm1,xm2)
        CALL GBOOK1(idbo+114,'Inv mass W-: Born all-03$',Nbin,xm1,xm2)
      ELSEIF (mode.EQ.0) THEN
!---------------------------------------------------------------------- 
! Tag charged fermions
        CALL KW_GetIflav(Iflav,Amdec)
        DO i = 1,4
           ifl = IABS(IFLAV(i))
           IF (ifl.EQ.12 .OR. ifl.EQ.14 .OR. ifl.EQ.16) THEN
              IfChar(i) = 0
           ELSE
              IfChar(i) = 1
           ENDIF
        ENDDO
! weights
        CALL KW_GetWtAll(WtMain,WtCrud,WtSet)
! Cut-weight on charged fermions separation angle from beams
        wtfba = 1d0
! Crude weight
cccc from getter        wtcrud = WTCRU1*WTCRU2
! main weight
!        IF(dabs(wtset(1)*wtcrud/wtmain-1).gt.1d-10) THEN
!           WRITE(6,*)'KWyfsww==> inconsistency in wtset: ',
!     $         wtset(1)*wtcrud , wtmain
!           STOP
!        ENDIF
!        wtmod=wtmain
        wtmod= wtset(1)*wtcrud 
        wtmodww=wtset(9)*wtcrud
        IF (wtcrud.EQ.0d0) GOTO 101
!!!! Get all fermion and photon 4-momenta from event record
!!!        CALL Get_FS_4Momenta(PfeAll,PhoAll,NphAll)
! Put all fermion into one array
        CALL KW_GetMomDec(pf1,pf2,pf3,pf4)
        DO k = 1,4
           PfeAll(k,1) = pf1(k)
           PfeAll(k,2) = pf2(k)
           PfeAll(k,3) = pf3(k)
           PfeAll(k,4) = pf4(k)
        ENDDO
! Apply cut on charged fermions separation angle from beams 
        DO i = 1,4
           IF (IfChar(i).EQ.1) THEN
              ctfb = CosThe(PfeAll,i)
              IF (ABS(ctfb).GT.ctfmin) THEN
                 wtfba = 0d0
                 GOTO 101
              ENDIF
           ENDIF
        ENDDO
 101    CONTINUE
        wtcrfb = wtcrud*wtfba
        IF (wtcrfb.NE.0d0) THEN
          DO k = 1,4 
             qwm(k) = pf1(k) + pf2(k)
             qwp(k) = pf3(k) + pf4(k)
          ENDDO
! ... cos(theta) of W-/W+
          cthWm = qwm(3)/DSQRT(qwm(1)**2+qwm(2)**2+qwm(3)**2) 
          cthWp =-qwp(3)/DSQRT(qwp(1)**2+qwp(2)**2+qwp(3)**2) 
! ... invariant mass of W-/W+
          amwm = SQRT(qwm(4)**2 -qwm(3)**2 -qwm(2)**2 -qwm(1)**2)
          amwp = SQRT(qwp(4)**2 -qwp(3)**2 -qwp(2)**2 -qwp(1)**2)
        ELSE
          cthWm =-2d0
          cthWp =-2d0
          amwm  =-1d0
          amwp  =-1d0
        ENDIF
        wtmct   = WTMODww*wtfba
        wtmctww = (WTMOD-wtmodww)*wtfba
! Total cross section monitoring 
        CALL GMONIT(0,IdBo+1,WTMODww,1d0,1d0) ! no cuts
        CALL GMONIT(0,IdBo+2,wtmct,1d0,1d0) ! with cuts
!     ccall-cc03
        CALL GMONIT(0,IdBo+3,WTMOD-wtmodww,1d0,1d0) ! no cuts 
        CALL GMONIT(0,IdBo+4,wtmctww,1d0,1d0)       ! with cuts
! Fill histograms
! Theta distribution
        CALL gf1(IdBo+11,cthWp,wtmct)
        CALL gf1(IdBo+12,cthWm,wtmct)
!     ccall-cc03
        CALL gf1(IdBo+111,cthWp,wtmctww)
        CALL gf1(IdBo+112,cthWm,wtmctww)
! Invariant mass of W-/W+
        CALL gf1(IdBo+13,amwp,wtmct)
        CALL gf1(IdBo+14,amwm,wtmct)
!     ccall-cc03
        CALL gf1(IdBo+113,amwp,wtmctww)
        CALL gf1(IdBo+114,amwm,wtmctww)
      ELSEIF (mode.EQ.1) THEN 
! Print histograms
        CALL gprint(IdBo+11)
        CALL gprint(IdBo+12)
        CALL gprint(IdBo+13)
        CALL gprint(IdBo+14)
        CALL gprint(IdBo+111)
        CALL gprint(IdBo+112)
        CALL gprint(IdBo+113)
        CALL gprint(IdBo+114)
! Print total x-section
        CALL GMONIT(1,IdBo+1,averw1,errel1,evtot1)
        CALL GMONIT(1,IdBo+2,averw2,errel2,evtot2)
! Get normalization (crude x-section)
        CALL KW_GetXSecNR(XSecNR,XErrNR)
        fbfac = 1d3
        xsec1 = averw1*XSecNR*fbfac
        errx1 = errel1*xsec1
        xsec2 = averw2*XSecNR*fbfac
        errx2 = errel2*xsec2
        WRITE(nout,'(A60)') '                                       '
        WRITE(nout,'(A60)') '------------ Xsec_tot [fb] ------------'
        WRITE(nout,'(1X,F17.8, 4H  +-, F11.8, 1X, A30)') 
     &        xsec1,errx1, 'Born:   no cuts'
        WRITE(nout,'(1X,F17.8, 4H  +-, F11.8, 1X, A30)') 
     &        xsec2,errx2, 'Born: with cuts'
! Print total x-section ccall-cc03 difference
        CALL GMONIT(1,IdBo+3,averw103,errel103,evtot103)
        CALL GMONIT(1,IdBo+4,averw203,errel203,evtot203)

        xsec103 = averw103*XSecNR*fbfac
        errx103 = errel103*xsec103
        xsec203 = averw203*XSecNR*fbfac
        errx203 = errel203*xsec203
        WRITE(nout,'(A60)') '                                       '
        WRITE(nout,'(A60)') '------------ Xsec_tot [fb] ------------'
        WRITE(nout,'(1X,F17.8, 4H  +-, F11.8, 1X, A30)') 
     &        xsec103,errx103, 'CCall-CC03 Born:   no cuts'
        WRITE(nout,'(1X,F17.8, 4H  +-, F11.8, 1X, A30)') 
     &        xsec203,errx203, 'CCall-CC03 Born: with cuts'
        WRITE(nout,'(A60)') '============== End Prod1 =============='
        WRITE(nout,'(A60)') '                                       '
      ELSE
        WRITE(6,*)' >> Prod1: Wrong mode = ',mode
        STOP
      ENDIF
      END

      SUBROUTINE Prod3(mode)
*     ***************************
!---------------------------------------------------------------!
! Tests of ISR in YFSWW3                                        !
!---------------------------------------------------------------!
      IMPLICIT REAL*8 (A-H,O-Z) 
      PARAMETER( pi = 3.1415926535897932d0 )
! Input/output files
      COMMON / INOUT  / NINP,NOUT
      DIMENSION IFLAV(4),AMDEC(4)
      DIMENSION PfeAll(4,4),PhoAll(100,4)
      DIMENSION IfChar(4),PfBare(4,4),PfCalo(4,4)
      DIMENSION pgam(4), QWmBare(4),QWpBare(4), QWmCalo(4), QWpCalo(4)  
      DIMENSION PhBare(100,4),PhCalo(100,4)
      DIMENSION wtset(100)
      SAVE 
!
      IF (mode.EQ.-1) THEN
!----------------------------------------------------------------------
        WRITE(nout,*) '   '
        WRITE(nout,*) '=============================================='
        WRITE(nout,*) '============== Prod3: ISR+FSR ================'
        WRITE(nout,*) '=============================================='
        WRITE(nout,*) '   '
        Nbin = 50
        idr = 130000
! Deg --> rad    
        degrad = pi/180
! Minimum angle of final state fermion to beams [deg]
        thfmin = 10d0
        ctfmin = COS(thfmin*degrad)
! Lower cut on photon energy
        Egmin = 1d0
! Lower cuts on photon polar angle [deg]
        thgmin = 5d0
        ctgmin = COS(thgmin*degrad)
! TH cuts on invariant mass of fermion+photon (recombination cuts)
        xmfg_bare =  5d0
        xmfg_calo =  25d0
! Initialize total cross section monitoring
! ccall
        CALL GMONIT(-1,idr+1,0D0,1D0,1D0) ! no cuts
        CALL GMONIT(-1,idr+2,0D0,1D0,1D0) ! with cuts
! ccall-cc03
        CALL GMONIT(-1,idr+3,0D0,1D0,1D0) ! no cuts
        CALL GMONIT(-1,idr+4,0D0,1D0,1D0) ! with cuts
! Book histograms
        ct1 =-1d0
        ct2 = 1d0
! ccall
        CALL GBOOK1(idr+11,'BARE costh(W+): ISR $',Nbin,ct1,ct2)
        CALL GBOOK1(idr+12,'BARE costh(W-): ISR $',Nbin,ct1,ct2)
        CALL GBOOK1(idr+21,'CALO costh(W+): ISR $',Nbin,ct1,ct2)
        CALL GBOOK1(idr+22,'CALO costh(W-): ISR $',Nbin,ct1,ct2)
! ccall-cc03
        CALL GBOOK1(idr+111,'BARE costh(W+) ISR all-03$',Nbin,ct1,ct2)
        CALL GBOOK1(idr+112,'BARE costh(W-) ISR all-03$',Nbin,ct1,ct2)
        CALL GBOOK1(idr+121,'CALO costh(W+) ISR all-03$',Nbin,ct1,ct2)
        CALL GBOOK1(idr+122,'CALO costh(W-) ISR all-03$',Nbin,ct1,ct2)
        xm1 = 75d0
        xm2 = 85d0
! ccall
        CALL GBOOK1(idr+13,'BARE inv. mass of W+: ISR $',Nbin,xm1,xm2)
        CALL GBOOK1(idr+14,'BARE inv. mass of W-: ISR $',Nbin,xm1,xm2)
        CALL GBOOK1(idr+23,'CALO inv. mass of W+: ISR $',Nbin,xm1,xm2)
        CALL GBOOK1(idr+24,'CALO inv. mass of W-: ISR $',Nbin,xm1,xm2)
! ccall-cc03
        CALL GBOOK1(idr+113,'BARE inv mass W+ ISR all-03$',Nbin,xm1,xm2)
        CALL GBOOK1(idr+114,'BARE inv mass W- ISR all-03$',Nbin,xm1,xm2)
        CALL GBOOK1(idr+123,'CALO inv mass W+ ISR all-03$',Nbin,xm1,xm2)
        CALL GBOOK1(idr+124,'CALO inv mass W- ISR all-03$',Nbin,xm1,xm2)
        Eg1 = 0d0
        Eg2 = 50d0
! ccall
        CALL GBOOK1(idr+15,'BARE E(gamma): ISR $',Nbin,Eg1,Eg2)
        CALL GBOOK1(idr+25,'CALO E(gamma): ISR $',Nbin,Eg1,Eg2)
        CALL GBOOK1(idr+16,'BARE costh(gamma): ISR $',Nbin,ct1,ct2)
        CALL GBOOK1(idr+26,'CALO costh(gamma): ISR $',Nbin,ct1,ct2)
! ccall-cc03
        CALL GBOOK1(idr+115,'BARE E(gamma): ISR all-03$',Nbin,Eg1,Eg2)
        CALL GBOOK1(idr+125,'CALO E(gamma): ISR all-03$',Nbin,Eg1,Eg2)
        CALL GBOOK1(idr+116,'BARE costh(gama) ISR all-03$',Nbin,ct1,ct2)
        CALL GBOOK1(idr+126,'CALO costh(gama) ISR all-03$',Nbin,ct1,ct2)
        th1 = 0d0
        th2 = 180d0
! ccall
        CALL GBOOK1(idr+17,'BARE theta(gamma-f): ISR $',Nbin,th1,th2)
        CALL GBOOK1(idr+27,'CALO theta(gamma-f): ISR $',Nbin,th1,th2)
        CALL GBOOK1(idr+18,'BARE Esum(gamma): ISR $',Nbin,Eg1,Eg2)
        CALL GBOOK1(idr+28,'CALO Esum(gamma): ISR $',Nbin,Eg1,Eg2)
! ccall-cc03
        CALL GBOOK1(idr+117,'BARE the(gama-f) ISR all-03$',Nbin,th1,th2)
        CALL GBOOK1(idr+127,'CALO the(gama-f) ISR all-03$',Nbin,th1,th2)
        CALL GBOOK1(idr+118,'BARE Esum(gama) ISR all-03$',Nbin,Eg1,Eg2)
        CALL GBOOK1(idr+128,'CALO Esum(gama) ISR all-03$',Nbin,Eg1,Eg2)
      ELSEIF (mode.EQ.0) THEN
!---------------------------------------------------------------------- 
! Tag charged fermions
        CALL KW_GetIflav(Iflav,Amdec)
        DO i = 1,4
           ifl = IABS(IFLAV(i))
           IF (ifl.EQ.12 .OR. ifl.EQ.14 .OR. ifl.EQ.16) THEN
              IfChar(i) = 0
           ELSE
              IfChar(i) = 1
           ENDIF
        ENDDO
! weights
        CALL KW_GetWtAll(WtMain,WtCrud,WtSet)
! Cut-weight on charged fermions separation angle from beams
        wtfba = 1d0
! Crude weight
ccc from getter        wtcrud = WTCRU1*WTCRU2
! add the option of downgrading the ISR part of principal weight
!     i_principal_weight=2       ! First  order ISR
!     i_principal_weight=3       ! Second order ISR
!     i_principal_weight=4       ! Third  order ISR
! by default we use the best one !

      i_principal_weight=4       ! Third  order ISR
! master weight
        wtmod= wtset(i_principal_weight)*wtcrud 
        wtmodww=wtset(10-i_principal_weight)*wtcrud
!!!        wtmod=wtmain

        IF(dabs(wtmod/wtmain-1) .GT. 1d-10) THEN
           WRITE(6,*)'KWyfsww==> inconsistency in wtset: ',
     $         wtset(1)*wtcrud , wtmain
           STOP
        ENDIF

        IF (wtcrud.EQ.0d0) GOTO 101
! Get all fermion and photon 4-momenta from event record
        CALL Get_FS_4Momenta(PfeAll,PhoAll,NphAll)
! Apply cut on charged fermions separation angle from beams 
        DO i = 1,4
           IF (IfChar(i).EQ.1) THEN
              ctfb = CosThe(PfeAll,i)
              IF (ABS(ctfb).GT.ctfmin) THEN
                 wtfba = 0d0
                 GOTO 101
              ENDIF
           ENDIF
        ENDDO
 101    CONTINUE
        wtcrfb = wtcrud*wtfba
        IF (wtcrfb.NE.0d0) THEN
! Initialize Bare and Calo 4-momenta
           DO i = 1,4
              DO k = 1,4
                 PfBare(k,i) = PfeAll(k,i)
                 PfCalo(k,i) = PfeAll(k,i)
              ENDDO
           ENDDO
           EgBare = 1d-10
           EgsBare = 1d-10
           cthgBare = 0.9999d0
           thfgBare = 1d-10
           EgCalo = 1d-10
           EgsCalo = 1d-10
           cthgCalo = 0.9999d0
           thfgCalo = 1d-10
           NphBare = 0
           NphCalo = 0
           DO i = 1,NphAll
! The hardest photon
              DO k = 1,4 
                 pgam(k) = PhoAll(i,k)
              ENDDO
! Cut on photon polar angle
              costhg = CosPol(pgam)
              IF (ABS(costhg).LE.ctgmin) THEN
! Find minimum invariant-mass and angle of photon and charged fermion
                 CALL XmassMin(IfChar,PfeAll,pgam,xmfgmin,ifemin)
! BARE and CALO photon recombination cuts
                 IF (xmfgmin.LT.xmfg_bare .OR. pgam(4).LT.Egmin) THEN
                    DO k = 1,4
                       PfBare(k,ifemin) = PfBare(k,ifemin) + pgam(k)
                    ENDDO
                 ELSE
                    NphBare = NphBare + 1
                    DO k = 1,4
                       PhBare(NphBare,k) = pgam(k)
                    ENDDO
                 ENDIF
                 IF (xmfgmin.LT.xmfg_calo .OR. pgam(4).LT.Egmin) THEN
                    DO k = 1,4
                       PfCalo(k,ifemin) = PfCalo(k,ifemin) + pgam(k)
                    ENDDO
                 ELSE
                    NphCalo = NphCalo + 1
                    DO k = 1,4
                       PhCalo(NphCalo,k) = pgam(k)
                    ENDDO
                 ENDIF
              ENDIF
           ENDDO
           IF (NphBare.GT.0) THEN
              DO k = 1,4
                 pgam(k) = PhBare(1,k)
              ENDDO
              EgBare = pgam(4)
              cthgBare =-CosPol(pgam)
              thfgBare = ThefgMin(IfChar,PfBare,pgam)
              EgsBare = EgBare
              DO i = 2,NphBare
                 EgsBare = EgsBare + PhBare(i,4)
              ENDDO
           ENDIF
           IF (NphCalo.GT.0) THEN
              DO k = 1,4
                 pgam(k) = PhCalo(1,k)
              ENDDO
              EgCalo = pgam(4)
              cthgCalo =-CosPol(pgam)
              thfgCalo = ThefgMin(IfChar,PfCalo,pgam)
              EgsCalo = EgCalo
              DO i = 2,NphCalo
                 EgsCalo = EgsCalo + PhCalo(i,4)
              ENDDO
           ENDIF
! Bare and Calo W-/W+ invariant masses
           XmWmBare = XInvMass(PfBare,1,2)
           XmWpBare = XInvMass(PfBare,3,4)
           XmWmCalo = XInvMass(PfCalo,1,2)
           XmWpCalo = XInvMass(PfCalo,3,4)
! Bare and Calo W-/W+ cos(theta) w.r.t e-/e+
           DO k = 1,4
              QWmBare(k) = PfBare(k,1) + PfBare(k,2)
              QWpBare(k) = PfBare(k,3) + PfBare(k,4)
              QWmCalo(k) = PfCalo(k,1) + PfCalo(k,2)
              QWpCalo(k) = PfCalo(k,3) + PfCalo(k,4)
           ENDDO
           ctWmBare = CosPol(QWmBare)
           ctWpBare =-CosPol(QWpBare)
           ctWmCalo = CosPol(QWmCalo)
           ctWpCalo =-CosPol(QWpCalo)
        ELSE
           EgBare =-2d0
           EgsBare =-2d0
           cthgBare =-2d0
           thfgBare =-2d0
           EgCalo =-2d0
           EgsCalo =-2d0
           cthgCalo =-2d0
           thfgCalo =-2d0
           XmWmBare =-2d0
           XmWpBare =-2d0
           XmWmCalo =-2d0 
           XmWpCalo =-2d0
           ctWmBare =-2d0
           ctWpBare =-2d0
           ctWmCalo =-2d0
           ctWpCalo =-2d0
        ENDIF
        wtmct = WTMODww*wtfba
        wtmctww = (WTMOD-wtmodww)*wtfba
! Total cross section monitoring 
!     ccall
        CALL GMONIT(0,idr+1,WTMODww,1d0,1d0) ! no cuts
        CALL GMONIT(0,idr+2,wtmct,1d0,1d0) ! with cuts
!     ccall-cc03
        CALL GMONIT(0,idr+3,WTMOD-wtmodww,1d0,1d0) ! no cuts
        CALL GMONIT(0,idr+4,wtmctww,1d0,1d0) ! with cuts
! Fill histograms
! cost(theta) distribution of W+/W-
!     ccall
        CALL gf1(idr+11,ctWpBare,wtmct)
        CALL gf1(idr+12,ctWmBare,wtmct)
        CALL gf1(idr+21,ctWpCalo,wtmct)
        CALL gf1(idr+22,ctWmCalo,wtmct)
!     ccall-cc03
        CALL gf1(idr+111,ctWpBare,wtmctww)
        CALL gf1(idr+112,ctWmBare,wtmctww)
        CALL gf1(idr+121,ctWpCalo,wtmctww)
        CALL gf1(idr+122,ctWmCalo,wtmctww)
! Invariant mass of W-/W+
!     ccall
        CALL gf1(idr+13,XmWpBare,wtmct)
        CALL gf1(idr+14,XmWmBare,wtmct)
        CALL gf1(idr+23,XmWpCalo,wtmct)
        CALL gf1(idr+24,XmWmCalo,wtmct)
!     ccall-cc03
        CALL gf1(idr+113,XmWpBare,wtmctww)
        CALL gf1(idr+114,XmWmBare,wtmctww)
        CALL gf1(idr+123,XmWpCalo,wtmctww)
        CALL gf1(idr+124,XmWmCalo,wtmctww)
! Energy distribution of photon
!     ccall
        CALL gf1(idr+15,EgBare,wtmct)
        CALL gf1(idr+25,EgCalo,wtmct)
!     ccall-cc03
        CALL gf1(idr+115,EgBare,wtmctww)
        CALL gf1(idr+125,EgCalo,wtmctww)
! cos(theta) distribution of photon
!     ccall
        CALL gf1(idr+16,cthgBare,wtmct)
        CALL gf1(idr+26,cthgCalo,wtmct)
!     ccall-cc03
        CALL gf1(idr+116,cthgBare,wtmctww)
        CALL gf1(idr+126,cthgCalo,wtmctww)
! theta(gamma-fermion) distribution
!     ccall
        CALL gf1(idr+17,thfgBare/degrad,wtmct)
        CALL gf1(idr+27,thfgCalo/degrad,wtmct)
!     ccall-cc03
        CALL gf1(idr+117,thfgBare/degrad,wtmctww)
        CALL gf1(idr+127,thfgCalo/degrad,wtmctww)
! Energy-sum distribution of photons
!     ccall
        CALL gf1(idr+18,EgsBare,wtmct)
        CALL gf1(idr+28,EgsCalo,wtmct)
!     ccall-cc03
        CALL gf1(idr+118,EgsBare,wtmctww)
        CALL gf1(idr+128,EgsCalo,wtmctww)
      ELSEIF (mode.EQ.1) THEN 
! Print histograms
         DO i = 1,8
           CALL gprint(idr+10+i)
           CALL gprint(idr+20+i)
         ENDDO
         DO i = 1,8
           CALL gprint(idr+110+i)
           CALL gprint(idr+120+i)
         ENDDO
! Print total x-section
        CALL GMONIT(1,idr+1,averw1,errel1,evtot1)
        CALL GMONIT(1,idr+2,averw2,errel2,evtot2)
! Get normalization (crude x-section)
        CALL KW_GetXSecNR(XSecNR,XErrNR)
        fbfac = 1d3
        xsec1 = averw1*XSecNR*fbfac
        errx1 = errel1*xsec1
        xsec2 = averw2*XSecNR*fbfac
        errx2 = errel2*xsec2
        WRITE(nout,'(A60)') '                                          '
        WRITE(nout,'(A60)') '------------ WW Xsec_tot [fb] ------------'
        WRITE(nout,'(1X,F17.8, 4H  +-, F15.8, 1X, A30)') 
     &        xsec1,errx1, 'WW ISR:   no cuts'
        WRITE(nout,'(1X,F17.8, 4H  +-, F15.8, 1X, A30)') 
     &        xsec2,errx2, 'WW ISR: with cuts'

! Print total x-section ccall-cc03 difference
        CALL GMONIT(1,Idr+3,averw103,errel103,evtot103)
        CALL GMONIT(1,Idr+4,averw203,errel203,evtot203)

        xsec103 = averw103*XSecNR*fbfac
        errx103 = errel103*xsec103
        xsec203 = averw203*XSecNR*fbfac
        errx203 = errel203*xsec203
        WRITE(nout,'(A60)') '                                       '
        WRITE(nout,'(A60)') '------------ Xsec_tot [fb] ------------'
        WRITE(nout,'(1X,F17.8, 4H  +-, F15.8, 1X, A30)') 
     &        xsec103,errx103, 'CCall-CC03 ISR:   no cuts'
        WRITE(nout,'(1X,F17.8, 4H  +-, F15.8, 1X, A30)') 
     &        xsec203,errx203, 'CCall-CC03 ISR: with cuts'

        WRITE(nout,'(A60)') '============== End Prod2 =============='
        WRITE(nout,'(A60)') '                                       '
      ELSE
         WRITE(6,*)' >> Prod3: Wrong mode = ',mode
         STOP
      ENDIF
      END

      SUBROUTINE Get_FS_4Momenta(PfeAll,PhoAll,NphAll)
*     ************************************************
*####################################################################
*# Get 4-momenta of 4 fermions and all photons from COMMON/HEPEVT/  #
*# Photons are ordered according to decreasing energy.              #  
*# OUTPUT: PfeAll(i,k) -- k-th component of i-th fermion 4-momentum #       
*#         PhoAll(i,k) -- k-th component of i-th photon 4-momentum  #       
*####################################################################
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      REAL PHEP,VHEP
      SAVE /HEPEVT/
      DIMENSION PfeAll(4,4),PhoAll(100,4)
      DIMENSION PhoMom(100,4)
*
*! Get final state fermions 4-momenta
      DO ID1 = 5,NHEP
         IF (IDHEP(ID1).NE.22) GOTO 8
      ENDDO
 8    CONTINUE
      DO  K = 1,4
         PfeAll(K,1) = PHEP(K,ID1)
         PfeAll(K,2) = PHEP(K,ID1+1)
      ENDDO
      DO ID2 = ID1+2,NHEP
         IF (IDHEP(ID2).NE.22) GOTO 18
      ENDDO
 18   CONTINUE
      DO  K = 1,4
         PfeAll(K,3) = PHEP(K,ID2)
         PfeAll(K,4) = PHEP(K,ID2+1)
      ENDDO
*! Get photon 4-momenta and multiplicity
      NGAM = 0
      DO  I = 5,NHEP
         IF (IDHEP(I).EQ.22) THEN
            NGAM = NGAM + 1
            DO  K = 1,4
               PhoMom(NGAM,K) = PHEP(K,I)
            ENDDO
         ENDIF
      ENDDO
      NphAll = NGAM
*! Order photons according to decreasing energy
      CALL Sort_Phot(PhoMom,PhoAll,NphAll)
      END

      SUBROUTINE Sort_Phot(PhoIn,PhoOut,NphAll)
*     *****************************************
*####################################################      
*# Ordering photons according to decreasing energy  #
*# (a bit primitive but simple).                    #
*# PhoIn  - input photons (not ordered)             #
*# PhoOut - output photons (ordered)                #
*# NphAll - number of photons                       #
*####################################################      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION PhoIn(100,4),PhoOut(100,4)
      DIMENSION PhoEne(100)
*
      DO i = 1,NphAll
         PhoEne(i) = PhoIn(i,4)
      ENDDO
      DO i = 1,NphAll
         jmax = 1
         Emax = PhoEne(jmax)
         DO j = 2,NphAll
            Egam = PhoEne(j)
            IF (Egam.GT.Emax) THEN
               jmax = j
               Emax = Egam
            ENDIF
         ENDDO
         DO k = 1,4
            PhoOut(i,k) = PhoIn(jmax,k)
         ENDDO
         PhoEne(jmax) = -1d0
      ENDDO
      END

      FUNCTION CosPol(p)
*     ******************
*###################################################################
*# Calculate cosine of polar angle of 4-momentum p.                # 
*################################################################### 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION p(4)
*
      csth = p(3)/SQRT(p(1)**2 + p(2)**2 + p(3)**2)
      CosPol = csth
      END

      FUNCTION CosThe(pfa,i)
*     **********************
*###################################################################
*# Calculate cosine of polar angle of i-th fermion;                # 
*# pfa  - 4x4 array final state fermions 4-momenta:                #
*#        pfa(k,i) - k-th component of i-th fermion 4-mom.         # 
*################################################################### 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION pfa(4,4)
*
      pmod = SQRT(pfa(1,i)**2 + pfa(2,i)**2 + pfa(3,i)**2)
      csth = pfa(3,i)/pmod
      CosThe = csth
      END

      FUNCTION CosTpq(p,q)
*     ********************
*###################################################################
*# Calculate cosine of opening angle between momenta p and q.      # 
*################################################################### 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION p(4),q(4)
*
      pmod = SQRT(p(1)**2 + p(2)**2 + p(3)**2)
      qmod = SQRT(q(1)**2 + q(2)**2 + q(3)**2)
      pxq  = p(1)*q(1) + p(2)*q(2) + p(3)*q(3)
      CosTpq = pxq/pmod/qmod
      END

      FUNCTION XInvMass(pfa,i,j)
*     **************************
*###################################################################
*# Calculate invariant mass of (i,j)-th fermion-pair;              # 
*# pfa  - 4x4 array final state fermions 4-momenta:                #
*#        pfa(k,i) - k-th component of i-th fermion 4-mom.         # 
*################################################################### 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION pfa(4,4)
*
      xm2 = ( pfa(4,i) + pfa(4,j) )**2
      DO k = 1,3
         xm2 = xm2 - ( pfa(k,i) + pfa(k,j) )**2
      ENDDO
      XInvMass = SQRT(xm2)
      END

      SUBROUTINE XmassMin(IfChar,PfeAll,pgam,xmfgmin,ifemin)
*     ******************************************************
*###################################################################
*# Find minimum invariant mass of charged fermion + photon         #
*# and opening angle between photon and closest charged fermion.   #
*# INPUT: IfChar -- 4-dim array with charged fermion tags          #
*#        PfeAll -- 4x4 array with 4 fermions 4-momenta            #
*#        pgam   -- photon 4-momentum                              #
*# OUTPUT: xmfgmin -- min. inv. mass of charged fermion and poton  #
*#         ifemin  -- ID of above fermion                          #
*################################################################### 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION IfChar(4),PfeAll(4,4),pgam(4)
      DIMENSION pfe(4),pcl(4)
*
      ifemin = 0
      xm2min = 1d20
      DO i = 1,4
         IF (IfChar(i).EQ.1) THEN
            DO k = 1,4
               pfe(k) = PfeAll(k,i)
               pcl(k) = pfe(k) + pgam(k)
            ENDDO
            xmcl2 = pcl(4)**2 - pcl(3)**2 - pcl(2)**2 - pcl(1)**2
            IF (xmcl2.LE.xm2min) THEN
               xm2min = xmcl2
               ifemin = i
            ENDIF
         ENDIF
      ENDDO
      xmfgmin = SQRT(xm2min)
      END
      
      FUNCTION ThefgMin(IfChar,PfeAll,pgam)
*     *************************************
*###################################################################
*# Find minimum angle of a photon and charged final state fermion. #
*# INPUT: IfChar -- 4-dim array with charged fermion tags          #
*#        PfeAll -- 4x4 array with 4 fermions 4-momenta            #
*#        pgam   -- photon 4-momentum                              #
*################################################################### 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION IfChar(4),PfeAll(4,4),pgam(4),pfe(4)
*
      ctfgmin = -1d0
      DO i = 1,4
         IF (IfChar(i).EQ.1) THEN
            DO k = 1,4
               pfe(k) = PfeAll(k,i)
            ENDDO
            costfg = CosTpq(pfe,pgam)
            IF (costfg.GT.ctfgmin) ctfgmin = costfg
         ENDIF
      ENDDO
      ThefgMin = ACOS(ctfgmin)
      END



      SUBROUTINE dumpeh(nev)
*     ************************
      IMPLICIT REAL*8(a-h,o-z)
! ------------------------------------------------------
! WRITE histos on the disk
! ------------------------------------------------------
      nouth=11
      OPEN(nouth,FILE='./korw.hst')
      CALL grfile(nouth,' ','n')   !transfer FILE number
      CALL grout( 0,icy,' ')       !WRITE on the disk
      CALL grend(' ')              !CLOSE FILE
! ------------------------------------------------------
! overWRITE semaphore FILE flag
      ninp2=2
      OPEN(ninp2,FILE='./semaphore')
      WRITE(ninp2,'(a4)') 'CONT'
! append semaphore FILE with new random number seed in
      CALL MAROUT(ijklin,ntotin,ntot2n)
      WRITE(ninp2,'(i10,a)') ijklin, ' = ijklin '
      WRITE(ninp2,'(i10,a)') ntotin, ' = ntotin '
      WRITE(ninp2,'(i10,a)') ntot2n, ' = ntot2n '
      WRITE(ninp2,'(i10,a)') nev,    ' =    nev '
      CLOSE(ninp2)
! ------------------------------------------------------
      END
      SUBROUTINE givsem(semaph)
*     ************************
      IMPLICIT REAL*8(a-h,o-z)
      CHARACTER*4 semaph
! ------------------------------------------------------
! READ semaphore flag
! ------------------------------------------------------
      ninp2=2
      OPEN(ninp2,FILE='./semaphore')
      READ(ninp2,'(a4)') semaph
      CLOSE(ninp2)
      END

