
      PROGRAM MAIN
*     ************
*-------------------------------------------------------------*
* Example of running YFSWW3 in a re-weighting mode            *
*-------------------------------------------------------------*
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION xpar(10000) ! array for input parameters
      CHARACTER*80 DiskFile
*! Input parameters for re-weighting routine
      INTEGER Iflav(4),Nphot                                          
      DOUBLE PRECISION pf1(4),pf2(4),pf3(4),pf4(4),Phot(100,4)          
      DIMENSION wtset(100)
*
*///////////////////////////////////////////////////////////////
*//        Define output file                                 //
*///////////////////////////////////////////////////////////////
      nout = 16                    ! Default in YFSWW is nout=16
      OPEN(nout,file='rw.out')
      CALL LuGive("MSTU(11)=16;")  ! Output unit for Jetset
*///////////////////////////////////////////////////////////////
*//        Read DEFAULT input data file for YFSWW3            //
*///////////////////////////////////////////////////////////////
      DiskFile = './data_DEFAULTS'
      iReset   = 1
*!--------------------------------------------------------------!
*! 1st argument of YFSWW_ReaDataX is the name of the input file !
*! 2nd argument: iReset = 1: reset input parameters array xpar  !
*!               iReset = 0: do not reset (but update) xpar     !
*! 3rd argument: the size of the input parameters array xpar    !
*! 4th argument: the name of the input parameters array         !
*!--------------------------------------------------------------!
      CALL YFSWW_ReaDataX( DiskFile,     iReset, 10000, xpar)
*///////////////////////////////////////////////////////////////
*//        Read input data file for THIS RUN                  //
*///////////////////////////////////////////////////////////////
      DiskFile = './user.data'  ! The name of an actual user input data file
      iReset   = 0
      CALL YFSWW_ReaDataX( DiskFile,    iReset, 10000, xpar)
*///////////////////////////////////////////////////////////////
*//         YFSWW initialization                              //
*///////////////////////////////////////////////////////////////
      CALL YFSWW_Initialize(xpar)
*///////////////////////////////////////////////////////////////
*//     MAIN LOOP FOR MATRIX ELEMENT WEIGHT CALCULATION       //
*///////////////////////////////////////////////////////////////
*===============================================================
*!... Number of events to be re-weighted
      NevTot = 200 000 000

! the parameters below can be taken from input
!      i_disk =NINT(m_Xpar(1082))
!      i_writ_wt=NINT(m_Xpar(1086))
! for now they are fixed here however
      i_disk=3
      i_writ_wt=1

      DO i=1,100
         wtset(i)=0d0
      ENDDO

      DO Iev = 1, NevTot
*! Read an event from disk/tape
*! --> Here should come the actual user routine!
         CALL reader_4v(i_disk,Iflav,pf1,pf2,pf3,pf4,
     @                   phot,nphot,wtkarl,iend) 
         IF(iend.EQ.1) THEN
            WRITE(6,*)'YFSWW3: End of data detected, program stops'
            STOP
         ELSEIF(iend.EQ.0) THEN
! regular event
*! Calculate a correction weight for a stored event
            Wt_NL = YFSWW_WtNL(Iflav,pf1,pf2,pf3,pf4,Phot,Nphot)
            IF(iev.LE.3) THEN
               CALL dumpd(6)
            ENDIF
*! Save the weight Wt_NL
            CALL writer_wt(i_writ_wt,wtset,Wt_NL) 
         ELSEIF(iend.EQ.-1) THEN
! rejected event, skipping
            Wt_NL=0d0
         ENDIF
      ENDDO

      END	
