      SUBROUTINE karlud(mode,par1,par2,par3)
*     **************************************
* low level  monte-carlo generator
* administrates directly generation of v-variable
* and indirectly of all other variables.
*     **************************************
      IMPLICIT DOUBLE PRECISION (a-h,o-z)
      PARAMETER (nmax= 40)
      COMMON / matpar / pi,ceuler
      COMMON / phypar / alfinv,gpicob
      COMMON / weking / ene,amaz,gammz,amel,amfin,xk0,sinw2,ide,idf
      COMMON / wekin2 / amaw,gammw,gmu,alphaw
! user mask on final states
      COMMON /cumask/ user_umask(202)
* this COMMON can be everywhere, contains various switches
      COMMON / keykey/  keyrad,keyphy,keytek,keymis,keydwm,keydwp
* one more common with various switches (ONLY in karludw.f)
      COMMON / keykar/  i_yfs,i_file,i_disk,i_writ_wt,i_writ_4v
      COMMON / inout  / ninp,nout
      COMMON / bxfmts / bxope,bxclo,bxtxt,bxl1i,bxl1f,bxl2f,bxl1g,bxl2g
      CHARACTER*80      bxope,bxclo,bxtxt,bxl1i,bxl1f,bxl2f,bxl1g,bxl2g

      COMMON / momset / qeff1(4),qeff2(4),sphum(4),sphot(100,4),nphot
      COMMON / momdec / q1(4),q2(4),p1(4),p2(4),p3(4),p4(4)
      COMMON / cms_eff_momdec /
     $      effbeam1(4),effbeam2(4),effp1(4),effp2(4),effp3(4),effp4(4)
      COMMON / wgtgen / wtves,wtyfs,wtborn
      COMMON / wgtall / wtcrud,wtmod,wtset(100)

! this common breaks modularity. Should be removed somehow.
* communicates with vesko/rhosko
      COMMON / vvrec  / vvmin,vvmax,vv,beti

      EXTERNAL rhosko
      DIMENSION drvec(1)

      DIMENSION effq1(4),effq2(4)

      dimension effq1n(4),effq2n(4),effp1n(4),effp2n(4)
      dimension effp3n(4),effp4n(4),qqq(4)
      dimension qeff1n(4),qeff2n(4),spdum(100,4)
      dimension q1dum(4),q2dum(4),p1dum(4),p2dum(4),p3dum(4),p4dum(4)
      DIMENSION ipdg(4)

      SAVE

*     ==================================================================
*     ===================initialization=================================
*     ==================================================================
      IF(mode .EQ. -1) THEN
*     ==================================================================
      KeyMas = MOD(KeyPhy,100)/10
      Key4f  = MOD(KeyMis,100)/10
      IF(  KeyMas .EQ. 0 ) THEN
        ambeam=0d0
      ELSE
        ambeam=amel
      ENDIF

      svar = 4d0*ene**2
* this is "pointer" for internal monitoring histograms/averages
      idyfs = 0


* 4f m-type phase space debugg mode, 
* i_disk =0 
*   normal generation mode
* i_disk =1 
*   READs 4vects and ikan from the disk,
*   events then goes through jacobian calculations
*   requires keyisr=0 and keysmp=2 or 3
* i_disk =2
*   READs 4vects from the disk and calculates only the matrix el. 
*   works also for isr. 
* i_disk =3
*   READs 4vects ant WtCrud from the disk, and calculates matrix el. 
*   constructs event.
! shifted to data cards 10/10/00 ms      i_disk=0

* m probability in m/z mixing of 4f phase space generators
      prob_ps_m=0.5d0

!-- yfs internal tests, activated with i_yfs=1
! shifted to data cards 10/10/00 ms      i_yfs=0

*-- initialize decays
! what should emin be ??????? some additional cut-off ?????
      emin=1d0
      emax=2*ene
! i_file=1 requests xsection data from the file 
!          (50-250GeV for now, flat elsewhere)
! i_file=0 requests xsection data from analytic function
! shifted to data cards 10/10/00 ms      i_file=1
      KeyWgt = MOD(KeyTek,10)
      KeySmp = MOD(KeyTek,1000)/100 
      CALL decay_prob_init(emin,emax,user_umask,i_file,KeyWgt,keysmp)
*-- initialize decays end

! is beti needed by / vvrec / ????
      beti = 2d0/alfinv/pi*(dlog(4d0*ene**2/amel**2)-1d0)

*-- initialization of qed part
      keyisr = MOD(keyrad,10)
*-- calculation of crude normalization
      IF( keyisr .NE. 0)THEN
         CALL vesk1w(-1,rhosko,dum1,dum2,xcvesk)
         CALL gifyfs(svar,amel,fyfs)
         xcrude = xcvesk*fyfs

*-- initialize internal tests of yfs
         IF(i_yfs. EQ. 1) 
     @     CALL yfs_tests(-1,amel,ene,idyfs,wtves,xcvesk,wt1,wt2,wt3)
      ELSE
! note, for no ISR xcrude is completely dummy, it will be divided out
! later on. can be set to 1 as well...
         sprim=svar
         xcrude=get_total_crude(sprim)
         fyfs=1d0
         xcvesk=0d0
      ENDIF
*-- outputs
      par1=xcrude
      par2=xcvesk
      par3=xcrude
      keysmp = MOD(keytek,1000)/100

* ==================================================================
* ====================generation====================================
* ==================================================================
      ELSEIF( mode  .EQ.  0) THEN
* ==================================================================

! check if not end of run
      CALL check_EndOfRun(ieor)
      IF(ieor.EQ.1) THEN
         WRITE(6,*)'KARLUD: end of run requested'
         RETURN
      ENDIF

      CALL cleanup

!*************************
      IF(i_disk.GE.2) THEN
!*************************
! read the event from the disk
         CALL check_EndOfRun(ieor)
         IF(ieor.NE.1) THEN
            CALL reader_4v(i_disk,ipdg,p1,p2,p3,p4,sphot,nphot,wtkarl
     $           ,iend)
         ELSE
            iend=1
         ENDIF
         IF(iend.EQ.-1) THEN
! -1 =zero weight event, skip
! setup the label anyway (for bookkeeping only)
            CALL pdg_to_linear_label(label,ipdg)
*-- store label for future use from_phot_spec_book ! temporary !!
            CALL store_label(0,label)
            fak_phsp=0d0
            fak=0d0
            wtkarl=0d0
            wtborn=0d0
            xcborn=0d0
! fill in COMMONs via decay routine
            rndm=0d0
            CALL decay(i_disk,sprim,rndm,label)
            GOTO 150 
         ELSEIF(iend.EQ.1) THEN
! +1 =end of file
            WRITE(6,*) 'Reader_4v=> End of file reached, KORALW stops'
            CALL set_EndOfRun
            RETURN
cc            STOP
         ENDIF

         DO i=1,4
            q1(i)=p1(i)+p2(i)
            q2(i)=p3(i)+p4(i)
         ENDDO

         DO i=1,4
            sphum(i)=0d0
         ENDDO
         DO iph=1,nphot
            DO i=1,4
               sphum(i)=sphum(i)+sphot(iph,i)
            ENDDO
         ENDDO
          
         sprim = qadra(q1,q2)

c! setup the label
         CALL pdg_to_linear_label(label,ipdg)
c! bug for non diagonal 4/12/00
c         IF(label.EQ.105 .OR. label.EQ.115 .OR. label.EQ.127 .OR. 
c     $      label.EQ.129) THEN  !uuss ddcc uubb ccbb 
c            IF( (Key4f.EQ.1 .AND. ipdg(1).EQ.-ipdg(4)) .OR. 
c     #          (Key4f.EQ.0 .AND. ipdg(1).NE.-ipdg(4)) ) THEN
c               DO ii=1,4
c                  p2dum(ii)=p2(ii)
c                  p2(ii)=p4(ii)
c                  p4(ii)=p2dum(ii)
c               ENDDO
c            ENDIF
c         ENDIF
c! end bug 4/12/00

         rndm=0d0
         CALL decay(i_disk,sprim,rndm,label)
*-- store label for future use from_phot_spec_book ! temporary !!
         CALL store_label(0,label)

* transform everything  to cms'' (effective)
      CALL from_cms_eff(-1,keyisr,svar,sprim,ambeam,sphum,
     $      sphot,nphot,q1,q2,p1,p2,p3,p4,
     $      effbeam1,effbeam2,effq1,effq2,effp1,effp2,effp3,effp4)
* set up also the effective beams in CMS
      CALL from_cms_eff(1,keyisr,svar,sprim,ambeam,sphum,
     $      sphot,nphot,effq1,effq2,effp1,effp2,effp3,effp4,
     $      qeff1,qeff2,q1dum,q2dum,p1dum,p2dum,p3dum,p4dum)

* set various weights to 1
      fak_phsp=1d0
      fak=1d0
ccc      wtkarl=1d0 ! it is red from disk
      wtborn=1d0
      xcborn=1d0

!*****************************
      ELSE
!*****************************

      wtves=1d0
      wtyfs=1d0
* generate vv
      IF( keyisr .NE. 0 ) THEN
         CALL vesk1w( 0,rhosko,dum1,dum2,wtves)
* low-level multiphoton generator
         CALL yfsgen(vv,vvmin,nmax,wt1,wt2,wt3)

*-- internal tests of yfs (should that be before or after next line???)
         IF(i_yfs. EQ. 1) 
     @      CALL yfs_tests(0,amel,ene,idyfs,wtves,xcvesk,wt1,wt2,wt3)
*-- photons under ir cut treated as 0
         IF( vv  .LT.  vvmin) vv=0d0
      ELSE
         vv=0d0
         wt1=1d0
         wt2=1d0
         wt3=1d0
      ENDIF
      wtyfs=wt1*wt2*wt3
      IF( wtyfs  .EQ.  0d0) THEN
         wtkarl=0d0
         wtborn=0d0
         GOTO 150
      ENDIF

      sprim=svar*(1-vv)

*-- generate decay channel
         CALL varran(drvec,1)
         rndm=drvec(1)

      CALL decay(i_disk,sprim,rndm,label)
*-- store label for future use from_phot_spec_book ! temporary !!
      CALL store_label(0,label)

*======================================================
*=========== 4-body phase space begin =================
*======================================================

*-- make a choice of kinematical branch
*-- generate 4f hyper-point
      IF( keysmp .EQ. 2 ) THEN
*-- m branch
         CALL make_phsp_point
     $        (i_disk,label,ambeam,svar,sprim,fak_phsp,
     $          effbeam1,effbeam2,effp1,effp2,effp3,effp4)
      ELSEIF( keysmp .LE. 1 ) THEN
*-- z branch
         CALL make_phsp_point_z
     $      (i_disk,ambeam,svar,sprim,fak_phsp,
     $       effbeam1,effbeam2,effp1,effp2,effp3,effp4)
      ELSEIF( keysmp .EQ. 3 ) THEN
        WRITE(6,*)'karludw=> KeySmp=3 is a test option. Disabled'
        WRITE(6,*)'If you really want to play with it contact authors'
        STOP
*-- mixed branch
         CALL make_phsp_point_mz
     $      (prob_ps_m,i_disk,ambeam,svar,sprim,fak_phsp,i_m,
     $       effbeam1,effbeam2,effp1,effp2,effp3,effp4)
      ELSE
         WRITE(6,*)'karludw=>wrong keysmp=',keysmp
         STOP
      ENDIF

*-- event outside physical phase space?
      IF(fak_phsp .EQ. 0d0)  THEN
         wtkarl=0d0
         wtborn=0d0
         GOTO 150
      ENDIF

! set auxilliary effq-i
      DO i=1,4
        effq1(i)=effp1(i)+effp2(i)
        effq2(i)=effp3(i)+effp4(i)
      ENDDO

* transform everything back to cms (lab)
      CALL from_cms_eff(1,keyisr,svar,sprim,ambeam,sphum,
     $      sphot,nphot,effq1,effq2,effp1,effp2,effp3,effp4,
     $      qeff1,qeff2,q1,q2,p1,p2,p3,p4)

! if one wants to reproduce more precisely the matrix element from 
! 4vectors stored on disk the following tune-up is usefull
! <<<< tune-up >>>>
!! 1/20/01 tune-up made permanent, othervise confusing MS
!! 1/20/01      IF(i_writ_wt.NE.0 .OR. i_writ_4v.NE.0) then
         DO ii=1,4
            q1(ii)=p1(ii)+p2(ii)
            q2(ii)=p3(ii)+p4(ii)
         ENDDO
         sprim = qadra(q1,q2)
         CALL from_cms_eff(-1,keyisr,svar,sprim,ambeam,sphum,
     $        sphot,nphot,q1,q2,p1,p2,p3,p4,
     $        effbeam1,effbeam2,effq1,effq2,effp1,effp2,effp3,effp4)
!! 1/20/01      ENDIF
! end tune-up

*... place selecto on some phase space regions to zero them
      fak_sel=1d0
      CALL selecto(p1,p2,p3,p4,qeff1,qeff2,fak_sel)
*... place users cuts on some phase space regions to zero them
      user_fak_sel=1d0
      CALL user_selecto(p1,p2,p3,p4,qeff1,qeff2,user_fak_sel)

      fak_sel=fak_sel*user_fak_sel

*... event outside physical phase space?
      IF(fak_sel .EQ. 0d0)  THEN
         fak=0d0
         wtkarl=0d0
         wtborn=0d0
         GOTO 150
      ENDIF

*-- calculate total jacobian (summed over branches)
      IF( keysmp  .EQ.  2 ) THEN
         CALL get_phsp_weight
     $      (label,ambeam,svar,sprim,fak,
     $       effbeam1,effbeam2,effp1,effp2,effp3,effp4)
      ELSEIF( keysmp  .LE.  1 ) THEN
         CALL get_phsp_weight_z
     $      (svar,sprim,fak,
     $       effbeam1,effbeam2,effp1,effp2,effp3,effp4)
      ELSEIF( keysmp .EQ. 3 ) THEN
         CALL get_phsp_weight_mz
     $      (prob_ps_m,ambeam,svar,sprim,fak,i_m,
     $       effbeam1,effbeam2,effp1,effp2,effp3,effp4)
      ENDIF

      IF(fak .EQ. 0d0)  THEN
         wtkarl=0d0
         wtborn=0d0
         GOTO 150
      ENDIF

*...  statistical factors for identical particles
      CALL selstfac(stat_fac)
      fak=fak*stat_fac

*======================================================
*=========== 4-body phase space END ===================
*======================================================

*------------------------------------------------------
*------------------ END generation --------------------
*------------------------------------------------------

* first come weights from vesko, inverse of the dummy
* born used in photon spectrum and yfs.
c ms      xcborn=1d0/tot_born_crud(svar,sprim)
      xcborn=1d0/get_total_crude(sprim)
      wtkarl=wtves*xcborn*wtyfs

*-- weight for phase space  volume
       wtkarl=wtkarl *fak

!============================
      IF(wtkarl .NE. 0d0)THEN
!============================

! decay channel probability normalisation factor 
         wmp= get_decay_prob(sprim,label)
         IF(wmp .LE. 0d0) THEN
           WRITE(6,*)'karludw=>generated channel with 0 probability',wmp
           STOP
         ELSE
           wtkarl=wtkarl/wmp
         ENDIF

!-- we move born and other weights up to koralw, as they need the 4fermion
!-- matr. el also

!==========
      ENDIF
!==========

      IF(wtkarl .LT. 0d0) THEN
         WRITE(*,*) 'ujemna waga itype=',itype
         WRITE(*,*) wtkarl
         WRITE(*,*) 'aa'
         WRITE(*,*) faki
         WRITE(*,*) 'bb'
         WRITE(*,*) p1
         WRITE(*,*) p2
         WRITE(*,*) p3
         WRITE(*,*) p4
      ENDIF

!*****************************
      ENDIF
!*****************************

 150  CONTINUE

      par1=xcborn
      par2=wtkarl
      par3=0d0

*     ======================
      ELSEIF(mode .EQ. 1) THEN
*     ======================

*-- crude xsection xcvesk and yfs formfactor fyfs
      IF( keyisr .NE. 0 )THEN
         CALL vesk1w( 1,rhosko,xsve,erelve,xcvesk)
         CALL gifyfs(svar,amel,fyfs)
         xcrude=xcvesk*fyfs

*-- internal tests of yfs
         IF(i_yfs. EQ. 1) 
     @     CALL yfs_tests(1,amel,ene,idyfs,wtves,xcvesk,wt1,wt2,wt3)
      ELSE
c ms         xcrude=tot_born_crud(svar,sprim)
         xcrude=get_total_crude(sprim)
         fyfs=1d0
         xcvesk=0d0
      ENDIF
*-- outputs
      par1=xcrude
      par2=xcvesk
      par3=xcrude

* ============
      ELSE
* ============

*-- internal tests of yfs
      IF( keyisr .NE. 0 ) THEN
        IF(i_yfs.EQ.1) 
     @    CALL yfs_tests(mode,amel,ene,idyfs,wtves,xcvesk,wt1,wt2,wt3)
      ENDIF

*-- born xsection, total!
      IF( keyisr .NE. 0 ) THEN
        CALL vesk1w( 1,rhosko,xsve,erelve,xcvesk)
        CALL gifyfs(svar,amel,fyfs)
        xcrude=xcvesk*fyfs
      ELSE
c ms        xcrude=tot_born_crud(svar,sprim)
        xcrude=get_total_crude(sprim)
        fyfs=1d0
        xcvesk=0d0
      ENDIF
      CALL gmonit(1,idyfs+58,averw,errel,parm3)
      xsborn  = xcrude*averw
      erborn  = xsborn*errel
      par1=0d0
      par2=xsborn
      par3=erborn
* ==========
      ENDIF
* ==========
      END


      SUBROUTINE reader_wt(i_read,wtset,wtext) 
!     *********************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
      DIMENSION wtset(100)

      DATA init /1/
      SAVE 

      IF(i_read.EQ.0) RETURN

      IF(init.EQ.1) THEN
! initialize
         OPEN(24,file='wtext.data.in')
         INIT=0
      ENDIF

      IF(i_read.GE.-2 .AND. i_read.LE.2) THEN
         READ(24,'(e26.18)') wtext
      ELSEIF(i_read.LE.-3 .OR. i_read.GE.3) THEN
         DO i=1,9
            READ(24,'(9e26.18)') wtset(i)
         ENDDO
      ENDIF
      END

      SUBROUTINE writer_wt(i_writ,wtset,wtext) 
!     *********************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
      DIMENSION wtset(100)

      DATA init /1/
      SAVE 

      IF(i_writ.EQ.0) RETURN

      IF(init.EQ.1) THEN
! initialize
         OPEN(23,file='wtext.data.out')
         INIT=0
      ENDIF

      IF(i_writ.GE.-2 .AND. i_writ.LE.2) THEN
         WRITE(23,'(e26.18)') wtext
      ELSEIF(i_writ.LE.-3 .OR. i_writ.GE.3) THEN
         DO i=1,9
            WRITE(23,'(9e26.18)') wtset(i)
c            WRITE(6,*) 'writer_wt',wtset(i)
         ENDDO
      ENDIF
      call flush(23)
      END

      SUBROUTINE reader_4v(i_read,ip,p1,p2,p3,p4,
     @                   sphot,nphot,wtkarl,iend) 
!     *********************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
      DIMENSION dbp1(4),dbp2(4),dbp3(4),dbp4(4)
      DIMENSION ipdg(4), sphot(100,4), photo(4)
      DIMENSION p1(4),p2(4),p3(4),p4(4)
      DIMENSION ip(4)

      CHARACTER char1

      DATA init /1/
      SAVE 

      IF(i_read.EQ.0) RETURN

      IF(init.EQ.1) THEN
! initialize
         OPEN(22,file='4vect.data.in')
         INIT=0
      ENDIF

! read one point

      iend=0
      wtkarl=1d0
      IF(i_read.EQ.3) THEN
         READ(22,*,end=12) char1
         IF(char1.EQ.'E') THEN
! end of run requested
            GOTO 12
         ENDIF
      ELSEIF(i_read.EQ.4) THEN
         READ(22,*,end=12) char1
         IF(char1.EQ.'E') THEN
! end of run requested
            GOTO 12
         ELSEIF(char1.EQ.'R') THEN
! rejected event
! read pdg specification anyway (for bookkeeping only)
            READ(22,*,end=12) ip
      
            DO j=1,4
               p1(j) =0d0
               p2(j) =0d0
               p3(j) =0d0
               p4(j) =0d0
            ENDDO
            nphot=0
            iend=-1
            wtkarl=0d0
            RETURN
         ENDIF
      ENDIF
      
      READ(22,*,end=12) ipdg
      
      READ(22,'(4e26.18)') dbp1 
      READ(22,'(4e26.18)') dbp2 
      READ(22,'(4e26.18)') dbp3 
      READ(22,'(4e26.18)') dbp4 
      
      READ(22,*) nphot
      
      DO i=1,nphot
         READ(22,'(4e26.18)') photo 
         DO j=1,4
            sphot(i,j) =photo(j)
         ENDDO
      ENDDO
      IF(i_read.EQ.4) THEN
         READ(22,'(4e26.18)') wtkarl
      ENDIF
      
! ensure the KW convention for mix doubly ckm suppr. states 
      CALL KWswapper(ipdg,dbp1,dbp2,dbp3,dbp4,
     @                   ip,p1,p2,p3,p4) 

      RETURN
      
! end of file detected
 12   CONTINUE
      iend=1

      END

      SUBROUTINE KWswapper(ipdg,p1,p2,p3,p4,
     @                   ip,dbp1,dbp2,dbp3,dbp4) 
!     *********************************************
! this routine reverses form WW convention of mix ckm suppr to ZZ conv.
! i.e.  suus -> uuss
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
      DIMENSION dbp1(4),dbp2(4),dbp3(4),dbp4(4)
      DIMENSION ip(4)
      DIMENSION p1(4),p2(4),p3(4),p4(4)
      DIMENSION ipdg(4)

      IF(ipdg(1).EQ.-ipdg(4) .AND. ipdg(2).EQ.-ipdg(3)) THEN
         IF( ipdg(1).EQ.3 .AND. ipdg(3).EQ.2   .OR.
     @       ipdg(1).EQ.5 .AND. ipdg(3).EQ.2   .OR.
     @       ipdg(1).EQ.5 .AND. ipdg(3).EQ.4 ) THEN
! swap W-W+ into ZZ
            ip(1)=ipdg(3)
            ip(2)=ipdg(2)
            ip(3)=ipdg(1)
            ip(4)=ipdg(4)
            DO i=1,4
               dbp1(i)=p3(i)
               dbp2(i)=p2(i)
               dbp3(i)=p1(i)
               dbp4(i)=p4(i)
            ENDDO
         ELSEIF( ipdg(1).EQ.1 .AND. ipdg(3).EQ.4 ) THEN
            ip(1)=ipdg(1)
            ip(2)=ipdg(4)
            ip(3)=ipdg(3)
            ip(4)=ipdg(2)
            DO i=1,4
               dbp1(i)=p1(i)
               dbp2(i)=p4(i)
               dbp3(i)=p3(i)
               dbp4(i)=p2(i)
            ENDDO
         ELSE
! no swap
            DO i=1,4
               ip(i)=ipdg(i)
               dbp1(i)=p1(i)
               dbp2(i)=p2(i)
               dbp3(i)=p3(i)
               dbp4(i)=p4(i)
            ENDDO
         ENDIF
      ELSE
! no swap
         DO i=1,4
            ip(i)=ipdg(i)
            dbp1(i)=p1(i)
            dbp2(i)=p2(i)
            dbp3(i)=p3(i)
            dbp4(i)=p4(i)
         ENDDO
      ENDIF   
  
      END

      SUBROUTINE writer_4v(ipdg,dbp1,dbp2,dbp3,dbp4,
     @                   sphot,nphot,wtcrud,i_writ_4v,i_end) 
!     *********************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
      DIMENSION dbp1(4),dbp2(4),dbp3(4),dbp4(4)
      DIMENSION ipdg(4), sphot(100,4), photo(4)

      DATA init /1/
      SAVE 

      IF(i_writ_4v.EQ.0) RETURN

      IF(i_end.EQ.1)THEN
         IF(i_writ_4v.GE.3) THEN
            WRITE(21,*) 'E'
         ENDIF
         CLOSE(21)
         RETURN
      ENDIF
         
      IF(init.EQ.1) THEN
! initialize
         OPEN(21,file='4vect.data.out')
         INIT=0
      ENDIF
! write one point
      IF(wtcrud.EQ.0d0) THEN
         IF(i_writ_4v.EQ.4) THEN
            WRITE(21,*) 'R'
! write pdg specification anyway (for bookkeeping only)
            WRITE(21,*) ipdg
            call flush(21)
         ENDIF
         RETURN
      ELSE
         IF(i_writ_4v.GE.3) THEN
            WRITE(21,*) 'A'
         ENDIF
         WRITE(21,*) ipdg
         
         WRITE(21,'(4e26.18)') dbp1 
         WRITE(21,'(4e26.18)') dbp2 
         WRITE(21,'(4e26.18)') dbp3 
         WRITE(21,'(4e26.18)') dbp4 
         
         WRITE(21,*) nphot
         
         DO i=1,nphot
            DO j=1,4
               photo(j)=sphot(i,j)
            ENDDO
            WRITE(21,'(4e26.18)') photo 
         ENDDO
         IF(i_writ_4v.EQ.4) THEN
            WRITE(21,'(4e26.18)') wtcrud
         ENDIF
      ENDIF
c      WRITE(6,*)'writer_4v', wtcrud
      call flush(21)
      END

      SUBROUTINE from_cms_eff(mode,keyisr,svar,sprim,ambeam,
     $      sphum,sphot,nphot, bq1,bq2,bp1,bp2,bp3,bp4,
     $      qeff1,qeff2,q1,q2,p1,p2,p3,p4)
*     **********************************************************
* this routine transforms 4momenta between cms (lab) and
*      effective cms (p_final)
*
* mode =  1   from cms_eff to cms
* mode = -1   from cms to cms_eff
* bq1,bq2,bp1,bp2,bp3,bp4   arbitrary 4momenta to be transformed
*
* output
*  q1, q2, p1, p2, p3, p4   transformed 4momenta
*  qeff1,qeff2              effective beams in cms (mode=1)
*                                           in cms_eff (mode=-1)
*
* written by: m. skrzypek              date: 7/6/96
*
      IMPLICIT DOUBLE PRECISION (a-h,o-z)
      DIMENSION qeff1(4),qeff2(4),sphum(4),sphot(100,4)
      DIMENSION bq1(4),bq2(4),bp1(4),bp2(4),bp3(4),bp4(4)
      DIMENSION q1(4),q2(4),p1(4),p2(4),p3(4),p4(4)
      DIMENSION qsu(4),ef1(4),ef2(4),photd(4),sphotd(100,4)
      DIMENSION def1(4),def2(4)
      DIMENSION dott(8),qlab1(4),qlab2(4),ql(4),pl(4),paux(4)

      IF(mode.EQ.-1 .AND. keyisr.EQ.3) THEN
        WRITE(6,*)'from_cms_eff=>'
        WRITE(6,*)' Mode=-1 not implemented yet for keyisr=3' 
        STOP
      ENDIF

* to activate dumps kindmp=1
      kindmp=0

      DO 124, i=1,4
      q1(i)=bq1(i)
      q2(i)=bq2(i)
      p1(i)=bp1(i)
      p2(i)=bp2(i)
      p3(i)=bp3(i)
 124  p4(i)=bp4(i)


      IF(nphot .EQ. 0) THEN
*     ===================

* define effective beams (massive) in cms''

        qeff1(4)= sqrt(svar)/2d0
        qeff1(3)= dsqrt(svar/4d0-ambeam**2)
        qeff1(2)= 0d0
        qeff1(1)= 0d0
        qeff2(4)= sqrt(svar)/2d0
        qeff2(3)=-dsqrt(svar/4d0-ambeam**2)
        qeff2(2)= 0d0
        qeff2(1)= 0d0

      ELSEIF(nphot .GE. 1) THEN
*     =======================

* effective beams (in lab)
        ef1(4)= sqrt(svar)/2d0
        ef1(3)= dsqrt(svar/4d0-ambeam**2)
        ef1(2)= 0d0
        ef1(1)= 0d0
        ef2(4)= sqrt(svar)/2d0
        ef2(3)=-dsqrt(svar/4d0-ambeam**2)
        ef2(2)= 0d0
        ef2(1)= 0d0
        DO 11 ii=1,nphot
        IF(sphot(ii,3) .GE. 0d0) THEN
          DO 12 jj=1,4
 12       ef1(jj)= ef1(jj)-sphot(ii,jj)
        ELSE
          DO 13 jj=1,4
 13       ef2(jj)= ef2(jj)-sphot(ii,jj)
        ENDIF
 11     CONTINUE

      IF(kindmp .EQ. 1)THEN
        WRITE(6,*)'__lab0, ef1,ef2'
        CALL dumpl(6,p1,p2,p3,p4,ef1,ef2,sphot,nphot)
      ENDIF

* qsu is 4momentum of decay products (p1-p4) in cms
        DO 110 k=1,4
  110 qsu(k)=-sphum(k)
        qsu(4)=qsu(4)+sqrt(svar)

* transform ef1,2 to rest frame (cms')
* cms' is rotated cms_eff (z+ not along qeff1) !!!
        CALL boostv(1,qsu,ef1,ef1)
        CALL boostv(1,qsu,ef2,ef2)

      IF(kindmp .EQ. 1)THEN
        WRITE(6,*)'__cms ef1,2, phots lab'
        CALL dumpl(6,p1,p2,p3,p4,ef1,ef2,sphot,nphot)
        DO 70 i=1,nphot
        DO 71 j=1,4
 71     photd(j)=sphot(i,j)
*.. photons to cms'
        CALL boostv( 1,qsu,photd,photd)
*.. photons to cms''
        CALL rotatv(1,ef1,photd,photd)
        DO 72 j=1,4
 72     sphotd(i,j)=photd(j)
 70     CONTINUE
        WRITE(6,*)'cms ef1,2 phots cmsbis'
        CALL dumpl(6,p1,p2,p3,p4,ef1,ef2,sphotd,nphot)
* control
        CALL rotatv(-1,ef1,ef2,def2)
        WRITE(6,*)'__control'
        CALL dumpl(6,p1,p2,p3,p4,ef1,def2,sphot,nphot)
        CALL rotatv( 1,ef1,ef2,def2)
        WRITE(6,*)'__control'
        CALL dumpl(6,p1,p2,p3,p4,ef1,def2,sphot,nphot)
      ENDIF

* define effective beams (massive) in cms'' (cms_eff, z+ along qeff1)
        qeff1(4)= sqrt(sprim)/2d0
        qeff1(3)= dsqrt(sprim/4d0-ambeam**2)
        qeff1(2)= 0d0
        qeff1(1)= 0d0
        qeff2(4)= sqrt(sprim)/2d0
        qeff2(3)=-dsqrt(sprim/4d0-ambeam**2)
        qeff2(2)= 0d0
        qeff2(1)= 0d0

        IF(kindmp .EQ. 1)THEN
          WRITE(6,*)'___cmsbis, qeff1,qeff2'
          CALL dumpl(6,p1,p2,p3,p4,qeff1,qeff2,sphotd,nphot)
        ENDIF

*++++++++++++++++++++++++
      IF(mode .EQ. 1) THEN
*       from cms_eff to cms
*++++++++++++++++++++++++

! 9/27/00 adjustment to yfsww, ms
          IF(keyisr.EQ.1) THEN
* rotate from cms'' (z along ef1) to cms' (z along e- beam)
             CALL rotatv(-1,ef1,qeff1,qeff1)
             CALL rotatv(-1,ef1,qeff2,qeff2)
             CALL rotatv(-1,ef1,q1,q1)
             CALL rotatv(-1,ef1,q2,q2)
             CALL rotatv(-1,ef1,p1,p1)
             CALL rotatv(-1,ef1,p2,p2)
             CALL rotatv(-1,ef1,p3,p3)
             CALL rotatv(-1,ef1,p4,p4)
          ELSEIF(keyisr.EQ.3) THEN
! Zbyszek's ansatz on t-channel radiation
! check all dot products 
             dott(1)=dot(qeff1,p1)
             dott(2)=dot(qeff1,p2)
             dott(3)=dot(qeff1,p3)
             dott(4)=dot(qeff1,p4)

             dott(5)=dot(qeff2,p1)
             dott(6)=dot(qeff2,p2)
             dott(7)=dot(qeff2,p3)
             dott(8)=dot(qeff2,p4)
! find smallest
             ddt=dott(1)
             imin=1
             DO i=2,8
                IF(dott(i).LT.ddt) THEN
                   ddt=dott(i)
                   imin=i
                ENDIF
             ENDDO
! boost lab beams to cms_eff
             qlab1(4)= sqrt(svar)/2d0
             qlab1(3)= dsqrt(svar/4d0-ambeam**2)
             qlab1(2)= 0d0
             qlab1(1)= 0d0
             qlab2(4)= sqrt(svar)/2d0
             qlab2(3)=-dsqrt(svar/4d0-ambeam**2)
             qlab2(2)= 0d0
             qlab2(1)= 0d0
             CALL boostv(1,qsu,qlab1,qlab1)
             CALL boostv(1,qsu,qlab2,qlab2)
! rotate to qlab parallel to z-axis             
             IF(imin.LT.5) THEN
                DO i=1,4
                   ql(i)=qlab1(i)
                ENDDO
             ELSE
                   ql(4)=qlab2(4)
                DO i=1,3
                   ql(i)=+qlab2(i) 
                ENDDO
             ENDIF

             CALL rotatv(-1,ql,p1,p1)
             CALL rotatv(-1,ql,p2,p2)
             CALL rotatv(-1,ql,p3,p3)
             CALL rotatv(-1,ql,p4,p4)

             IF(imin.EQ.1 .OR. imin.EQ.5) THEN
                DO i=1,4
                   pl(i)=p1(i)
                ENDDO
             ELSEIF(imin.EQ.2 .OR. imin.EQ.6) THEN
                DO i=1,4
                   pl(i)=p2(i)
                ENDDO
             ELSEIF(imin.EQ.3 .OR. imin.EQ.7) THEN
                DO i=1,4
                   pl(i)=p3(i)
                ENDDO
             ELSEIF(imin.EQ.4 .OR. imin.EQ.8) THEN
                DO i=1,4
                   pl(i)=p4(i)
                ENDDO
             ENDIF
             plmod=dsqrt(pl(1)**2+pl(2)**2+pl(3)**2)
             qlmod=dsqrt(ql(1)**2+ql(2)**2+ql(3)**2)
             qlmod=dsqrt(ql(4)**2-ambeam**2)
! find rotation that will reconstruct the dot prod.
             cthe=(pl(4)*ql(4)-dott(imin))/plmod/qlmod
             sthe=dsqrt(dabs(1-cthe**2))
             cphi=pl(1)/dsqrt(pl(1)**2+pl(2)**2)
             sphi=pl(2)/dsqrt(pl(1)**2+pl(2)**2)
! rotate by cthe
             paux(4)=pl(4)
             paux(3)=plmod*cthe
             paux(2)=plmod*sthe*sphi
             paux(1)=plmod*sthe*cphi

             CALL rotatv(-1,pl,p1,p1)
             CALL rotatv(-1,pl,p2,p2)
             CALL rotatv(-1,pl,p3,p3)
             CALL rotatv(-1,pl,p4,p4)

             CALL rotatv(1,paux,p1,p1)
             CALL rotatv(1,paux,p2,p2)
             CALL rotatv(1,paux,p3,p3)
             CALL rotatv(1,paux,p4,p4)
! and rotate back by ql
             CALL rotatv(1,ql,p1,p1)
             CALL rotatv(1,ql,p2,p2)
             CALL rotatv(1,ql,p3,p3)
             CALL rotatv(1,ql,p4,p4)
          ENDIF

        IF(kindmp .EQ. 1)THEN
          WRITE(6,*)'__cmsprim'
          CALL dumpl(6,p1,p2,p3,p4,qeff1,qeff2,sphot,nphot)
        ENDIF

* transform back to lab
          CALL boostv(-1,qsu,qeff1,qeff1)
          CALL boostv(-1,qsu,qeff2,qeff2)
          CALL boostv(-1,qsu,q1,q1)
          CALL boostv(-1,qsu,q2,q2)
          CALL boostv(-1,qsu,p1,p1)
          CALL boostv(-1,qsu,p2,p2)
          CALL boostv(-1,qsu,p3,p3)
          CALL boostv(-1,qsu,p4,p4)
*.. fine tuning on masses
          qeff1(4)=dsqrt(ambeam**2+qeff1(1)**2+qeff1(2)**2+qeff1(3)**2)
          qeff2(4)=dsqrt(ambeam**2+qeff2(1)**2+qeff2(2)**2+qeff2(3)**2)

        IF(kindmp .EQ. 1)THEN
          WRITE(6,*)'__lab, qeff'
          CALL dumpl(6,p1,p2,p3,p4,qeff1,qeff2,sphot,nphot)
* transform ef1 back to lab
          CALL boostv(-1,qsu,ef1,def1)
          CALL boostv(-1,qsu,ef2,def2)
          WRITE(6,*)'__lab all, ef'
          CALL dumpl(6,p1,p2,p3,p4,def1,def2,sphot,nphot)
        ENDIF
        IF(kindmp .EQ. 1 .AND. keyisr.EQ.3) THEN
! check on dot products
           write(6,*)'---------'
           write(6,*)'pl 1: ',pl
           CALL rotatv(-1,pl,pl,pl)
           write(6,*)'pl 2: ',pl
           CALL rotatv(1,paux,pl,pl)
           write(6,*)'paux 1: ',paux
           CALL rotatv(1,ql,pl,pl)
           write(6,*)'ql 1: ',ql
           write(6,*)'pl 3: ',pl
           write(6,*)'przed boostem   pl.ql ',dot(pl,ql)
           write(6,*)'przed boostem paux.ql ',dot(pl,ql)
           CALL boostv(-1,qsu,pl,pl)
           write(6,*)'pl 4: ',pl
           write(6,*)'qlab1: ',qlab1
           write(6,*)'qlab2: ',qlab2
           write(6,*)'qsu: ',qsu
           qlab1(4)= sqrt(svar)/2d0
           qlab1(3)= dsqrt(svar/4d0-ambeam**2)
           qlab1(2)= 0d0
           qlab1(1)= 0d0
           qlab2(4)= sqrt(svar)/2d0
           qlab2(3)=-dsqrt(svar/4d0-ambeam**2)
           qlab2(2)= 0d0
           qlab2(1)= 0d0
           ddnew1=dot(pl,qlab1)
           ddnew2=dot(pl,qlab2)
           WRITE(6,*)'dot old,new1,new2',dott(imin),ddnew1,ddnew2,imin
           dott(1)=dot(qlab1,p1)
           dott(2)=dot(qlab1,p2)
           dott(3)=dot(qlab1,p3)
           dott(4)=dot(qlab1,p4)
           
           dott(5)=dot(qlab2,p1)
           dott(6)=dot(qlab2,p2)
           dott(7)=dot(qlab2,p3)
           dott(8)=dot(qlab2,p4)
           write(6,*)'dott ',dott
        ENDIF

*++++++++++++++++++++++++
        ELSEIF(mode .EQ. -1) THEN
*       to cms_eff from cms
*++++++++++++++++++++++++
          CALL boostv(1,qsu,q1,q1)
          CALL boostv(1,qsu,q2,q2)
          CALL boostv(1,qsu,p1,p1)
          CALL boostv(1,qsu,p2,p2)
          CALL boostv(1,qsu,p3,p3)
          CALL boostv(1,qsu,p4,p4)
! 9/27/00 adjustment to yfsww, ms
          IF(keyisr.EQ.1) THEN
             CALL rotatv(1,ef1,q1,q1)
             CALL rotatv(1,ef1,q2,q2)
             CALL rotatv(1,ef1,p1,p1)
             CALL rotatv(1,ef1,p2,p2)
             CALL rotatv(1,ef1,p3,p3)
             CALL rotatv(1,ef1,p4,p4)
          ENDIF
*++++++++++++++++++++++++
        ELSE
*++++++++++++++++++++++++
          WRITE(6,*)'from_cms_eff==> wrong mode: ',mode
          STOP
*++++++++++++++++++++++++
        ENDIF
*++++++++++++++++++++++++
      ELSE
*     ====
        WRITE(6,*)'from_cms_eff==> wrong no of phots: ',nphot
        STOP
      ENDIF
*     =====
      END


      SUBROUTINE selecto(p1,p2,p3,p4,p5,p6,wt)
* #################################################
* #        mask on phase space regions            #
* #             NOT TO BE MODIFIED                #
* #      use user_selecto for users cuts          #
* #################################################
      IMPLICIT DOUBLE PRECISION (a-h,o-z)
      COMMON /articut/ arbitr,arbitr1,themin,arbitr2
      COMMON / decays / IFlav(4), amdec(4) 
* this COMMON can be everywhere, contains various switches
      COMMON / keykey/  keyrad,keyphy,keytek,keymis,keydwm,keydwp
      SAVE /articut/,/ decays /,/ keykey/
      SAVE
      DIMENSION p1(4),p2(4),p3(4),p4(4),p5(4),p6(4)

      IF (wt .EQ. 0d0) RETURN
      angarb = SIN(themin)**2

* remove section of e+e-ch+ch- phase space where grace has numerical
* problem for config. with two nearly massless high p_t photons and electrons
* in final state.
!WP: tests ...
c         IF ((iflav(2) .EQ. -11) .OR. (iflav(3) .EQ. 11))THEN
c      IF (qadra(p1,p2)+qadra(p3,p4) .LE. arbitr1) wt=0d0
c         ENDIF
c         IF ((iflav(2) .EQ. -11) .AND. (iflav(3) .EQ. 11))THEN
c      IF (qadra(p1,p4)+qadra(p2,p3) .LE. arbitr1) wt=0d0
c         ENDIF
c      IF (wt .EQ. 0d0) RETURN

         IF ((iflav(2) .EQ. -11) .OR. (iflav(3) .EQ. 11))THEN
      IF (qadra(p1,p2).LE.arbitr1 .OR. qadra(p3,p4).LE.arbitr1) wt=0d0
         ENDIF
         IF ((iflav(2) .EQ. -11) .AND. (iflav(3) .EQ. 11))THEN
      IF (qadra(p1,p4).LE.arbitr1 .OR. qadra(p2,p3).LE.arbitr1) wt=0d0
         ENDIF
      IF (wt .EQ. 0d0) RETURN

!!!!!!!!!!!! additional cut on angle...temporary fixup

      IF(abs(iflav(1)) .NE. 12  .AND.  abs(iflav(1)) .NE. 14
     $  .AND.  abs(iflav(1)) .NE. 16  .AND.
     $ (p1(1)**2+p1(2)**2)/(p1(1)**2+p1(2)**2+p1(3)**2) .LT. angarb )
     $  wt=0d0

      IF(abs(iflav(2)) .NE. 12  .AND.  abs(iflav(2)) .NE. 14
     $  .AND.  abs(iflav(2)) .NE. 16  .AND.
     $ (p2(1)**2+p2(2)**2)/(p2(1)**2+p2(2)**2+p2(3)**2) .LT. angarb )
     $  wt=0d0

      IF(abs(iflav(3)) .NE. 12  .AND.  abs(iflav(3)) .NE. 14
     $  .AND.  abs(iflav(3)) .NE. 16  .AND.
     $ (p3(1)**2+p3(2)**2)/(p3(1)**2+p3(2)**2+p3(3)**2) .LT. angarb )
     $  wt=0d0

      IF(abs(iflav(4)) .NE. 12  .AND.  abs(iflav(4)) .NE. 14
     $  .AND.  abs(iflav(4)) .NE. 16  .AND.
     $ (p4(1)**2+p4(2)**2)/(p4(1)**2+p4(2)**2+p4(3)**2) .LT. angarb )
     $  wt=0d0

      IF (wt .EQ. 0d0) RETURN

!!!!!!!!!!!!!

      pt2=0
      IF(abs(iflav(1)) .NE. 12  .AND.  abs(iflav(1)) .NE. 14
     $  .AND.  abs(iflav(1)) .NE. 16  .AND.
     $ (p1(1)**2+p1(2)**2)/(p1(1)**2+p1(2)**2+p1(3)**2) .GT. angarb )
     $  pt2=pt2+p1(1)**2+p1(2)**2

      IF(abs(iflav(2)) .NE. 12  .AND.  abs(iflav(2)) .NE. 14
     $  .AND.  abs(iflav(2)) .NE. 16  .AND.
     $ (p2(1)**2+p2(2)**2)/(p2(1)**2+p2(2)**2+p2(3)**2) .GT. angarb )
     $  pt2=pt2+p2(1)**2+p2(2)**2

      IF(abs(iflav(3)) .NE. 12  .AND.  abs(iflav(3)) .NE. 14
     $  .AND.  abs(iflav(3)) .NE. 16  .AND.
     $ (p3(1)**2+p3(2)**2)/(p3(1)**2+p3(2)**2+p3(3)**2) .GT. angarb )
     $  pt2=pt2+p3(1)**2+p3(2)**2

      IF(abs(iflav(4)) .NE. 12  .AND.  abs(iflav(4)) .NE. 14
     $  .AND.  abs(iflav(4)) .NE. 16  .AND.
     $ (p4(1)**2+p4(2)**2)/(p4(1)**2+p4(2)**2+p4(3)**2) .GT. angarb )
     $  pt2=pt2+p4(1)**2+p4(2)**2

*!!!!!      IF(pt2 .LE. arbitr) wt=0d0
* set  .LT.  to have a chance to `see' electron neutrinos.
      IF(pt2 .LT. arbitr) wt=0d0

* this is dirty trick to get rid of events with high p_t photons
* which spoil e+e-xx final states.
* begin ==========================
       pt3=0
      IF(abs(iflav(2)) .EQ. 11 .OR. abs(iflav(3)) .EQ. 11) THEN
        pt3=pt3 +(p1(1)+p2(1)+p3(1)+p4(1))**2
        pt3=pt3 +(p1(2)+p2(2)+p3(2)+p4(2))**2
        IF(pt3 .GT. arbitr2) wt=0d0
      ENDIF
* end   =========================
* the following is the cut as used by v. 1.3x . It is practically
* identical to the above one that uses fermion four-momenta 
* instead of effective beams. also its numeric value was glued to the
* fermionic cut.
* begin ==========================
c       pt3=0
c      IF(abs(iflav(2)) .EQ. 11 .OR. abs(iflav(3)) .EQ. 11) THEN
c       pt3=pt3+p5(1)**2+p5(2)**2
c       pt3=pt3+p6(1)**2+p6(2)**2
c       IF(pt3 .GT. arbitr/2) wt=0d0
c      ENDIF
* end   =========================
* this is the END of routine!!
      RETURN


*rubbish kept `in any case'
*
*      IF ((abs(iflav(1)) .EQ. 11) .AND. (abs(iflav(4)) .EQ. 11)) THEN
*      IF (  (    ((p4(3)/p4(4))**2 .GT. 0.96d0)
*     $        .AND. ((p1(3)/p1(4))**2 .GT. 0.96d0) ) .OR.
*     $ ((p4(1)**2+p4(2)**2+p1(1)**2+p1(2)**2) .LE. 49d0)) wt=0d0
*      ENDIF
*!!!      IF (qadra(p1,p2) .LE. 1d0) wt=0d0
*      IF (qadra(p1,p3) .LE. arbitr) wt=0d0
*      IF (qadra(p1,p4) .LE. arbitr) wt=0d0
*      IF (qadra(p1,p5) .LE. arbitr) wt=0d0
*      IF (qadra(p1,p6) .LE. arbitr) wt=0d0
*      IF (qadra(p2,p3) .LE. arbitr) wt=0d0
*      IF (qadra(p2,p4) .LE. arbitr) wt=0d0
*      IF (qadra(p2,p5) .LE. arbitr) wt=0d0
*      IF (qadra(p2,p6) .LE. arbitr) wt=0d0
*      IF (qadra(p3,p4) .LE. arbitr) wt=0d0
*      IF (qadra(p3,p5) .LE. arbitr) wt=0d0
*      IF (qadra(p3,p6) .LE. arbitr) wt=0d0
*      IF (qadra(p4,p5) .LE. arbitr) wt=0d0
*      IF (qadra(p4,p6) .LE. arbitr) wt=0d0
*      IF (qadra(p5,p6) .LE. arbitr) wt=0d0
*       IF (wt .EQ. 0d0) RETURN
*      IF ((p1(1)**2+p1(2)**2) .LE. arbitr) wt=0d0
*      IF ((p2(1)**2+p2(2)**2) .LE. arbitr) wt=0d0
*      IF ((p3(1)**2+p3(2)**2) .LE. arbitr) wt=0d0
*      IF ((p4(1)**2+p4(2)**2) .LE. arbitr) wt=0d0

*       IF (wt .EQ. 0d0) RETURN
*      IF ((p1(1)**2+p1(2)**2)/p1(4)**2 .LE. angarb) wt=0d0
*      IF ((p2(1)**2+p2(2)**2)/p2(4)**2 .LE. angarb) wt=0d0
*      IF ((p3(1)**2+p3(2)**2)/p3(4)**2 .LE. angarb) wt=0d0
*      IF ((p4(1)**2+p4(2)**2)/p4(4)**2 .LE. angarb) wt=0d0
*       WRITE(*,*) p1
*       WRITE(*,*) p2
*       WRITE(*,*) p3
*       WRITE(*,*) p4
*       WRITE(*,*) '---------'
*       WRITE(*,*) p5
*       WRITE(*,*) p6
      END

      SUBROUTINE selstfac(wt)
* ######################################
* introduces statistical factor for identical particles
      IMPLICIT DOUBLE PRECISION (a-h,o-z)

      COMMON / decays / IFlav(4), amdec(4) 

      IF(iflav(1) .EQ. iflav(3)) THEN
        wt=1/4d0
      ELSE
        wt=1d0
      ENDIF

      END

      FUNCTION qadra(p1,p2)
*     ***************************************
      IMPLICIT DOUBLE PRECISION (a-h,o-z)
      DIMENSION p1(4),p2(4),pp(4)
      DO k=1,4
        pp(k)=p1(k)+p2(k)
      ENDDO
      qadra=dmas2(pp)
      END

      SUBROUTINE cleanup
!     ******************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
      COMMON / MOMSET / QEFF1(4),QEFF2(4),SPHUM(4),SPHOT(100,4),NPHOT 
      COMMON / MOMDEC / Q1(4),Q2(4),P1(4),P2(4),P3(4),P4(4)

      DO i=1,4
        DO j=1,nphot
          SPHOT(j,i)=0d0
        ENDDO
        sphum(i)=0d0
        qeff1(i)=0d0
        qeff2(i)=0d0
        q1(i)=0d0
        q2(i)=0d0
        p1(i)=0d0
        p2(i)=0d0
        p3(i)=0d0
        p4(i)=0d0
      ENDDO
      nphot=0

      END

      SUBROUTINE yfs_tests(mode,amel,ene,idyfs,wtves,xcvesk,wt1,wt2,wt3)
!     ******************************************************************
! yfs related tests
! WARNING these tests use random numbers generator. 
! That means they will alter the series.
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
      COMMON / matpar / pi,ceuler
      COMMON / phypar / alfinv,gpicob
 
      COMMON / bxfmts / bxope,bxclo,bxtxt,bxl1i,bxl1f,bxl2f,bxl1g,bxl2g
      CHARACTER*80      bxope,bxclo,bxtxt,bxl1i,bxl1f,bxl2f,bxl1g,bxl2g

* communicates with vesko/rhosko
      COMMON / vvrec  / vvmin,vvmax,vv,beti

      EXTERNAL rhosko

      COMMON / inout  / ninp,nout

      DIMENSION drvec(100)

      SAVE

* ============
      IF(mode .EQ. -1) THEN
* ============

        svar=4*ene**2

        beti = 2d0/alfinv/pi*(dlog(4d0*ene**2/amel**2)-1d0)
        beti2= 2d0/alfinv/pi* dlog(4d0*ene**2/amel**2)
        gamfap =1d0-pi**2*beti**2/12d0
        gamfac =exp(-ceuler*beti)/dpgamm(1d0+beti)
        gamfa2 =exp(-ceuler*beti2)/dpgamm(1d0+beti2)

        prec = 1d-7
        xcgaus =bremkf(1,prec)
        xdel = xcvesk/xcgaus-1
        WRITE(nout,bxtxt) '  vesko initialisation report'
        WRITE(nout,bxtxt) '          mode -1            '
        WRITE(nout,bxl1f) xcvesk,'approx xs_crude  vesko','xcvesk','v1'
        WRITE(nout,bxl1f) xcgaus,'exact  xs_crude  gauss','xcgaus','v2'
        WRITE(nout,bxl1f) xdel   ,'xcvesk/xcgaus-1      ','      ','v3'
        WRITE(nout,bxtxt) 'initialize karlud  END '
        WRITE(nout,bxclo)

*-- initialize control histos for yfsgen
        DO k=50,56
          CALL gmonit(-1,idyfs+k,0d0,1d0,1d0)
        ENDDO

* ============
      ELSEIF(mode .EQ. 0) THEN
* ============

         ref  = vvrho(50,svar,amel,vv,vvmin)
         wtr  = ref/vvrho(1,svar,amel,vv,vvmin)
         CALL varran(drvec,1)
         CALL gmonit(0,idyfs+56,wtr,1d0,drvec(1))
* pseudorejection in order to introduce reference xsection
         IF(drvec(1) .GT. wtr) GOTO 110
         wf1  = wt1*vvrho(51,svar,amel,vv,vvmin)/ref
         wf2  = wt2*vvrho(52,svar,amel,vv,vvmin)/ref
         wf3  = wt3
         wf13 = wf1*wf3
         wf123= wf1*wf2*wf3
         CALL gmonit(0,idyfs+51,wf1,  1d0,1d0)
         CALL gmonit(0,idyfs+52,wf2,  1d0,1d0)
         CALL gmonit(0,idyfs+53,wf3,  1d0,1d0)
         CALL gmonit(0,idyfs+54,wf13, 1d0,1d0)
         CALL gmonit(0,idyfs+55,wf123,1d0,1d0)
 110     CONTINUE
         CALL gmonit(0,idyfs+50,wtves,  1d0,1d0)

* ============
      ELSEIF(mode .EQ. 1) THEN
* ============

         CALL vesk1w( 1,rhosko,xsve,erelve,xcves)
         CALL gmonit(1,idyfs+50,wtnoss,ernoss,dumm3)
         prec   = 1d-7
         xsgs   = bremkf(1,prec)
         ergs   = xsgs*prec
         erve   = xsve*erelve
         ddv    = xsve/xsgs-1d0
         ddr    = erelve + 1d-6
         xdel   = xcves/xsgs-1
         WRITE(nout,bxope)
         WRITE(nout,bxtxt) '            window v           '
         WRITE(nout,bxtxt) '       vesko final report      '
         WRITE(nout,bxtxt) '             mode  1           '
        WRITE(nout,bxl1f)xcves ,   'approx xs_crude vesko','xcvesk','v4'
        WRITE(nout,bxl2f)xsve,erve,'exact  xs_crude vesko','xsve  ','v5'
        WRITE(nout,bxl2f)xsgs,ergs,'exact  xs_crude gauss','xsgs  ','v6'
        WRITE(nout,bxl1f) xdel    ,'xcvesk_appr/xsgs-1   ','      ','v7'
        WRITE(nout,bxl2f)ddv,ddr,  ' xsve_exact/xsgs-1   ','      ','v8'
         WRITE(nout,bxclo)
* ============
      ELSE
* ============

      CALL gmonit(1,idyfs+51,del1,dwt1,parm3)
      del1   = del1-1d0
      CALL gmonit(1,idyfs+52,awf2,dwt2,parm3)
      CALL gmonit(1,idyfs+53,awf3,dwt3,parm3)
      del3   = awf3-gamfa2
      CALL gmonit(1,idyfs+54,awf4,dwt4,parm3)
      del4   = awf4-gamfac
      WRITE(nout,bxope)
      WRITE(nout,bxtxt) '     karlud  final  report     '
      WRITE(nout,bxtxt) '         window b              '
      WRITE(nout,bxl2f) del1,dwt1,  '<wf1>-1  mass wt   ','del1  ','b1'
      WRITE(nout,bxl2f) awf2,dwt2,  '<wf2> dilat. weight','awf2  ','b2'
      WRITE(nout,bxl2f) awf3,dwt3,  '<wf3> dilat. weight','awf3  ','b3'
      WRITE(nout,bxl2f) del3,dwt3,  '<wf3>-ygf(beti2)   ','del3  ','b4'
      WRITE(nout,bxl2f) awf4,dwt4,  '<wf1*wf3>          ','awf4  ','b5'
      WRITE(nout,bxl2f) del4,dwt4,  '<wf1*wf3>-ygf(beti)','del4  ','b6'
      WRITE(nout,bxclo)
*     ==================================================================
      CALL gmonit(1,idyfs+59,wtkarl,erkarl,parm3)
      CALL vesk1w( 1,rhosko,xsve,erelve,xcves)
      xskr=xcves*wtkarl
      CALL gmonit(1,idyfs+55,awf5,dwt5,parm3)
      del5   = awf5-gamfac
      CALL gmonit(1,idyfs+56,awf6,parm2,parm3)
      prec = 1d-6
      xrefer = bremkf(50,prec)
      delkar = xrefer*awf5/xskr  -1d0
      delref = xcves*awf6/xrefer-1d0
      WRITE(nout,bxope)
      WRITE(nout,bxtxt) '     karlud  final  report cont.   '
      WRITE(nout,bxtxt) '         window c                  '
      WRITE(nout,bxtxt) 'beti= 2*alfa/pi*(log(s/mel**2)-1)       '
      WRITE(nout,bxtxt) 'gamfap= 1-pi**2*beti**2/12              '
      WRITE(nout,bxtxt) 'gamfac=exp(-ceuler*beti)/gamma(1+beti)  '
      WRITE(nout,bxtxt) 'gamfa2=exp(-ceuler*beti2)/gamma(1+beti2)'
      WRITE(nout,bxl1f)  beti,        '                =','beti  ','c1'
      WRITE(nout,bxl1f)  gamfap,      '                =','gamfap','c2'
      WRITE(nout,bxl1f)  gamfac,      '                =','gamfac','c3'
      WRITE(nout,bxl1f)  gamfa2,      '                =','gamfa2','c4'
      WRITE(nout,bxl2f) awf5,dwt5, ' <wf1*wf3*wf4>      ','awf5  ','c5'
      WRITE(nout,bxl2f) del5,dwt5, ' <wf1*wf3>-ygf(beti)','del5  ','c6'
      WRITE(nout,bxtxt) 'delkar=xrefer*aver(wf1*wf1*wf3)/xskarl-1'
      WRITE(nout,bxtxt) 'delref=xcrude*aver(wtr)/xrefer-1        '
      WRITE(nout,bxl1f) xrefer,    'reference x_sect.   ','xrefer','c7'
      WRITE(nout,bxl1f) delkar,    'xrefer*awf5/xskr  -1','delkar','c8'
      WRITE(nout,bxl1f) delref,    'xcvesk*awf6/xrefer-1','delref','c9'
      WRITE(nout,bxclo)

* ============
      ENDIF
* ============

      END
