************************************************************************
      subroutine selgrf(ibackgr)
************************************************************************
* Overwrites GRACE initialisation according to KORALW needs
* ibackgr = 0  - doubly resonant W-pairs
* ibackgr = 1  - complete 4fermion process
************************************************************************
      implicit DOUBLE PRECISION(a-h,o-z)
      include 'incl1.f'
      common /grc4fs/ nthprc
*-----------------------------------------------------------------------
*------------------------------------
      if( ibackgr .eq. 0 ) then
*------------------------------------
          do n1 = 1, ngraph
             jselg(n1) = 0
          enddo
* Graph selection : W-pairs
          if( nthprc .eq. 27 ) then
              jselg(15) = 1
              jselg(19) = 1
              jselg(23) = 1
          elseif( nthprc .eq. 62 ) then
              jselg(57) = 1
              jselg(61) = 1
              jselg(77) = 1
          else
              print *,'not yet selgrf',nthprc
              stop
          endif
*------------------------------------
      elseif( ibackgr .eq. 2 ) then
*------------------------------------
! NOTE that graphs 33-36 are higgs + ghosts
          do n1 = 1, ngraph
             jselg(n1) = 0
          enddo
* Graph selection : initial state tata 
* pairs in mumutata final state (12)
          if( nthprc .eq. 12 ) then
          do n1 = 37, 44
             jselg(n1) = 1
          enddo
          endif
*------------------------------------
      elseif( ibackgr .eq. 3 ) then
*------------------------------------
          do n1 = 1, ngraph
             jselg(n1) = 0
          enddo
* Graph selection : final state tata 
* pairs off mumu in mumutata final state (12)
          if( nthprc .eq. 12 ) then
          do n1 = 1, 16
             jselg(n1) = 1
          enddo
          endif
*------------------------------------
      elseif( ibackgr .eq. 4 ) then
*------------------------------------
          do n1 = 1, ngraph
             jselg(n1) = 0
          enddo
* Graph selection : initial state tautau from gamma
*                   + final state tautau from gamma 
          if( nthprc .eq. 12 ) then
! IS
             jselg(37) = 1
             jselg(39) = 1
             jselg(41) = 1
             jselg(42) = 1
! FS
             jselg( 1) = 1
             jselg( 5) = 1
             jselg( 9) = 1
             jselg(13) = 1
          elseif( nthprc .eq. 8 ) then
! this is \mu\mu\e\e channel
! IS
             jselg(39) = 1
             jselg(40) = 1
             jselg(43) = 1
             jselg(45) = 1
! FS
             jselg( 9) = 1
             jselg(11) = 1
             jselg(13) = 1
             jselg(15) = 1
          endif
*------------------------------------
      elseif( ibackgr .eq. 5 ) then
*------------------------------------
          do n1 = 1, ngraph
             jselg(n1) = 0
          enddo
* Graph selection : initial state tautau from gamma  
          if( nthprc .eq. 12 ) then
             jselg(37) = 1
             jselg(39) = 1
             jselg(41) = 1
             jselg(42) = 1
          elseif( nthprc .eq. 8 ) then
! this is \mu\mu\e\e channel
! IS
             jselg(39) = 1
             jselg(40) = 1
             jselg(43) = 1
             jselg(45) = 1
          endif
*------------------------------------
      elseif( ibackgr .eq. 6 ) then
*------------------------------------
          do n1 = 1, ngraph
             jselg(n1) = 0
          enddo
* Graph selection : final state mumu 
* pairs off tata in mumutata final state (12)
          if( nthprc .eq. 12 ) then
          do n1 = 17, 32
             jselg(n1) = 1
          enddo
          endif
*------------------------------------
      else
*------------------------------------
* Graph selection : all graphs
          do 20 n1 = 1, ngraph
             jselg(n1) = 1
   20     continue
      endif
*-----------------------------------------------------------------------
      return
      end

