      FUNCTION culmc(s,s1,s2)
!     **************************
! Coulomb effect from Fadin, Khoze, Martin, Stirling, dtp/95/64
! first order, eq. 9
! * 8.11.99: Added "Screened-Coulomb" ansatz for non-factorizable corr.
!            of A.P. Chapovsky & V.A. Khoze, hep-ph/9902343
! Last corr.  02.11.2000    by: WP
!----------------------------------------------------------------------------

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  

      COMMON / MATPAR / pi,ceuler     
      COMMON / PHYPAR / alfinv,gpicob     
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF 
      COMMON / WEKIN2 / AMAW,GAMMW,GMU,ALPHAW   
! This common can be everywhere, contains various switches
      COMMON / KeyKey/  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp

      KeyCul = MOD(KeyRad,10000)/1000

      if(keycul.eq.0) then
        culmc = 1d0
      elseif(keycul.LE.2) then
        pp = 1/(4*s) *( s**2 -2*s*(s1+s2) +(s1-s2)**2 )
        ppp= 1/(4*s) *((s-s1-s2)**2-4d0*s1*s2)
        if(pp.lt.0.) pp=ppp
        p  = dsqrt(pp)
        en = (s-4*amaw**2)/(4*amaw)
        ddee = dsqrt(en**2+gammw**2)
        p1 = dsqrt( amaw/2d0 *( ddee -en ) )
        p2 = dsqrt( amaw/2d0 *( ddee +en ) )
        dabskap2 = amaw *ddee
        drekap  =  p1
        dimkap  = -p2

        IF(keycul.EQ.1) THEN
           ff = 1 +sqrt(s)/(4*p*alfinv)
     $           *( pi -2*datan( (dabskap2 -pp)/(2*p*drekap) ) )
        ELSE
!WP: "Screend-Coulomb" ansatz for non-factorizable corrections
           beta = 2*p/SQRT(s)
           ScrFac = (1 - beta)**2
           ff = 1 +sqrt(s)/(4*p*alfinv)
     $         *( pi - 2*datan( (dabskap2 -pp)/(2*p*drekap) )*ScrFac )
        ENDIF
        culmc = ff -1  ! <========!!!!!!!!!
        culmc = ff
      else
        write(6,*) ' culMC==> wrong keycul=',keycul
        stop
      endif
      end

